# Triggers para la base de datos elabo

DELIMITER //

#----------------------------------------------------------
# DATOSEXA
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.datosexa_bi;//
CREATE TRIGGER datosexa_bi
BEFORE INSERT ON datosexa
FOR EACH ROW
BEGIN
  SET NEW.status = "E";
  SET NEW.fechares = NOW();
  IF NEW.totalexa IS NULL THEN 
    SET NEW.totalexa = 0.00;
  END IF;
  IF NEW.deducible IS NULL THEN 
    SET NEW.deducible = 0.00;
  END IF;
  IF NEW.totalexacia IS NULL THEN 
    SET NEW.totalexacia = 0.00;
  END IF;
  IF NEW.descuento IS NULL THEN 
    SET NEW.descuento = 0.00;
  END IF;
  IF NEW.descuentocia IS NULL THEN 
    SET NEW.descuentocia = 0.00;
  END IF;
  IF NEW.cargoadi IS NULL THEN 
    SET NEW.cargoadi = 0.00;
  END IF;
  IF NEW.cargoadicia IS NULL THEN 
    SET NEW.cargoadicia = 0.00;
  END IF;
  IF NEW.totalpagar IS NULL THEN 
    SET NEW.totalpagar = 0.00;
  END IF;
  IF NEW.totalpagarcli IS NULL THEN 
    SET NEW.totalpagarcli = 0.00;
  END IF;
  IF NEW.totalpagarcia IS NULL THEN 
    SET NEW.totalpagarcia = 0.00;
  END IF;
  IF NEW.pagado IS NULL THEN 
    SET NEW.pagado = 0.00;
  END IF;
  IF NEW.pagadocli IS NULL THEN 
    SET NEW.pagadocli = 0.00;
  END IF;
  IF NEW.pagadocia IS NULL THEN 
    SET NEW.pagadocia = 0.00;
  END IF;
  IF NEW.saldo IS NULL THEN 
    SET NEW.saldo = 0.00;
  END IF;
  IF NEW.saldocli IS NULL THEN 
    SET NEW.saldocli = 0.00;
  END IF;
  IF NEW.saldocia IS NULL THEN 
    SET NEW.saldocia = 0.00;
  END IF;

  SET NEW.totalpagar = (NEW.totalexa*(1+(NEW.descuento/100))+NEW.cargoadi);
  SET NEW.saldo = NEW.totalpagar - NEW.pagado;

END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.datosexa_ai;//
CREATE TRIGGER datosexa_ai
AFTER INSERT ON datosexa
FOR EACH ROW
BEGIN  
  DECLARE num INTEGER;

  SET num = NEW.numerocli;

  CALL calcule_saldo_paciente(num);

END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.datosexa_bu;//
CREATE TRIGGER datosexa_bu
BEFORE UPDATE ON datosexa
FOR EACH ROW
BEGIN
  SET NEW.fechamod = NOW();
  IF NEW.totalexa IS NULL THEN 
    SET NEW.totalexa = 0.00;
  END IF;
  IF NEW.descuento IS NULL THEN 
    SET NEW.descuento = 0.00;
  END IF;
  IF NEW.cargoadi IS NULL THEN 
    SET NEW.cargoadi = 0.00;
  END IF;
  IF NEW.totalpagar IS NULL THEN 
    SET NEW.totalpagar = 0.00;
  END IF;
  IF NEW.pagado IS NULL THEN 
    SET NEW.pagado = 0.00; 
  END IF;
  IF NEW.saldo IS NULL THEN 
    SET NEW.saldo = 0.00;
  END IF;
  IF NEW.totalpagarcli IS NULL THEN 
    SET NEW.totalpagarcli = 0.00;
  END IF;
  IF NEW.pagadocli IS NULL THEN 
    SET NEW.pagadocli = 0.00; 
  END IF;
  IF NEW.saldocli IS NULL THEN 
    SET NEW.saldocli = 0.00;
  END IF;
  IF NEW.totalpagarcia IS NULL THEN 
    SET NEW.totalpagarcia = 0.00;
  END IF;
  IF NEW.pagadocia IS NULL THEN 
    SET NEW.pagadocia = 0.00; 
  END IF;
  IF NEW.saldocia IS NULL THEN 
    SET NEW.saldocia = 0.00;
  END IF;

#  SET NEW.totalpagar = (round(NEW.totalexa*(1+(NEW.descuento/100)),2)+NEW.cargoadi);
#  SET NEW.saldo = NEW.totalpagar - NEW.pagado;

END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.datosexa_au;//
CREATE TRIGGER datosexa_au
AFTER UPDATE ON datosexa
FOR EACH ROW
BEGIN
  DECLARE numcli INTEGER;
  DECLARE numord INTEGER;

  SET numcli = NEW.numerocli;
  SET numord = NEW.numerex; 

  CALL calcule_saldo_paciente(numcli);

END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.datosexa_ad;//
CREATE TRIGGER datosexa_ad
AFTER DELETE ON datosexa
FOR EACH ROW  
BEGIN
  DECLARE num INTEGER;

  SET num = OLD.numerocli;

  CALL calcule_saldo_paciente(num);

END;//
#----------------------------------------------------------

#----------------------------------------------------------
# DEFAULTS
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.defaults_bi;//
CREATE TRIGGER defaults_bi
BEFORE INSERT ON defaults
FOR EACH ROW
BEGIN
  if (char_length(trim(NEW.resultado)) > 0) then
	SET NEW.status = "M";
  else
	SET NEW.status = 'E';	
  end if;
END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.defaults_bu;//
CREATE TRIGGER defaults_bu
BEFORE UPDATE ON defaults
FOR EACH ROW
BEGIN
  if (char_length(trim(NEW.resultado)) > 0) then
	SET NEW.status = "M";
  else
	SET NEW.status = 'E';	
  end if;
END;//
#----------------------------------------------------------



#----------------------------------------------------------
# DOCTORES
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.doctores_bi;//
CREATE TRIGGER doctores_bi
BEFORE INSERT ON doctores
FOR EACH ROW
BEGIN
  if (NEW.primerape IS NULL) then
	SET NEW.primerape = " ";
  else
  	SET NEW.primerape = UPPER(NEW.primerape);
  end if;
  if (NEW.segundoape is NULL) then
	SET NEW.segundoape = " ";
  else
  	SET NEW.segundoape = UPPER(NEW.segundoape);
  end if;
  if (NEW.nombre IS NULL) then
	SET NEW.nombre = " ";
  else
	SET NEW.nombre = UPPER(NEW.nombre);
  END IF;
  SET NEW.tmpllave = CONCAT(NEW.primerape," ",NEW.segundoape," ",NEW.nombre);
END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.doctores_bu;//
CREATE TRIGGER doctores_bu
BEFORE UPDATE ON doctores
FOR EACH ROW
BEGIN
  if (NEW.primerape IS NULL) then
	SET NEW.primerape = " ";
  else
  	SET NEW.primerape = UPPER(NEW.primerape);
  end if;
  if (NEW.segundoape is NULL) then
	SET NEW.segundoape = " ";
  else
  	SET NEW.segundoape = UPPER(NEW.segundoape);
  end if;
  if (NEW.nombre IS NULL) then
	SET NEW.nombre = " ";
  else
	SET NEW.nombre = UPPER(NEW.nombre);
  END IF;
  SET NEW.tmpllave = CONCAT(NEW.primerape," ",NEW.segundoape," ",NEW.nombre);
END;//
#----------------------------------------------------------


#----------------------------------------------------------
# EXAMENES
#----------------------------------------------------------

#----------------------------------------------------------


DROP TRIGGER IF EXISTS elabo.examenes_bi;//
CREATE TRIGGER examenes_bi
BEFORE INSERT ON examenes
FOR EACH ROW
BEGIN
  DECLARE newc VARCHAR(5);
  DECLARE newn VARCHAR(30);
  DECLARE newp DOUBLE;
  DECLARE pruebatipo char(1);
  DECLARE num INTEGER;
  DECLARE dedu DOUBLE;
  DECLARE conv INTEGER;

  SET NEW.status = "E";
  SET NEW.imprime = 0;
  SET NEW.fechares = NOW();
  SET NEW.fechamod= NOW();	
  SET newc = NEW.codiex;
  SET newn = NEW.nombrexa;
  SET newp = NEW.precio;  
  SET num = NEW.numerex;

  CALL llenarexamen(newc, newn, newp, dedu, conv, pruebatipo);

  SET NEW.nombrexa = newn;
  SET NEW.convenio = conv;
  SET NEW.u = pruebatipo;
  IF pruebatipo = 'M' then
    SET NEW.precio = 0.00;
    SET NEW.deducible = 0.00;
  ELSE
    SET NEW.precio = newp;
    SET NEW.deducible = dedu;
  END IF;

END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.examenes_ai;//
CREATE TRIGGER examenes_ai
AFTER INSERT ON examenes
FOR EACH ROW
BEGIN
  DECLARE num INTEGER;
  DECLARE codi CHAR(4);
  DECLARE exanum INTEGER;
  DECLARE exatipo CHAR(1);

  SET exatipo = NEW.u;
  SET num = NEW.numerex;
  SET codi = NEW.codiex;
  SET exanum = NEW.examenid;


  CALL inserte_impuestos(num, codi, exanum);	
  CALL calcule_total_orden(num);
  CALL inserte_resultados(num, codi, exanum);

END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.examenes_bd;//
CREATE TRIGGER examenes_bd
BEFORE DELETE ON examenes
FOR EACH ROW
BEGIN
  DECLARE num INTEGER;

  SET num = OLD.examenid;

  CALL quite_impuestos(num);

END;//
#----------------------------------------------------------
#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.examenes_ad;//
CREATE TRIGGER examenes_ad
AFTER DELETE ON examenes
FOR EACH ROW
BEGIN
  DECLARE num INTEGER;

  SET num = OLD.numerex;

  CALL calcule_total_orden(num);

END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.examenes_au;//
CREATE TRIGGER examenes_au
AFTER UPDATE ON examenes
FOR EACH ROW
BEGIN
  DECLARE nume INTEGER;

  SET nume = OLD.numerex;

  CALL status_orden(nume);

  IF ((NEW.deducible <> OLD.deducible) or (NEW.precio <> OLD.precio)) then
	CALL calcule_total_orden(nume);
  END IF;
END;//
#----------------------------------------------------------

#----------------------------------------------------------
# METAEXAMENES
#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.metaexas_ai;//
CREATE TRIGGER metaexas_ai
AFTER INSERT ON metaexas
FOR EACH ROW
BEGIN
  DECLARE num CHAR(4);

  SET num = NEW.metacodiex;

  CALL calcule_total_meta(num);
 	
END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.metaexas_au;//
CREATE TRIGGER metaexas_au
AFTER UPDATE ON metaexas
FOR EACH ROW
BEGIN
  DECLARE num CHAR(4);

  SET num = NEW.metacodiex;

  CALL calcule_total_meta(num);

END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.metaexas_ad;//
CREATE TRIGGER metaexas_ad
AFTER DELETE ON metaexas
FOR EACH ROW
BEGIN
  DECLARE num CHAR(4);

  SET num = OLD.metacodiex;

  CALL calcule_total_meta(num);

END;//
#----------------------------------------------------------

#----------------------------------------------------------
# PACIENTES

DROP TRIGGER IF EXISTS elabo.pacientes_bi;//
CREATE TRIGGER pacientes_bi
BEFORE INSERT ON pacientes
FOR EACH ROW
BEGIN
  SET NEW.primerape = TRIM(UPPER(NEW.primerape));
  SET NEW.segundoape = TRIM(UPPER(NEW.segundoape));
  SET NEW.nombre = TRIM(UPPER(NEW.nombre));
  if (NEW.segundoape IS NULL) then
 	 SET NEW.tmpllave = CONCAT(NEW.primerape," ",NEW.nombre);
  else 
  	SET NEW.tmpllave = CONCAT(NEW.primerape," ",NEW.segundoape," ",NEW.nombre);
  end if;
  SET NEW.fechares = NOW();
  SET NEW.modidate = NOW();

  SET NEW.edad= datediff(now(),NEW.nacio)/365.242199; 

END;//

DROP TRIGGER IF EXISTS elabo.pacientes_bu;//
CREATE TRIGGER pacientes_bu
BEFORE UPDATE ON pacientes
FOR EACH ROW
BEGIN
  SET NEW.primerape = UPPER(NEW.primerape);
  SET NEW.segundoape = UPPER(NEW.segundoape);
  SET NEW.nombre = UPPER(NEW.nombre);
  if (NEW.segundoape IS NULL) then
 	 SET NEW.tmpllave = CONCAT(NEW.primerape," ",NEW.nombre);
  else 	
  	SET NEW.tmpllave = CONCAT(NEW.primerape," ",NEW.segundoape," ",NEW.nombre);
  end if; 
  SET NEW.modidate = NOW();

  SET NEW.edad= datediff(now(),NEW.nacio)/365.242199; 

END;//
  
#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.pagos_bi;//
#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.pagos_ai;//
#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.pagos_bd;//
#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.pagos_ad;//

#----------------------------------------------------------
# PRESUPUESTOHEAD
#----------------------------------------------------------

#----------------------------------------------------------


DROP TRIGGER IF EXISTS elabo.presupuestohead_bd;//
CREATE TRIGGER presupuestohead_bd
BEFORE DELETE ON presupuestohead
FOR EACH ROW
BEGIN
  DECLARE num INTEGER;
  SET num = OLD.presupuestoid;

  CALL borre_presupuestos(num);

END;//

#----------------------------------------------------------
# PRESUPUESTOS
#----------------------------------------------------------

#----------------------------------------------------------


DROP TRIGGER IF EXISTS elabo.presupuestos_bi;//
CREATE TRIGGER presupuestos_bi
BEFORE INSERT ON presupuestos
FOR EACH ROW
BEGIN
  DECLARE newc VARCHAR(5);
  DECLARE newn VARCHAR(30);
  DECLARE newp DOUBLE;
  DECLARE pruebatipo char(1);
  DECLARE num INTEGER;

  SET NEW.status = "E";
  SET NEW.fechares = NOW();
  SET NEW.fechamod= NOW();	
  SET newc = NEW.codiex;
  SET newn = NEW.nombrexa;
  SET newp = NEW.precio;  
  SET num = NEW.numerex;
  SET pruebatipo = NEW.u;

  CALL llenarpresupuesto(newc, newn, newp, pruebatipo);

  SET NEW.nombrexa = newn;
  SET NEW.u = pruebatipo;
  SET NEW.precio = newp;

END;//
#----------------------------------------------------------


#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.resultados_bi;//
CREATE TRIGGER resultados_bi
BEFORE INSERT ON resultados
FOR EACH ROW
BEGIN
  IF (NEW.tiporesult = 'C' or NEW.tiporesult = 'N' or NEW.tiporesult = 'F') THEN
    SET NEW.status = 'E';
  ELSE 
    SET NEW.status ='F';
  END IF;
END;// 
#----------------------------------------------------------


#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.resultados_bu;//
CREATE TRIGGER resultados_bu
BEFORE UPDATE ON resultados
FOR EACH ROW
BEGIN
  DECLARE numresult DOUBLE;

  IF (NEW.tiporesult = 'C' or NEW.tiporesult = 'N') THEN
    IF (NEW.resultado IS NULL or length(trim(NEW.resultado))= 0) THEN
      SET NEW.status = 'E';
    ELSE 
      SET NEW.status = 'F';
    END IF;
  ELSE 
    SET NEW.status = 'F';
  END IF;
  IF (NEW.resultado <> OLD.resultado) THEN
  	SET NEW.fechamod = NOW();
  END IF;
  SET NEW.bandera = '  ';

  IF (NEW.resultado REGEXP '^[^a-zA-Z]') THEN
    SET numresult = CONVERT(NEW.resultado,DECIMAL(13,3));
    if numresult < NEW.minimo then 
      SET NEW.bandera = "-";
    end if;
    if numresult > NEW.maximo then 
      SET NEW.bandera = "+";
    end if;
	
    if numresult < NEW.panicminimo then 
      SET NEW.bandera = "--";
    end if;
    If numresult > NEW.panicmaximo then 
      SET NEW.bandera = "++";
    end if;

    if numresult < NEW.imposiblemin then 
      SET NEW.bandera = "E-";
    end if;

    if numresult > NEW.imposiblemax then 
      SET NEW.bandera = "E+";
    end if;

  end if;

  if (NEW.tiporesult = 'C' or NEW.tiporesult = 'Y' or NEW.tiporesult = 'O') then

	if (NEW.resultado = "=al") then
		SET NEW.resultado = "Abundates";
 	end if;
	if (NEW.resultado = "=au") then
		SET NEW.resultado = "ABUNDANTES";
 	end if;
	if (NEW.resultado = "=acl") then
		SET NEW.resultado = "Amarillo claro";
 	end if;
	if (NEW.resultado = "=acu") then
		SET NEW.resultado = "AMARILLO CLARO";
 	end if;
	if (NEW.resultado = "=eal") then
		SET NEW.resultado = "Escasas";
 	end if;
	if (NEW.resultado = "=eau") then
		SET NEW.resultado = "ESCASAS";
 	end if;
	if (NEW.resultado = "=eol") then
		SET NEW.resultado = "Escasos";
 	end if;
	if (NEW.resultado = "=eou") then
		SET NEW.resultado = "ESCASOS";
 	end if;
	if (NEW.resultado = "=mal") then
		SET NEW.resultado = "Muchas";
 	end if;
	if (NEW.resultado = "=mau") then
		SET NEW.resultado = "MUCHAS";
 	end if;
	if (NEW.resultado = "=mol") then
		SET NEW.resultado = "Muchos";
 	end if;
	if (NEW.resultado = "=mou") then
		SET NEW.resultado = "MUCHOS";
 	end if;
	if (NEW.resultado = "=mcl") then
		SET NEW.resultado = "Moderada cantidad";
 	end if;
	if (NEW.resultado = "=mcu") then
		SET NEW.resultado = "MODERADA CANTIDAD";
 	end if;

	if (NEW.resultado = "=msl") then
		SET NEW.resultado = "Moderadamente sensible";
 	end if;
	if (NEW.resultado = "=msu") then
		SET NEW.resultado = "MODERADAMENTE SENSIBLE";
 	end if;
	if (NEW.resultado = "=nol") then
		SET NEW.resultado = "No se observa";
 	end if;
	if (NEW.resultado = "=nou") then
		SET NEW.resultado = "NO SE OBSERVA";
 	end if;
	if (NEW.resultado = "=nel") then
		SET NEW.resultado = "No se encontro";
 	end if;
	if (NEW.resultado = "=neu") then
		SET NEW.resultado = "NO SE ENCONTRO";
 	end if;

	if (NEW.resultado = "=nrl") then
		SET NEW.resultado = "No reactivo";
 	end if;
	if (NEW.resultado = "=nru") then
		SET NEW.resultado = "NO REACTIVO";
 	end if;
	if (NEW.resultado = "=nhl") then
		SET NEW.resultado = "No hay";
 	end if;
	if (NEW.resultado = "=nhu") then
		SET NEW.resultado = "NO HAY";
 	end if;
	if (NEW.resultado = "=nl") then
		SET NEW.resultado = "Negativo";
 	end if;
	if (NEW.resultado = "=nu") then
		SET NEW.resultado = "NEGATIVO";
 	end if;
	if (NEW.resultado = "=pl") then
		SET NEW.resultado = "Positivo";
 	end if;
	if (NEW.resultado = "=pu") then
		SET NEW.resultado = "POSITIVO";
 	end if;
	if (NEW.resultado = "=pol") then
		SET NEW.resultado = "Pocas";
 	end if;
	if (NEW.resultado = "=pou") then
		SET NEW.resultado = "POSITIVO";
 	end if;
	if (NEW.resultado = "=rl") then
		SET NEW.resultado = "Resistente";
 	end if;
	if (NEW.resultado = "=ru") then
		SET NEW.resultado = "RESISTENTE";
 	end if;
	if (NEW.resultado = "=sl") then
		SET NEW.resultado = "Sensible";
 	end if;
	if (NEW.resultado = "=su") then
		SET NEW.resultado = "SENSIBLE";
 	end if;
	if (NEW.resultado = "=sul") then
		SET NEW.resultado = "Suceptible";
 	end if;
	if (NEW.resultado = "=suu") then
		SET NEW.resultado = "SUCEPTIBLE";
 	end if;

  end if;

END;//
#----------------------------------------------------------

#----------------------------------------------------------
DROP TRIGGER IF EXISTS elabo.resultados_au;//
CREATE TRIGGER resultados_au
AFTER UPDATE ON resultados
FOR EACH ROW
BEGIN
  DECLARE num INTEGER;

  SET num =  NEW.examenid;

  if (NEW.tiporesult <> 'F') then
    if (NEW.tiporesult <> 'U') then
      CALL update_status(num);
    end if;
  end if;


END;//
#----------------------------------------------------------

