/*
MySQL Data Transfer
Source Host: localhost
Source Database: elabo
Target Host: localhost
Target Database: elabo
Date: 25/02/2007 10:33:38 a.m.
*/

SET FOREIGN_KEY_CHECKS=0;
-- ----------------------------
-- Table structure for caja
-- ----------------------------
CREATE TABLE `caja` (
  `PAGONUM` int(9) unsigned NOT NULL auto_increment,
  `NUMEREX` int(9) unsigned NOT NULL,
  `FECHA` datetime default NULL,
  `TIPOPAGO` int(9) unsigned default NULL,
  `TIPOTARJETA` int(9) unsigned default NULL,
  `EMISOR` varchar(10) collate latin1_general_ci default NULL,
  `NUMERO` varchar(20) collate latin1_general_ci default NULL,
  `MONTO` double(15,2) default '0.00',
  `USUARIO` varchar(15) collate latin1_general_ci default NULL,
  `TERMINAL` varchar(20) collate latin1_general_ci default NULL,
  `TIPOMOV` char(2) collate latin1_general_ci default NULL,
  PRIMARY KEY  (`PAGONUM`),
  KEY `PAGOS_NUMEREX` (`NUMEREX`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='InnoDB free: 19456 kB';

-- ----------------------------
-- Table structure for cajahist
-- ----------------------------
CREATE TABLE `cajahist` (
  `PAGONUM` int(9) unsigned NOT NULL auto_increment,
  `NUMEREX` int(9) unsigned NOT NULL,
  `FECHA` datetime default NULL,
  `TIPOPAGO` int(9) unsigned default NULL,
  `TIPOTARJETA` int(9) unsigned default NULL,
  `EMISOR` varchar(10) collate latin1_general_ci default NULL,
  `NUMERO` varchar(20) collate latin1_general_ci default NULL,
  `MONTO` double(15,2) default '0.00',
  `USUARIO` varchar(15) collate latin1_general_ci default NULL,
  `TERMINAL` varchar(20) collate latin1_general_ci default NULL,
  `TIPOMOV` char(2) collate latin1_general_ci default NULL,
  PRIMARY KEY  (`PAGONUM`),
  KEY `PAGOS_NUMEREX` (`NUMEREX`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='InnoDB free: 19456 kB';

-- ----------------------------
-- Table structure for cias
-- ----------------------------
CREATE TABLE `cias` (
  `CODIGO` int(9) unsigned NOT NULL auto_increment,
  `NOMBRE` varchar(40) collate latin1_general_ci default NULL,
  `CONTACTO` varchar(40) collate latin1_general_ci default NULL,
  `TELOFI` varchar(17) collate latin1_general_ci default NULL,
  `FAXOFI` varchar(8) collate latin1_general_ci default NULL,
  `EMAILOFI` varchar(40) collate latin1_general_ci default NULL,
  `DIRECCIO1` varchar(40) collate latin1_general_ci default NULL,
  `DIRECCIO2` varchar(40) collate latin1_general_ci default NULL,
  `DIRECCIO3` varchar(40) collate latin1_general_ci default NULL,
  `CIUDAD` varchar(20) collate latin1_general_ci default NULL,
  `PROVINCIA` varchar(20) collate latin1_general_ci default NULL,
  `CODPOSTAL` varchar(10) collate latin1_general_ci default NULL,
  `NOTAS1` varchar(255) collate latin1_general_ci default NULL,
  `USERID` varchar(20) collate latin1_general_ci default NULL,
  `CLAVE` varchar(20) collate latin1_general_ci default NULL,
  `Saldo` double(15,2) default NULL,
  PRIMARY KEY  (`CODIGO`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='InnoDB free: 19456 kB';

-- ----------------------------
-- Table structure for citas
-- ----------------------------
CREATE TABLE `citas` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `fecha` date default NULL,
  `hora` time default NULL,
  `paciente` varchar(50) collate latin1_general_ci default NULL,
  `direccion` varchar(255) collate latin1_general_ci default NULL,
  `atiende` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for datosexa
-- ----------------------------
CREATE TABLE `datosexa` (
  `NUMEREX` int(9) unsigned NOT NULL auto_increment,
  `NUMEROCLI` int(9) unsigned NOT NULL,
  `MEDICO` int(9) default NULL,
  `CIA` int(9) default NULL,
  `FACTURARA` varchar(50) collate latin1_general_ci default NULL,
  `ENVIARRESU` char(1) collate latin1_general_ci default NULL,
  `MUESTRALAB` char(50) collate latin1_general_ci default 'LABORATORIO',
  `IDIOMA` char(2) collate latin1_general_ci default NULL,
  `STATUS` char(1) collate latin1_general_ci default 'E',
  `CUARTO` char(5) collate latin1_general_ci default NULL,
  `ORDENC` varchar(10) collate latin1_general_ci default NULL,
  `BARCODE` varchar(10) collate latin1_general_ci default NULL,
  `EMAILC` varchar(40) collate latin1_general_ci default NULL,
  `EMAILO` varchar(40) collate latin1_general_ci default NULL,
  `EMAILE` varchar(40) collate latin1_general_ci default NULL,
  `FAXC` varchar(8) collate latin1_general_ci default NULL,
  `FAXO` varchar(8) collate latin1_general_ci default NULL,
  `FAXE` varchar(8) collate latin1_general_ci default NULL,
  `SFAXC` char(1) collate latin1_general_ci default NULL,
  `SFAXO` char(1) collate latin1_general_ci default NULL,
  `SFAXE` char(1) collate latin1_general_ci default NULL,
  `SEMAC` char(1) collate latin1_general_ci default NULL,
  `SEMAO` char(1) collate latin1_general_ci default NULL,
  `SEMAE` char(1) collate latin1_general_ci default NULL,
  `TOTALEXA` double(15,2) default '0.00',
  `DESCUENTO` double(15,2) default '0.00',
  `CARGOADI` double(15,2) default '0.00',
  `TOTALPAGAR` double(15,2) default '0.00',
  `PAGADO` double(15,2) default '0.00',
  `SALDO` double(15,2) default '0.00',
  `FECHARES` datetime default NULL,
  `FECHAFIN` datetime default NULL,
  `FECHAMOD` datetime default NULL,
  `CREAUI` varchar(12) collate latin1_general_ci default NULL,
  `MODIUSERID` varchar(12) collate latin1_general_ci default NULL,
  `REPORTE` mediumblob,
  PRIMARY KEY  (`NUMEREX`),
  KEY `NUMEROCLI` (`NUMEROCLI`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;
DELIMITER ;;
CREATE TRIGGER `datosexa_bi` BEFORE INSERT ON `datosexa` FOR EACH ROW BEGIN
  SET NEW.status = "E";
  SET NEW.fechares = NOW();
  IF NEW.totalexa IS NULL THEN 
    SET NEW.totalexa = 0.00;
  END IF;
  IF NEW.descuento IS NULL THEN 
    SET NEW.descuento = 0.00;
  END IF;
  IF NEW.cargoadi IS NULL THEN 
    SET NEW.cargoadi = 0.00;
  END IF;
  IF NEW.totalpagar IS NULL THEN 
    SET NEW.totalpagar = 0.00;
  END IF;
  IF NEW.pagado IS NULL THEN 
    SET NEW.pagado = 0.00;
  END IF;
  IF NEW.saldo IS NULL THEN 
    SET NEW.saldo = 0.00;
  END IF;

  SET NEW.totalpagar = (NEW.totalexa*(1+(NEW.descuento/100))+NEW.cargoadi);
  SET NEW.saldo = NEW.totalpagar - NEW.pagado;

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `datosexa_ai` AFTER INSERT ON `datosexa` FOR EACH ROW BEGIN  
  DECLARE num INTEGER;

  SET num = NEW.numerocli;

  CALL calcule_saldo_paciente(num);

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `datosexa_bu` BEFORE UPDATE ON `datosexa` FOR EACH ROW BEGIN
  SET NEW.fechamod = NOW();
  IF NEW.totalexa IS NULL THEN 
    SET NEW.totalexa = 0.00;
  END IF;
  IF NEW.descuento IS NULL THEN 
    SET NEW.descuento = 0.00;
  END IF;
  IF NEW.cargoadi IS NULL THEN 
    SET NEW.cargoadi = 0.00;
  END IF;
  IF NEW.totalpagar IS NULL THEN 
    SET NEW.totalpagar = 0.00;
  END IF;
  IF NEW.pagado IS NULL THEN 
    SET NEW.pagado = 0.00; 
  END IF;
  IF NEW.saldo IS NULL THEN 
    SET NEW.saldo = 0.00;
  END IF;

  SET NEW.totalpagar = (NEW.totalexa*(1+(NEW.descuento/100))+NEW.cargoadi);
  SET NEW.saldo = NEW.totalpagar - NEW.pagado;

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `datosexa_au` AFTER UPDATE ON `datosexa` FOR EACH ROW BEGIN
  DECLARE numcli INTEGER;
  DECLARE numord INTEGER;

  SET numcli = NEW.numerocli;
  SET numord = NEW.numerex; 

  CALL calcule_saldo_paciente(numcli);

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `datosexa_ad` AFTER DELETE ON `datosexa` FOR EACH ROW BEGIN
  DECLARE num INTEGER;

  SET num = OLD.numerocli;

  CALL calcule_saldo_paciente(num);

END;;
DELIMITER ;

-- ----------------------------
-- Table structure for defaults
-- ----------------------------
CREATE TABLE `defaults` (
  `ID` int(9) unsigned NOT NULL auto_increment,
  `EXAMENID` int(9) unsigned NOT NULL default '0',
  `CODIEX` CHAR(4) collate latin1_general_ci NOT NULL default '000',
  `IDIOMA` char(2) collate latin1_general_ci NOT NULL default 'ES',
  `SEXO` char(1) collate latin1_general_ci NOT NULL default 'A',
  `EDADMIN` double(5,2) NOT NULL default '0.00',
  `EDADMAX` double(5,2) NOT NULL default '99.99',
  `SECUENCIA` int(5) default NULL,
  `TIPORESULT` varchar(2) collate latin1_general_ci default 'C',
  `IMPRIME` char(1) collate latin1_general_ci default NULL,
  `BANDERA` char(2) collate latin1_general_ci default '',
  `LEYENDA` varchar(30) collate latin1_general_ci default NULL,
  `RESULTADO` varchar(255) collate latin1_general_ci default NULL,
  `UNIDADES` varchar(15) collate latin1_general_ci default NULL,
  `NORMALES` varchar(255) collate latin1_general_ci default NULL,
  `MINIMO` double default '0',
  `MAXIMO` double default '99999.99',
  `PANICMINIMO` double default '-99999.99',
  `PANICMAXIMO` double default '99999.99',
  `IMPOSIBLEMIN` double default '-99999.99',
  `IMPOSIBLEMAX` double default '99999.99',
  `MNEMONIC` varchar(10) collate latin1_general_ci default NULL,
  `NEGRITA` tinyint(1) default NULL,
  `ITALICA` tinyint(1) default NULL,
  `SUBRAYADO` tinyint(1) default NULL,
  `FUENTE` tinyint(1) default '1',
  `TAMANO` int(3) default '10',
  `fechamod` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `status` char(1) collate latin1_general_ci default 'E',
  `variable` char(8) collate latin1_general_ci default NULL,
  `comparable` int(1) default '0',
  `formula` varchar(255) collate latin1_general_ci default NULL,
  `alineacion` char(1) collate latin1_general_ci default NULL,
  PRIMARY KEY  (`ID`),
  KEY `DEFAULTINDEX` (`CODIEX`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='InnoDB free: 19456 kB';
DELIMITER ;;
CREATE TRIGGER `defaults_bi` BEFORE INSERT ON `defaults` FOR EACH ROW BEGIN
  if (char_length(trim(NEW.resultado)) > 0) then
	SET NEW.status = "M";
  else
	SET NEW.status = 'E';	
  end if;
END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `defaults_bu` BEFORE UPDATE ON `defaults` FOR EACH ROW BEGIN
  if (char_length(trim(NEW.resultado)) > 0) then
	SET NEW.status = "M";
  else
	SET NEW.status = 'E';	
  end if;
END;;
DELIMITER ;

-- ----------------------------
-- Table structure for departamentos
-- ----------------------------
CREATE TABLE `departamentos` (
  `dpto` int(9) unsigned NOT NULL auto_increment,
  `departamendo` varchar(25) collate latin1_general_ci NOT NULL,
  PRIMARY KEY  (`dpto`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for direxame
-- ----------------------------
CREATE TABLE `direxame` (
  `CODIEX` CHAR(4) collate latin1_general_ci NOT NULL,
  `NOMBREXA` varchar(30) collate latin1_general_ci default NULL,
  `PRECIO` double(15,2) default NULL,
  `U` char(1) collate latin1_general_ci default NULL,
  `DPTO` int(9) unsigned default NULL,
  PRIMARY KEY  (`CODIEX`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for doctores
-- ----------------------------
CREATE TABLE `doctores` (
  `CODIGO` int(9) unsigned NOT NULL auto_increment,
  `TITULO` varchar(4) collate latin1_general_ci default NULL,
  `NOMBRE` varchar(20) collate latin1_general_ci default NULL,
  `PRIMERAPE` varchar(20) collate latin1_general_ci default NULL,
  `SEGUNDOAPE` varchar(20) collate latin1_general_ci default NULL,
  `ESPECIALI` varchar(40) collate latin1_general_ci default NULL,
  `TELOFI` varchar(17) collate latin1_general_ci default NULL,
  `FAXOFI` varchar(8) collate latin1_general_ci default NULL,
  `EMAILOFI` varchar(40) collate latin1_general_ci default NULL,
  `TELCASA` varchar(17) collate latin1_general_ci default NULL,
  `FAXCASA` varchar(8) collate latin1_general_ci default NULL,
  `EMAILCASA` varchar(40) collate latin1_general_ci default NULL,
  `CELULAR` varchar(8) collate latin1_general_ci default NULL,
  `CIA` varchar(20) collate latin1_general_ci default NULL,
  `DIRECCION1` varchar(40) collate latin1_general_ci default NULL,
  `DIRECCION2` varchar(40) collate latin1_general_ci default NULL,
  `DIRECCION3` varchar(40) collate latin1_general_ci default NULL,
  `CIUDAD` varchar(20) collate latin1_general_ci default NULL,
  `PROVINCIA` varchar(20) collate latin1_general_ci default NULL,
  `CODPOSTAL` varchar(10) collate latin1_general_ci default NULL,
  `CUMPLE` date default NULL,
  `NOTAS` varchar(255) collate latin1_general_ci default NULL,
  `TMPLLAVE` varchar(60) collate latin1_general_ci default NULL,
  `CLAVEMED` varchar(20) collate latin1_general_ci default NULL,
  `USERID` varchar(20) collate latin1_general_ci default NULL,
  PRIMARY KEY  (`CODIGO`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='InnoDB free: 19456 kB';
DELIMITER ;;
CREATE TRIGGER `doctores_bi` BEFORE INSERT ON `doctores` FOR EACH ROW BEGIN
  if (NEW.primerape IS NULL) then
	SET NEW.primerape = " ";
  else
  	SET NEW.primerape = UPPER(NEW.primerape);
  end if;
  if (NEW.segundoape is NULL) then
	SET NEW.segundoape = " ";
  else
  	SET NEW.segundoape = UPPER(NEW.segundoape);
  end if;
  if (NEW.nombre IS NULL) then
	SET NEW.nombre = " ";
  else
	SET NEW.nombre = UPPER(NEW.nombre);
  END IF;
  SET NEW.tmpllave = CONCAT(NEW.primerape," ",NEW.segundoape," ",NEW.nombre);
END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `doctores_bu` BEFORE UPDATE ON `doctores` FOR EACH ROW BEGIN
  if (NEW.primerape IS NULL) then
	SET NEW.primerape = " ";
  else
  	SET NEW.primerape = UPPER(NEW.primerape);
  end if;
  if (NEW.segundoape is NULL) then
	SET NEW.segundoape = " ";
  else
  	SET NEW.segundoape = UPPER(NEW.segundoape);
  end if;
  if (NEW.nombre IS NULL) then
	SET NEW.nombre = " ";
  else
	SET NEW.nombre = UPPER(NEW.nombre);
  END IF;
  SET NEW.tmpllave = CONCAT(NEW.primerape," ",NEW.segundoape," ",NEW.nombre);
END;;
DELIMITER ;

-- ----------------------------
-- Table structure for examenes
-- ----------------------------
CREATE TABLE `examenes` (
  `EXAMENID` int(9) unsigned NOT NULL auto_increment,
  `NUMEREX` int(9) unsigned NOT NULL,
  `CODIEX` CHAR(4) collate latin1_general_ci NOT NULL,
  `NOMBREXA` varchar(30) collate latin1_general_ci default NULL,
  `PRECIO` double(15,2) default '0.00',
  `U` char(1) collate latin1_general_ci default NULL,
  `STATUS` char(1) collate latin1_general_ci default 'E',
  `FECHARES` datetime default NULL,
  `FECHAFIN` datetime default NULL,
  `FECHAMOD` datetime default NULL,
  `MODIUSERID` varchar(20) collate latin1_general_ci default NULL,
  `IMPRIME` int(1) default NULL,
  PRIMARY KEY  (`EXAMENID`),
  KEY `NUMEREX` (`NUMEREX`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;
DELIMITER ;;
CREATE TRIGGER `examenes_bi` BEFORE INSERT ON `examenes` FOR EACH ROW BEGIN
  DECLARE newc VARCHAR(5);
  DECLARE newn VARCHAR(30);
  DECLARE newp DOUBLE;
  DECLARE pruebatipo char(1);
  DECLARE num INTEGER;

  SET NEW.status = "E";
  SET NEW.imprime = 0;
  SET NEW.fechares = NOW();
  SET NEW.fechamod= NOW();	
  SET newc = NEW.codiex;
  SET newn = NEW.nombrexa;
  SET newp = NEW.precio;  
  SET num = NEW.numerex;
  SET pruebatipo = NEW.u;

  CALL llenarexamen(newc, newn, newp, pruebatipo);

  SET NEW.nombrexa = newn;
  SET NEW.u = pruebatipo;
  IF pruebatipo = 'M' then
    SET NEW.precio = 0.00;
  ELSE
    SET NEW.precio = newp;
  END IF;

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `examenes_ai` AFTER INSERT ON `examenes` FOR EACH ROW BEGIN
  DECLARE num INTEGER;
  DECLARE codi CHAR(4);
  DECLARE exanum INTEGER;
  DECLARE exatipo CHAR(1);

  SET exatipo = NEW.u;
  SET num = NEW.numerex;
  SET codi = NEW.codiex;
  SET exanum = NEW.examenid;


  CALL calcule_total_orden(num);
  CALL inserte_resultados(num, codi, exanum);

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `examenes_au` AFTER UPDATE ON `examenes` FOR EACH ROW BEGIN
  DECLARE nume INTEGER;

  SET nume = OLD.numerex;

  CALL status_orden(nume);

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `examenes_ad` AFTER DELETE ON `examenes` FOR EACH ROW BEGIN
  DECLARE num INTEGER;

  SET num = OLD.numerex;

  CALL calcule_total_orden(num);

END;;
DELIMITER ;

-- ----------------------------
-- Table structure for idiomas
-- ----------------------------
CREATE TABLE `idiomas` (
  `IDIOMAID` char(2) collate latin1_general_ci NOT NULL,
  `IDIOMA` varchar(15) collate latin1_general_ci NOT NULL,
  PRIMARY KEY  (`IDIOMAID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for mensajes
-- ----------------------------
CREATE TABLE `mensajes` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `Fecha` date default NULL,
  `hora` time default NULL,
  `usuarioid` int(10) unsigned NOT NULL default '0',
  `Departe` varchar(45) character set latin1 collate latin1_bin default NULL,
  `Empresa` varchar(45) collate latin1_general_ci default NULL,
  `Telefono` varchar(45) collate latin1_general_ci default NULL,
  `Mensaje` varchar(20) collate latin1_general_ci default NULL,
  `Notas` varchar(255) collate latin1_general_ci default NULL,
  `datestamp` timestamp NULL default NULL on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='Mensajes telefÃ³nicos';

-- ----------------------------
-- Table structure for metaexas
-- ----------------------------
CREATE TABLE `metaexas` (
  `METAID` int(9) unsigned NOT NULL auto_increment,
  `METACODIEX` CHAR(4) collate latin1_general_ci NOT NULL,
  `EXPANDCODE` CHAR(4) collate latin1_general_ci NOT NULL,
  `PRECIO` double default '0',
  PRIMARY KEY  (`METAID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;
DELIMITER ;;
CREATE TRIGGER `metaexas_ai` AFTER INSERT ON `metaexas` FOR EACH ROW BEGIN
  DECLARE num INTEGER;

  SET num = NEW.metacodiex;

  CALL calcule_total_meta(num);
 	
END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `metaexas_au` AFTER UPDATE ON `metaexas` FOR EACH ROW BEGIN
  DECLARE num INTEGER;

  SET num = NEW.metacodiex;

  CALL calcule_total_meta(num);

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `metaexas_ad` AFTER DELETE ON `metaexas` FOR EACH ROW BEGIN
  DECLARE num INTEGER;

  SET num = OLD.metacodiex;

  CALL calcule_total_meta(num);

END;;
DELIMITER ;

-- ----------------------------
-- Table structure for pacientes
-- ----------------------------
CREATE TABLE `pacientes` (
  `NUMEROCLI` int(9) unsigned NOT NULL auto_increment,
  `NOMBRE` varchar(15) collate latin1_general_ci default NULL,
  `PRIMERAPE` varchar(15) collate latin1_general_ci default NULL,
  `SEGUNDOAPE` varchar(15) collate latin1_general_ci default NULL,
  `SRADR` varchar(4) collate latin1_general_ci default NULL,
  `SEXO` char(1) collate latin1_general_ci default NULL,
  `TELEFONO` varchar(28) collate latin1_general_ci default NULL,
  `SALDO` double(15,2) default '0.00',
  `NACIO` datetime default NULL,
  `EDAD` double(5,2) default '0.00',
  `FAXCASA` varchar(8) collate latin1_general_ci default NULL,
  `FAXOFICINA` varchar(8) collate latin1_general_ci default NULL,
  `EMAIL1` varchar(40) collate latin1_general_ci default NULL,
  `EMAIL2` varchar(40) collate latin1_general_ci default NULL,
  `CREAUI` varchar(12) collate latin1_general_ci default NULL,
  `FECHARES` datetime default NULL,
  `MODIUI` varchar(12) collate latin1_general_ci default NULL,
  `MODIDATE` datetime default NULL,
  `ID` varchar(15) collate latin1_general_ci default NULL,
  `CLAVE` varchar(20) collate latin1_general_ci default NULL,
  `TMPLLAVE` varchar(60) collate latin1_general_ci default NULL,
  PRIMARY KEY  (`NUMEROCLI`),
  KEY `nombre` (`NOMBRE`),
  KEY `primerape` (`PRIMERAPE`),
  KEY `segundoape` (`SEGUNDOAPE`),
  KEY `tmpllave` (`TMPLLAVE`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;
DELIMITER ;;
CREATE TRIGGER `pacientes_bi` BEFORE INSERT ON `pacientes` FOR EACH ROW BEGIN
  SET NEW.primerape = UPPER(NEW.primerape);
  SET NEW.segundoape = UPPER(NEW.segundoape);
  SET NEW.nombre = UPPER(NEW.nombre);
  SET NEW.tmpllave = CONCAT(NEW.primerape," ",NEW.segundoape," ",NEW.nombre);
  SET NEW.fechares = NOW();
  SET NEW.modidate = NOW();

  SET NEW.edad= datediff(now(),NEW.nacio)/365.242199; 

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `pacientes_bu` BEFORE UPDATE ON `pacientes` FOR EACH ROW BEGIN
  SET NEW.primerape = UPPER(NEW.primerape);
  SET NEW.segundoape = UPPER(NEW.segundoape);
  SET NEW.nombre = UPPER(NEW.nombre);
  SET NEW.tmpllave = CONCAT(NEW.primerape," ",NEW.segundoape," ",NEW.nombre);
  SET NEW.modidate = NOW();

  SET NEW.edad= datediff(now(),NEW.nacio)/365.242199; 

END;;
DELIMITER ;

-- ----------------------------
-- Table structure for pagos
-- ----------------------------
CREATE TABLE `pagos` (
  `PAGONUM` int(9) unsigned NOT NULL auto_increment,
  `NUMEREX` int(9) unsigned NOT NULL,
  `FECHA` datetime default NULL,
  `TIPOPAGO` int(9) unsigned default NULL,
  `TIPOTARJETA` int(9) unsigned default NULL,
  `EMISOR` varchar(10) collate latin1_general_ci default NULL,
  `NUMERO` varchar(20) collate latin1_general_ci default NULL,
  `MONTO` double(15,2) default '0.00',
  `USUARIO` varchar(15) collate latin1_general_ci default NULL,
  `TERMINAL` varchar(20) collate latin1_general_ci default NULL,
  `TIPOMOV` char(2) collate latin1_general_ci default NULL,
  PRIMARY KEY  (`PAGONUM`),
  KEY `PAGOS_NUMEREX` (`NUMEREX`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='InnoDB free: 19456 kB';
DELIMITER ;;
CREATE TRIGGER `pagos_bi` BEFORE INSERT ON `pagos` FOR EACH ROW BEGIN
  DECLARE num INTEGER;

  SET NEW.fecha = NOW();

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `pagos_ai` AFTER INSERT ON `pagos` FOR EACH ROW BEGIN
  DECLARE pnum INTEGER;
  DECLARE num INTEGER;

  SET pnum = NEW.pagonum;
  SET num = NEW.numerex;

  CALL add_to_caja(pnum);
  CALL calcule_total_pagos(num);

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `pagos_bd` BEFORE DELETE ON `pagos` FOR EACH ROW BEGIN
  DECLARE pnum INTEGER;
  SET pnum = OLD.pagonum;

  CALL sub_to_caja(pnum);

END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `pagos_ad` AFTER DELETE ON `pagos` FOR EACH ROW BEGIN
  DECLARE num INTEGER;
  SET num = OLD.numerex;

  CALL calcule_total_pagos(num);

END;;
DELIMITER ;

-- ----------------------------
-- Table structure for presupuestohead
-- ----------------------------
CREATE TABLE `presupuestohead` (
  `presupuestoid` int(11) unsigned NOT NULL auto_increment,
  `paciente` varchar(50) default NULL,
  `descuento_fijo` float(13,2) default NULL,
  `descuento_por` float(6,2) default NULL,
  `userid` varchar(255) default NULL,
  PRIMARY KEY  (`presupuestoid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
DELIMITER ;;
CREATE TRIGGER `presupuestohead_bd` BEFORE DELETE ON `presupuestohead` FOR EACH ROW BEGIN
  DECLARE num INTEGER;
  SET num = OLD.presupuestoid;

  CALL borre_presupuestos(num);

END;;
DELIMITER ;

-- ----------------------------
-- Table structure for presupuestos
-- ----------------------------
CREATE TABLE `presupuestos` (
  `PRESULINEID` int(9) unsigned NOT NULL auto_increment,
  `PRESUPUESTOID` int(9) NOT NULL,
  `NUMEREX` int(9) unsigned NOT NULL,
  `CODIEX` CHAR(4) collate latin1_general_ci NOT NULL,
  `NOMBREXA` varchar(30) collate latin1_general_ci default NULL,
  `PRECIO` double(15,2) default '0.00',
  `U` char(1) collate latin1_general_ci default NULL,
  `STATUS` char(1) collate latin1_general_ci default 'E',
  `FECHARES` datetime default NULL,
  `FECHAFIN` datetime default NULL,
  `FECHAMOD` datetime default NULL,
  `MODIUSERID` varchar(20) collate latin1_general_ci default NULL,
  `IMPRIME` int(1) default NULL,
  PRIMARY KEY  (`PRESULINEID`),
  KEY `NUMEREX` (`NUMEREX`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;
DELIMITER ;;
CREATE TRIGGER `presupuestos_bi` BEFORE INSERT ON `presupuestos` FOR EACH ROW BEGIN
  DECLARE newc VARCHAR(5);
  DECLARE newn VARCHAR(30);
  DECLARE newp DOUBLE;
  DECLARE pruebatipo char(1);
  DECLARE num INTEGER;

  SET NEW.status = "E";
  SET NEW.fechares = NOW();
  SET NEW.fechamod= NOW();	
  SET newc = NEW.codiex;
  SET newn = NEW.nombrexa;
  SET newp = NEW.precio;  
  SET num = NEW.numerex;
  SET pruebatipo = NEW.u;

  CALL llenarpresupuesto(newc, newn, newp, pruebatipo);

  SET NEW.nombrexa = newn;
  SET NEW.u = pruebatipo;
  SET NEW.precio = newp;

END;;
DELIMITER ;

-- ----------------------------
-- Table structure for resultados
-- ----------------------------
CREATE TABLE `resultados` (
  `ID` int(9) unsigned NOT NULL auto_increment,
  `EXAMENID` int(9) unsigned NOT NULL,
  `CODIEX` CHAR(4) collate latin1_general_ci NOT NULL default '000',
  `IDIOMA` char(2) collate latin1_general_ci NOT NULL,
  `SEXO` char(1) collate latin1_general_ci NOT NULL default 'A',
  `EDADMIN` double(5,2) default '0.00',
  `EDADMAX` double(5,2) default '99.99',
  `SECUENCIA` int(5) default NULL,
  `TIPORESULT` varchar(2) collate latin1_general_ci default 'C',
  `IMPRIME` char(1) collate latin1_general_ci default NULL,
  `BANDERA` char(2) collate latin1_general_ci default '',
  `LEYENDA` varchar(30) collate latin1_general_ci default NULL,
  `RESULTADO` varchar(255) collate latin1_general_ci default NULL,
  `UNIDADES` varchar(15) collate latin1_general_ci default NULL,
  `NORMALES` varchar(255) collate latin1_general_ci default NULL,
  `MINIMO` double default '0',
  `MAXIMO` double default '99999.99',
  `PANICMINIMO` double default '-99999.99',
  `PANICMAXIMO` double default '99999.99',
  `IMPOSIBLEMIN` double default '-99999.99',
  `IMPOSIBLEMAX` double default '99999.99',
  `MNEMONIC` varchar(10) collate latin1_general_ci default NULL,
  `NEGRITA` tinyint(1) default NULL,
  `ITALICA` tinyint(1) default NULL,
  `SUBRAYADO` tinyint(1) default NULL,
  `FUENTE` tinyint(1) default NULL,
  `TAMANO` int(3) default NULL,
  `fechamod` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `status` char(1) collate latin1_general_ci default 'E',
  `variable` char(8) collate latin1_general_ci default NULL,
  `comparable` int(1) default '0',
  `formula` varchar(255) collate latin1_general_ci default NULL,
  `alineacion` char(1) collate latin1_general_ci default NULL,
  PRIMARY KEY  (`ID`),
  KEY `EXAMENID` (`EXAMENID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;
DELIMITER ;;
CREATE TRIGGER `resultados_bu` BEFORE UPDATE ON `resultados` FOR EACH ROW BEGIN
  DECLARE numresult DOUBLE;

  SET NEW.status = 'M';

  SET NEW.bandera = '  ';

  IF (NEW.resultado REGEXP '^[^a-zA-Z]') THEN
	set numresult = CONVERT(NEW.resultado,DECIMAL);
	if numresult < NEW.minimo then 
		SET NEW.bandera = "-";
	end if;
	if numresult > NEW.maximo then 
		SET NEW.bandera = "+";
	end if;
	
	if numresult < NEW.panicminimo then 
		SET NEW.bandera = "--";
	end if;

	if numresult > NEW.panicmaximo then 
		SET NEW.bandera = "++";
	end if;

	if numresult < NEW.imposiblemin then 
		SET NEW.bandera = "E-";
	end if;

	if numresult > NEW.imposiblemax then 
		SET NEW.bandera = "E+";
	end if;

  end if;
 
END;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER `resultados_au` AFTER UPDATE ON `resultados` FOR EACH ROW BEGIN
  DECLARE num INTEGER;

  SET num =  NEW.examenid;

  CALL update_status(num);


END;;
DELIMITER ;

-- ----------------------------
-- Table structure for saludos
-- ----------------------------
CREATE TABLE `saludos` (
  `saludoid` int(9) unsigned NOT NULL auto_increment,
  `sexo` char(1) collate latin1_general_ci NOT NULL,
  `saludo` varchar(5) collate latin1_general_ci NOT NULL,
  PRIMARY KEY  (`saludoid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for sexos
-- ----------------------------
CREATE TABLE `sexos` (
  `sexoid` char(1) collate latin1_general_ci NOT NULL,
  `sexo` char(10) collate latin1_general_ci NOT NULL,
  PRIMARY KEY  (`sexoid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for tipopago
-- ----------------------------
CREATE TABLE `tipopago` (
  `tipo` int(9) unsigned NOT NULL auto_increment,
  `descripcion` varchar(10) collate latin1_general_ci NOT NULL,
  PRIMARY KEY  (`tipo`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for tiporesultado
-- ----------------------------
CREATE TABLE `tiporesultado` (
  `tiporesult` varchar(2) collate latin1_general_ci NOT NULL default '',
  `descripcion` varchar(20) collate latin1_general_ci default NULL,
  PRIMARY KEY  (`tiporesult`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for tipotarjeta
-- ----------------------------
CREATE TABLE `tipotarjeta` (
  `tipotarjeta` int(9) unsigned NOT NULL auto_increment,
  `tarjeta` varchar(10) collate latin1_general_ci NOT NULL,
  `tipopago` int(9) default NULL,
  PRIMARY KEY  (`tipotarjeta`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for tipotubo
-- ----------------------------
CREATE TABLE `tipotubo` (
  `id` int(11) NOT NULL auto_increment,
  `tubo` varchar(30) character set latin1 default NULL,
  `equipo` varchar(30) character set latin1 default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for tubosxexamen
-- ----------------------------
CREATE TABLE `tubosxexamen` (
  `ID` int(11) NOT NULL auto_increment,
  `CODIEX` CHAR(4) collate latin1_general_ci default NULL,
  `TUBOID` int(11) default NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for userlevelpermissions
-- ----------------------------
CREATE TABLE `userlevelpermissions` (
  `userlevelid` int(11) NOT NULL,
  `tablename` varchar(50) collate latin1_general_ci NOT NULL,
  `permission` int(11) NOT NULL,
  PRIMARY KEY  (`userlevelid`,`tablename`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for userlevels
-- ----------------------------
CREATE TABLE `userlevels` (
  `userlevelid` int(11) NOT NULL,
  `userlevelname` varchar(50) collate latin1_general_ci NOT NULL,
  PRIMARY KEY  (`userlevelid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for usuarios
-- ----------------------------
CREATE TABLE `usuarios` (
  `USUARIOID` int(9) unsigned NOT NULL auto_increment,
  `USUARIO` varchar(20) collate latin1_general_ci NOT NULL,
  `PASSWORD` varchar(20) collate latin1_general_ci NOT NULL,
  `NOMBRE` varchar(25) collate latin1_general_ci default NULL,
  `PRIMERAPE` varchar(25) collate latin1_general_ci default NULL,
  `SEGUNDOAPE` varchar(25) collate latin1_general_ci default NULL,
  `USERLEVEL` int(3) NOT NULL,
  `citas` int(1) NOT NULL default '0',
  PRIMARY KEY  (`USUARIOID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- View structure for antiguedad
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `antiguedad` AS select sql_no_cache `datosexa`.`NUMEREX` AS `orden`,`pacientes`.`TMPLLAVE` AS `paciente`,`pacientes`.`ID` AS `id`,`datosexa`.`FECHARES` AS `fecha`,`datosexa`.`SALDO` AS `saldo`,(to_days(curdate()) - to_days(`datosexa`.`FECHARES`)) AS `dias`,if(((to_days(curdate()) - to_days(`datosexa`.`FECHARES`)) > 90),_latin1'Mas de 90',if(((to_days(curdate()) - to_days(`datosexa`.`FECHARES`)) > 60),_latin1'61-90',if(((to_days(curdate()) - to_days(`datosexa`.`FECHARES`)) > 30),_latin1'31 - 60',_latin1'0 - 30'))) AS `periodo` from (`datosexa` join `pacientes`) where ((`datosexa`.`NUMEROCLI` = `pacientes`.`NUMEROCLI`) and (`datosexa`.`SALDO` <> 0) and (`datosexa`.`CIA` = 0)) order by `pacientes`.`TMPLLAVE`,(to_days(curdate()) - to_days(`datosexa`.`FECHARES`));

-- ----------------------------
-- View structure for antiguedadcias
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `antiguedadcias` AS select sql_no_cache `cias`.`NOMBRE` AS `compania`,`datosexa`.`NUMEREX` AS `orden`,`pacientes`.`TMPLLAVE` AS `paciente`,`pacientes`.`ID` AS `id`,`datosexa`.`FECHARES` AS `fecha`,`datosexa`.`SALDO` AS `saldo`,(to_days(curdate()) - to_days(`datosexa`.`FECHARES`)) AS `dias`,if(((to_days(curdate()) - to_days(`datosexa`.`FECHARES`)) > 90),_latin1'Mas de 90',if(((to_days(curdate()) - to_days(`datosexa`.`FECHARES`)) > 60),_latin1'61-90',if(((to_days(curdate()) - to_days(`datosexa`.`FECHARES`)) > 30),_latin1'31 - 60',_latin1'0 - 30'))) AS `periodo` from ((`datosexa` join `cias` on((`datosexa`.`CIA` = `cias`.`CODIGO`))) join `pacientes` on((`datosexa`.`NUMEROCLI` = `pacientes`.`NUMEROCLI`))) where ((`datosexa`.`SALDO` <> 0) and (`datosexa`.`CIA` <> 0)) order by `pacientes`.`TMPLLAVE`,(to_days(curdate()) - to_days(`datosexa`.`FECHARES`));

-- ----------------------------
-- View structure for cajaview1
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `cajaview1` AS select `caja`.`USUARIO` AS `USUARIO`,`caja`.`PAGONUM` AS `PAGONUM`,`caja`.`NUMEREX` AS `NUMEREX`,`caja`.`FECHA` AS `FECHA`,`tipopago`.`descripcion` AS `tipodepago`,`tipotarjeta`.`tarjeta` AS `tarjeta`,`caja`.`TIPOMOV` AS `TIPOMOV`,`caja`.`NUMERO` AS `NUMERO`,`caja`.`MONTO` AS `MONTO`,`caja`.`EMISOR` AS `EMISOR` from ((`caja` left join `tipopago` on((`caja`.`TIPOPAGO` = `tipopago`.`tipo`))) left join `tipotarjeta` on((`caja`.`TIPOTARJETA` = `tipotarjeta`.`tipotarjeta`)));

-- ----------------------------
-- View structure for cajaview2
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `cajaview2` AS select `caja`.`USUARIO` AS `USUARIO`,`caja`.`PAGONUM` AS `PAGONUM`,`caja`.`NUMEREX` AS `NUMEREX`,`caja`.`FECHA` AS `FECHA`,`tipopago`.`descripcion` AS `tipodepago`,`tipotarjeta`.`tarjeta` AS `tarjeta`,`caja`.`TIPOMOV` AS `TIPOMOV`,`caja`.`NUMERO` AS `NUMERO`,`caja`.`MONTO` AS `MONTO`,`caja`.`EMISOR` AS `EMISOR` from ((`caja` left join `tipopago` on((`caja`.`TIPOPAGO` = `tipopago`.`tipo`))) left join `tipotarjeta` on((`caja`.`TIPOTARJETA` = `tipotarjeta`.`tipotarjeta`))) order by `caja`.`TIPOPAGO`,`caja`.`TIPOTARJETA`;

-- ----------------------------
-- View structure for ciasview
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `ciasview` AS select sql_no_cache `pacientes`.`TMPLLAVE` AS `tmpllave`,`datosexa`.`NUMEREX` AS `numerex`,`datosexa`.`FECHARES` AS `fechares`,`datosexa`.`TOTALPAGAR` AS `totalpagar`,`datosexa`.`PAGADO` AS `pagado`,`datosexa`.`SALDO` AS `saldo`,`datosexa`.`MODIUSERID` AS `modiuserid`,`datosexa`.`FECHAMOD` AS `fechamod`,`datosexa`.`CIA` AS `cia` from (`pacientes` join `datosexa`) where (`datosexa`.`NUMEROCLI` = `pacientes`.`NUMEROCLI`);

-- ----------------------------
-- View structure for comparables
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `comparables` AS select `datosexa`.`NUMEROCLI` AS `NUMEROCLI`,`examenes`.`NUMEREX` AS `NUMEREX`,`datosexa`.`MEDICO` AS `MEDICO`,`datosexa`.`CIA` AS `CIA`,`datosexa`.`STATUS` AS `STATUS`,`examenes`.`FECHARES` AS `FECHARES`,`examenes`.`FECHAFIN` AS `FECHAFIN`,`examenes`.`FECHAMOD` AS `FECHAMOD`,`resultados`.`BANDERA` AS `BANDERA`,`resultados`.`LEYENDA` AS `LEYENDA`,`resultados`.`RESULTADO` AS `RESULTADO`,`resultados`.`UNIDADES` AS `UNIDADES`,`resultados`.`NORMALES` AS `NORMALES`,`examenes`.`CODIEX` AS `CODIEX`,`examenes`.`NOMBREXA` AS `NOMBREXA`,`resultados`.`MINIMO` AS `MINIMO`,`resultados`.`MAXIMO` AS `MAXIMO` from ((`resultados` join `examenes` on((`resultados`.`EXAMENID` = `examenes`.`EXAMENID`))) join `datosexa` on((`examenes`.`NUMEREX` = `datosexa`.`NUMEREX`))) where ((`resultados`.`comparable` = 1) and (`resultados`.`RESULTADO` <> _latin1''));

-- ----------------------------
-- View structure for distpacientes
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `distpacientes` AS select sql_no_cache `pacientes`.`SEXO` AS `sexo`,((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) AS `edad`,if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 90),_latin1'> 90',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 80),_latin1'81 - 90',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 70),_latin1'71 - 80',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 60),_latin1'61 - 70',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 50),_latin1'51 - 60',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 40),_latin1'41 - 50',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 30),_latin1'31 - 40',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 20),_latin1'21 - 30',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 11),_latin1'11 - 20',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 1),_latin1' 1 - 10',_latin1' 0 -  1')))))))))) AS `rango` from `pacientes` order by if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 90),_latin1'> 90',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 80),_latin1'81 - 90',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 70),_latin1'71 - 80',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 60),_latin1'61 - 70',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 50),_latin1'51 - 60',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 40),_latin1'41 - 50',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 30),_latin1'31 - 40',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 20),_latin1'21 - 30',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 11),_latin1'11 - 20',if((((to_days(curdate()) - to_days(`pacientes`.`NACIO`)) / 365.242199) > 1),_latin1' 1 - 10',_latin1' 0 -  1'))))))))));

-- ----------------------------
-- View structure for entregamedico
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `entregamedico` AS select concat_ws(_latin1' ',`doctores`.`PRIMERAPE`,`doctores`.`SEGUNDOAPE`,`doctores`.`NOMBRE`) AS `MEDICO`,`doctores`.`TELOFI` AS `TELOFI`,`doctores`.`FAXOFI` AS `FAXOFI`,`doctores`.`DIRECCION1` AS `DIRECCION1`,`doctores`.`DIRECCION2` AS `DIRECCION2`,`doctores`.`DIRECCION3` AS `DIRECCION3`,`datosexa`.`NUMEREX` AS `NUMEREX`,`pacientes`.`TMPLLAVE` AS `PACIENTE`,`datosexa`.`FECHARES` AS `FECHARES`,`datosexa`.`FECHAFIN` AS `FECHAFIN` from ((`doctores` join `datosexa` on((`datosexa`.`MEDICO` = `doctores`.`CODIGO`))) join `pacientes` on((`datosexa`.`NUMEROCLI` = `pacientes`.`NUMEROCLI`))) where ((`datosexa`.`CIA` > 0) and (`datosexa`.`ENVIARRESU` = 1)) order by `datosexa`.`FECHAFIN` desc;

-- ----------------------------
-- View structure for estadocuenta
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `estadocuenta` AS select `cias`.`NOMBRE` AS `NOMBRE`,`datosexa`.`NUMEREX` AS `NUMEREX`,`datosexa`.`TOTALPAGAR` AS `TOTALPAGAR`,`datosexa`.`PAGADO` AS `PAGADO`,`datosexa`.`SALDO` AS `SALDO`,`datosexa`.`FECHARES` AS `FECHARES`,`datosexa`.`FECHAFIN` AS `FECHAFIN`,concat_ws(_latin1' ',`pacientes`.`PRIMERAPE`,`pacientes`.`SEGUNDOAPE`,`pacientes`.`NOMBRE`) AS `PACIENTE` from ((`datosexa` join `cias` on((`datosexa`.`CIA` = `cias`.`CODIGO`))) join `pacientes` on((`datosexa`.`NUMEROCLI` = `pacientes`.`NUMEROCLI`))) where (`datosexa`.`CIA` > _latin1'0') order by `cias`.`NOMBRE`,`datosexa`.`FECHAFIN`;

-- ----------------------------
-- View structure for examenescia
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `examenescia` AS select sql_no_cache `examenes`.`EXAMENID` AS `EXAMENID`,`examenes`.`NUMEREX` AS `NUMEREX`,`examenes`.`CODIEX` AS `CODIEX`,`examenes`.`NOMBREXA` AS `NOMBREXA`,`examenes`.`PRECIO` AS `PRECIO`,`examenes`.`STATUS` AS `STATUS`,`examenes`.`FECHARES` AS `FECHARES`,`examenes`.`FECHAFIN` AS `FECHAFIN`,`examenes`.`FECHAMOD` AS `FECHAMOD` from `examenes`;

-- ----------------------------
-- View structure for examenesmed
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `examenesmed` AS select sql_no_cache `examenes`.`EXAMENID` AS `EXAMENID`,`examenes`.`NUMEREX` AS `NUMEREX`,`examenes`.`CODIEX` AS `CODIEX`,`examenes`.`NOMBREXA` AS `NOMBREXA`,`examenes`.`PRECIO` AS `PRECIO`,`examenes`.`STATUS` AS `STATUS`,`examenes`.`FECHARES` AS `FECHARES`,`examenes`.`FECHAFIN` AS `FECHAFIN`,`examenes`.`FECHAMOD` AS `FECHAMOD` from `examenes`;

-- ----------------------------
-- View structure for ordenes
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `ordenes` AS select sql_no_cache `datosexa`.`CIA` AS `CIA`,`datosexa`.`NUMEREX` AS `NUMEREX`,concat_ws(_latin1' ',`pacientes`.`PRIMERAPE`,`pacientes`.`SEGUNDOAPE`,`pacientes`.`NOMBRE`) AS `PACIENTE`,`datosexa`.`STATUS` AS `STATUS`,`datosexa`.`ORDENC` AS `ORDENC`,`datosexa`.`TOTALPAGAR` AS `TOTALPAGAR`,`datosexa`.`PAGADO` AS `PAGADO`,`datosexa`.`SALDO` AS `SALDO`,`datosexa`.`FECHARES` AS `FECHARES`,`datosexa`.`FECHAFIN` AS `FECHAFIN`,`datosexa`.`FECHAMOD` AS `FECHAMOD`,`datosexa`.`MEDICO` AS `MEDICO` from (`datosexa` join `pacientes` on((`pacientes`.`NUMEROCLI` = `datosexa`.`NUMEROCLI`)));

-- ----------------------------
-- View structure for ordenescia
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `ordenescia` AS select `datosexa`.`CIA` AS `CIA`,`cias`.`NOMBRE` AS `NOMBRE`,`pacientes`.`ID` AS `as Id`,`pacientes`.`TMPLLAVE` AS `Paciente`,`doctores`.`TMPLLAVE` AS `Medico`,`datosexa`.`NUMEREX` AS `Orden`,`datosexa`.`STATUS` AS `Estatus`,`datosexa`.`FECHARES` AS `Fecha`,`datosexa`.`TOTALPAGAR` AS `Total`,`datosexa`.`PAGADO` AS `Pagado`,`datosexa`.`SALDO` AS `Saldo`,`datosexa`.`REPORTE` AS `REPORTE` from (((`datosexa` join `cias` on((`datosexa`.`CIA` = `cias`.`CODIGO`))) join `pacientes` on((`datosexa`.`NUMEROCLI` = `pacientes`.`NUMEROCLI`))) join `doctores` on((`datosexa`.`MEDICO` = `doctores`.`CODIGO`)));

-- ----------------------------
-- View structure for ordenesmed
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `ordenesmed` AS select `datosexa`.`NUMEREX` AS `NUMEREX`,`datosexa`.`STATUS` AS `STATUS`,`datosexa`.`ORDENC` AS `ORDENC`,`datosexa`.`TOTALPAGAR` AS `TOTALPAGAR`,`datosexa`.`PAGADO` AS `PAGADO`,`datosexa`.`SALDO` AS `SALDO`,`datosexa`.`FECHARES` AS `FECHARES`,`datosexa`.`FECHAFIN` AS `FECHAFIN`,`datosexa`.`FECHAMOD` AS `FECHAMOD`,`datosexa`.`MEDICO` AS `MEDICO`,`datosexa`.`REPORTE` AS `REPORTE`,`pacientes`.`TMPLLAVE` AS `TMPLLAVE` from (`datosexa` join `pacientes` on((`pacientes`.`NUMEROCLI` = `datosexa`.`NUMEROCLI`))) where (`datosexa`.`STATUS` <> _latin1'E');

-- ----------------------------
-- View structure for userdecias
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `userdecias` AS select `cias`.`CODIGO` AS `CODIGO`,`cias`.`USERID` AS `USERID`,`cias`.`CLAVE` AS `CLAVE` from `cias`;

-- ----------------------------
-- View structure for userdedrs
-- ----------------------------
CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `userdedrs` AS select `doctores`.`CODIGO` AS `CODIGO`,`doctores`.`USERID` AS `USERID`,`doctores`.`CLAVEMED` AS `CLAVEMED` from `doctores`;

-- ----------------------------
-- Procedure structure for add_to_caja
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `add_to_caja`(IN pnum INTEGER)
BEGIN
  
  CREATE TEMPORARY TABLE tmpcaja SELECT * FROM pagos WHERE pagos.pagonum=pnum;
  UPDATE tmpcaja SET pagonum=0, tipomov='DB';
  INSERT INTO caja SELECT * FROM tmpcaja;
  DROP TEMPORARY TABLE tmpcaja;
  
END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for borre_presupuestos
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `borre_presupuestos`(IN presuid INTEGER)
BEGIN
  DELETE FROM presupuestos WHERE presupuestoid=presuid;
END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for calcule_saldo_paciente
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `calcule_saldo_paciente`(IN num INTEGER)
BEGIN
  DECLARE totexa DOUBLE DEFAULT 0.00;
  DECLARE totex DOUBLE DEFAULT 0.00;
  DECLARE caltotpa CURSOR FOR SELECT sum(saldo) FROM datosexa where datosexa.numerocli=num; 
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET totex = 0.00;

  OPEN caltotpa;

  FETCH caltotpa INTO totex;
  IF totex IS NULL THEN
	SET totex = 0.00;
  END IF;

  UPDATE pacientes SET saldo=totex WHERE numerocli = num;

  CLOSE caltotpa;

END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for calcule_total_meta
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `calcule_total_meta`(IN num INTEGER)
BEGIN
  DECLARE totex DOUBLE DEFAULT 0.00;
  DECLARE caltotme CURSOR FOR SELECT sum(precio) FROM metaexas where metaexas.metacodiex=num; 
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET totex = 0.00;

  OPEN caltotme;
  FETCH caltotme INTO totex;
  IF totex IS NULL THEN
	SET totex = 0.00;
  END IF;
  UPDATE direxame SET precio=totex WHERE codiex = num;
  CLOSE caltotme;
END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for calcule_total_orden
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `calcule_total_orden`(IN num INTEGER)
BEGIN
  DECLARE totexa DOUBLE DEFAULT 0.00;
  DECLARE totex DOUBLE DEFAULT 0.00;
  DECLARE caltotor CURSOR FOR SELECT sum(precio) FROM examenes where examenes.numerex=num; 
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET totex = 0.00;

  OPEN caltotor;
  FETCH caltotor INTO totex;
  IF totex IS NULL THEN
	SET totex = 0.00;
  END IF;
  UPDATE datosexa SET totalexa=totex WHERE numerex = num;
  UPDATE datosexa SET totalpagar=((totalexa*(1+descuento/100))+cargoadi) where numerex = num;
  UPDATE datosexa SET saldo = (totalpagar - pagado) where numerex = num;
  CLOSE caltotor;
END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for calcule_total_pagos
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `calcule_total_pagos`(IN num INTEGER)
BEGIN
  DECLARE totpaid DOUBLE DEFAULT 0.00;
  DECLARE caltotor CURSOR FOR SELECT sum(monto) FROM pagos where pagos.numerex=num; 
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET totpaid = 0.00;

  OPEN caltotor;
  FETCH caltotor INTO totpaid;
  IF totpaid IS NULL THEN
	SET totpaid = 0.00;
  END IF;
  UPDATE datosexa SET pagado=totpaid WHERE numerex = num;
  UPDATE datosexa SET saldo = (totalpagar - pagado) where numerex = num;
  CLOSE caltotor;
END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for cierre_caja
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `cierre_caja`(IN quien CHAR(15))
BEGIN
  CREATE TABLE IF NOT EXISTS cajahist like caja;
  INSERT INTO cajahist SELECT * FROM caja WHERE usuario=quien;
  DELETE FROM CAJA WHERE usuario=quien;
END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for inserte_resultados
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `inserte_resultados`(IN num INTEGER, IN codi CHAR(4), IN exaid INTEGER)
BEGIN
  DECLARE cod_tmp CHAR(4);
  DECLARE num_tmp INTEGER DEFAULT 0;	
  DECLARE exa_tmp INTEGER DEFAULT 0;
  DECLARE cli_tmp INTEGER DEFAULT 0;
  DECLARE sex_tmp CHAR(1);
  DECLARE edad_tmp DOUBLE DEFAULT 0.00;
  DECLARE lang_tmp CHAR(2);
  DECLARE done INTEGER DEFAULT 0;

  DECLARE cur1 CURSOR FOR SELECT `examenes`.`CODIEX`,`examenes`.`NUMEREX`,`examenes`.`EXAMENID`,`datosexa`.`NUMEROCLI`,
    `datosexa`.`IDIOMA`,`pacientes`.`SEXO`, `pacientes`.`edad` 
    FROM `examenes` INNER JOIN `datosexa` ON (`examenes`.`NUMEREX` = `datosexa`.`NUMEREX`)
    INNER JOIN `pacientes` ON (`datosexa`.`NUMEROCLI` = `pacientes`.`NUMEROCLI`)
    WHERE (`examenes`.`NUMEREX` = num);
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  
  OPEN cur1;
  
  REPEAT
    FETCH cur1 INTO cod_tmp, num_tmp, exa_tmp, cli_tmp, lang_tmp, sex_tmp, edad_tmp;
    IF ((done = 0) AND (STRCMP(cod_tmp,codi)=0))  THEN
      CREATE TEMPORARY TABLE tmpdefaults COLLATE latin1_general_ci SELECT id, examenid, codiex, idioma, sexo, edadmin, edadmax, secuencia, tiporesult, 
        imprime, bandera, leyenda, resultado, unidades, normales, minimo, maximo, panicminimo, panicmaximo, imposiblemin,
	imposiblemax,mnemonic, negrita, italica, subrayado, fuente, tamano, fechamod, status, variable, comparable, formula,
	alineacion
	FROM defaults 
	WHERE defaults.codiex=cod_tmp COLLATE latin1_general_ci 
	AND defaults.idioma=lang_tmp COLLATE latin1_general_ci
        AND (edad_tmp BETWEEN defaults.edadmin AND defaults.edadmax)
	AND (defaults.sexo=sex_tmp COLLATE latin1_general_ci OR defaults.sexo= 'A' COLLATE latin1_general_ci); 
      UPDATE tmpdefaults SET examenid=exaid, id=0, fechamod=NOW(), status='E' COLLATE latin1_general_ci;
      INSERT INTO resultados SELECT * from tmpdefaults;
      DROP TEMPORARY TABLE tmpdefaults;
      SET done=1;
    END IF;
  UNTIL done END REPEAT;
  CLOSE cur1;

END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for llenarexamen
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `llenarexamen`(INOUT codi CHAR(4), INOUT nom VARCHAR(30), INOUT price DOUBLE, INOUT pruebatipo CHAR(1))
BEGIN
  DECLARE cod_tmp CHAR(4);
  DECLARE done INTEGER DEFAULT 0;
  DECLARE cur1 CURSOR FOR SELECT direxame.codiex,direxame.nombrexa, direxame.precio, direxame.u FROM direxame where
    direxame.codiex = codi COLLATE latin1_general_ci;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  OPEN cur1;

  REPEAT	
    FETCH cur1 INTO cod_tmp, nom, price, pruebatipo;
    IF (STRCMP(codi,cod_tmp)=0) THEN
      SET done = 1;
    END IF; 
  UNTIL done END REPEAT;

  CLOSE cur1;

END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for llenarpresupuesto
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `llenarpresupuesto`(INOUT codi CHAR(4), INOUT nom VARCHAR(30), INOUT price DOUBLE, INOUT pruebatipo CHAR(1))
BEGIN
  DECLARE cod_tmp CHAR(4);
  DECLARE done INTEGER DEFAULT 0;
  DECLARE cur1 CURSOR FOR SELECT direxame.codiex,direxame.nombrexa, direxame.precio, direxame.u FROM direxame where
    direxame.codiex = codi COLLATE latin1_general_ci;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  OPEN cur1;

  REPEAT	
    FETCH cur1 INTO cod_tmp, nom, price, pruebatipo;
    IF (STRCMP(codi,cod_tmp)=0) THEN
      SET done = 1;
    END IF; 
  UNTIL done END REPEAT;
  CLOSE cur1;

END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for status_orden
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `status_orden`(IN nume INTEGER)
BEGIN
  DECLARE cuantos INTEGER DEFAULT 0;	
  DECLARE ordencur CURSOR FOR SELECT count(status) from examenes where (status='E') AND numerex=nume;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET cuantos = 0;

  OPEN ordencur;
  FETCH ordencur INTO cuantos;
  IF (cuantos = 0) THEN
	UPDATE datosexa SET fechafin=NOW(), fechamod=NOW(), status='F' where numerex=nume;
  ELSE
        UPDATE datosexa SET fechamod=NOW(), status='M' where numerex=nume;
  END IF;
  CLOSE ordencur;
END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for sub_to_caja
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `sub_to_caja`(IN pnum INTEGER)
BEGIN
  
  CREATE TEMPORARY TABLE tmpcaja SELECT * FROM pagos WHERE pagos.pagonum=pnum;
  UPDATE tmpcaja SET pagonum=0, monto=monto*(-1.00), tipomov='CR';
  INSERT INTO caja SELECT * FROM tmpcaja;
  DROP TEMPORARY TABLE tmpcaja;
  
END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for sustituya_meta
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `sustituya_meta`(IN num INTEGER)
BEGIN
  DECLARE eid INTEGER;
  DECLARE nume INTEGER;
  DECLARE cod_tmp CHAR(4);
  DECLARE cod_tmp2 CHAR(4);
  DECLARE expa_tmp CHAR(4);
  DECLARE pre_tmp DOUBLE;
  DECLARE tipo_tmp CHAR(1);
  DECLARE done INTEGER DEFAULT 0;
  DECLARE cur0 CURSOR FOR SELECT examenid,numerex, codiex, u from examenes where (numerex=num AND u="M");
  DECLARE cur1 CURSOR FOR SELECT metacodiex, expandcode, precio from metaexas;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  
  OPEN cur0;

  REPEAT	
    FETCH cur0 INTO eid, nume, cod_tmp, tipo_tmp;
    IF done = 0 THEN
      OPEN cur1;
      REPEAT
        FETCH cur1 into cod_tmp2, expa_tmp, pre_tmp;
        IF ((STRCMP(cod_tmp,cod_tmp2)=0) AND (done=0)) THEN
          INSERT INTO examenes (numerex, codiex) VALUES (nume, expa_tmp);
          UPDATE examenes SET precio=pre_tmp where numerex=nume and codiex like expa_tmp collate latin1_general_ci;
        END IF; 
      UNTIL done END REPEAT;
      SET done=0;
      CLOSE cur1;
    END IF; 
    DELETE from examenes where (examenid = binary eid);
  UNTIL done END REPEAT;


  CLOSE cur0;

END;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for update_status
-- ----------------------------
DELIMITER ;;
CREATE DEFINER=`root`@`localhost` PROCEDURE `update_status`(IN exaid INTEGER)
BEGIN
  DECLARE cuantos INTEGER DEFAULT 0;
  DECLARE tmpstatus CHAR(1) DEFAULT 'M';
  DECLARE resucur CURSOR FOR SELECT count(status) FROM resultados where status='E' AND (TIPORESULT='C' OR TIPORESULT='N') AND examenid=exaid AND
	CHAR_LENGTH(TRIM(RESULTADO)) = 0; 
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET cuantos = 0;
  
  OPEN resucur;
  FETCH resucur INTO cuantos;
  IF (cuantos = 0) THEN
	UPDATE examenes SET fechafin=NOW(), fechamod=NOW(), status='F', imprime=1 where examenid=exaid;
  ELSE
        UPDATE examenes SET fechamod=NOW(), status='M' where examenid=exaid;
  END IF;
  CLOSE resucur;

END;;
DELIMITER ;

-- ----------------------------
-- Records 
-- ----------------------------
INSERT INTO `cias` VALUES ('0', 'NO TIENE ASIGNADA', null, null, null, null, null, null, null, null, null, null, null, null, null, '458.16');
INSERT INTO `defaults` VALUES ('1', '0', '001', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'HECES GENERAL', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:22:27', null, null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('2', '0', '001', 'ES', 'A', '0.00', '99.99', '300', 'C', 'S', null, 'Consistencia........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', null, null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('3', '0', '001', 'ES', 'A', '0.00', '99.99', '400', 'C', 'S', null, 'Color...............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', null, null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('4', '0', '001', 'ES', 'A', '0.00', '99.99', '500', 'C', 'S', null, 'pH..................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('5', '0', '001', 'ES', 'A', '0.00', '99.99', '600', 'C', 'S', null, 'Parásitos...........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('6', '0', '001', 'ES', 'A', '0.00', '99.99', '700', 'C', 'S', null, 'Método..............:', 'DIRECTO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 10:42:08', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('7', '0', '001', 'ES', 'A', '0.00', '99.99', '800', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('8', '0', '002', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'FROTIS DE HECES', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('9', '0', '002', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', null, 'Leucocitos..........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1470', '0', '128', 'ES', 'A', '0.00', '99.99', '70300', 'T', 'S', '', 'ANTIGENOS FEBRILES', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 07:28:10', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1589', '0', '028', 'ES', 'M', '0.00', '99.99', '1300', 'N', 'S', null, 'Grado 1+.................:', null, '%', '(sin desplazamiento)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 10:48:38', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('14', '0', '002', 'ES', 'A', '0.00', '99.99', '700', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$F', '0', null, 'L');
INSERT INTO `defaults` VALUES ('15', '0', '003', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', '', 'Tripsina en Heces', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('16', '0', '004', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'Grasas en Heces.....:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('17', '0', '004', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('18', '0', '005', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'Azucares Reductores :', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', null, '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('19', '0', '006', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'pH de Heces.........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('20', '0', '007', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'Sangre Oculta(Heces):', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 11:00:53', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('21', '0', '007', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('22', '0', '008', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'ORINA GENERAL', null, null, null, '0', '0', '0', '0', '0', '0', null, '1', null, '1', '1', '10', '2007-02-07 12:15:03', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('23', '0', '008', 'ES', 'A', '0.00', '99.99', '200', 'T', 'S', null, 'FISICO', null, null, null, '0', '0', '0', '0', '0', '0', null, null, null, '1', '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('24', '0', '008', 'ES', 'A', '0.00', '99.99', '300', 'C', 'S', null, 'Color...............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('25', '0', '008', 'ES', 'A', '0.00', '99.99', '400', 'C', 'S', null, 'Aspecto.............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('26', '0', '008', 'ES', 'A', '0.00', '99.99', '500', 'C', 'S', null, 'Gravedad Especifica :', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('27', '0', '008', 'ES', 'A', '0.00', '99.99', '600', 'T', 'S', null, 'QUIMICO', null, null, null, '0', '0', '0', '0', '0', '0', null, null, null, '1', '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('28', '0', '008', 'ES', 'A', '0.00', '99.99', '700', 'C', 'S', null, 'pH..................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('29', '0', '008', 'ES', 'A', '0.00', '99.99', '800', 'C', 'S', null, 'Albumina............:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$E', '0', null, 'L');
INSERT INTO `defaults` VALUES ('31', '0', '008', 'ES', 'A', '0.00', '99.99', '1000', 'C', 'S', null, 'Glucosa.............:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$G', '0', null, 'L');
INSERT INTO `defaults` VALUES ('32', '0', '008', 'ES', 'A', '0.00', '99.99', '1100', 'C', 'S', null, 'Cetona..............:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', null, '$H', '0', null, 'L');
INSERT INTO `defaults` VALUES ('33', '0', '008', 'ES', 'A', '0.00', '99.99', '1200', 'C', 'S', null, 'Sangre oculta.......:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$I', '0', null, 'L');
INSERT INTO `defaults` VALUES ('34', '0', '008', 'ES', 'A', '0.00', '99.99', '1300', 'C', 'S', null, 'Bilis...............:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$J', '0', null, 'L');
INSERT INTO `defaults` VALUES ('35', '0', '008', 'ES', 'A', '0.00', '99.99', '1400', 'C', 'S', null, 'Urobilinógeno.......:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$K', '0', null, 'L');
INSERT INTO `defaults` VALUES ('36', '0', '008', 'ES', 'A', '0.00', '99.99', '1500', 'C', 'S', null, 'Nitrito.............:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$L', '0', null, 'L');
INSERT INTO `defaults` VALUES ('37', '0', '008', 'ES', 'A', '0.00', '99.99', '1600', 'C', 'S', null, 'Pigmentos Biliares..:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$M', '0', null, 'L');
INSERT INTO `defaults` VALUES ('38', '0', '008', 'ES', 'A', '0.00', '99.99', '1700', 'T', 'S', null, 'MICROSCOPICO', null, null, null, '0', '0', '0', '0', '0', '0', null, null, null, '1', '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('39', '0', '008', 'ES', 'A', '0.00', '99.99', '1800', 'C', 'S', null, 'Leucocitos..........:', null, '/Campo', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$N', '0', null, 'L');
INSERT INTO `defaults` VALUES ('40', '0', '008', 'ES', 'A', '0.00', '99.99', '1900', 'C', 'S', null, 'Leucocitos(Grumos)..:', 'NO SE OBSERVAN', '/campo         ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$O', '0', null, 'L');
INSERT INTO `defaults` VALUES ('41', '0', '008', 'ES', 'A', '0.00', '99.99', '2000', 'C', 'S', null, 'Eritrocitos.........:', 'NO SE OBSERVAN', '/campo         ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$P', '0', null, 'L');
INSERT INTO `defaults` VALUES ('42', '0', '008', 'ES', 'A', '0.00', '99.99', '2100', 'C', 'S', null, 'Cilindros...........:', 'NO SE OBSERVAN', '/campo         ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$Q', '0', null, 'L');
INSERT INTO `defaults` VALUES ('43', '0', '008', 'ES', 'A', '0.00', '99.99', '2200', 'C', 'S', null, 'Cilindroides........:', 'NO SE OBSERVAN', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$R', '0', null, 'L');
INSERT INTO `defaults` VALUES ('44', '0', '008', 'ES', 'A', '0.00', '99.99', '2300', 'C', 'S', null, 'Cristales...........:', 'NO SE OBSERVAN', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$S', '0', null, 'L');
INSERT INTO `defaults` VALUES ('45', '0', '008', 'ES', 'A', '0.00', '99.99', '2400', 'C', 'S', null, 'Celulas Epiteliales.:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$U', '0', null, 'L');
INSERT INTO `defaults` VALUES ('46', '0', '008', 'ES', 'A', '0.00', '99.99', '2500', 'C', 'S', null, 'Mucosidades.........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$V', '0', null, 'L');
INSERT INTO `defaults` VALUES ('47', '0', '008', 'ES', 'A', '0.00', '99.99', '2600', 'C', 'S', null, 'Sedimento Amorfo....:', 'NO SE OBSERVA', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$X', '0', null, 'L');
INSERT INTO `defaults` VALUES ('48', '0', '008', 'ES', 'A', '0.00', '99.99', '2700', 'C', 'S', null, 'Bacterias...........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$Y', '0', null, 'L');
INSERT INTO `defaults` VALUES ('49', '0', '008', 'ES', 'A', '0.00', '99.99', '2800', 'C', 'S', null, 'Espermatozoides.....:', 'NO SE OBSERVAN', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$Z', '0', null, 'L');
INSERT INTO `defaults` VALUES ('50', '0', '008', 'ES', 'A', '0.00', '99.99', '2900', 'C', 'S', null, 'Parásitos...........:', 'NO SE OBSERVAN', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', null, '$A1', '0', null, 'L');
INSERT INTO `defaults` VALUES ('51', '0', '008', 'ES', 'A', '0.00', '99.99', '3000', 'C', 'S', null, 'Hongos..............:', 'NO SE OBSERVAN', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B1', '0', null, 'L');
INSERT INTO `defaults` VALUES ('52', '0', '008', 'ES', 'A', '0.00', '99.99', '3100', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$C1', '0', null, 'L');
INSERT INTO `defaults` VALUES ('53', '0', '009', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'TINTE DE SEDIMENTO', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('54', '0', '009', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', '', 'Resultado', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('55', '0', '010', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'PRUEBAS METABOLICAS EN ORINA', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('56', '0', '010', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', '', 'pH', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('57', '0', '010', 'ES', 'A', '0.00', '99.99', '300', 'C', 'S', '', 'Azucares reductores', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('58', '0', '010', 'ES', 'A', '0.00', '99.99', '400', 'C', 'S', '', 'Glucosa', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('59', '0', '010', 'ES', 'A', '0.00', '99.99', '500', 'C', 'S', '', 'Cloruro Ferrico', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('60', '0', '010', 'ES', 'A', '0.00', '99.99', '600', 'C', 'S', '', 'Dinitrofenilhidrazina', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$E', '0', null, 'L');
INSERT INTO `defaults` VALUES ('61', '0', '010', 'ES', 'A', '0.00', '99.99', '700', 'C', 'S', '', 'Cianuro de Nitroprusiato', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '0', null, 'L');
INSERT INTO `defaults` VALUES ('62', '0', '010', 'ES', 'A', '0.00', '99.99', '800', 'C', 'S', '', 'Nitrosonaftol', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$G', '0', null, 'L');
INSERT INTO `defaults` VALUES ('63', '0', '010', 'ES', 'A', '0.00', '99.99', '900', 'C', 'S', '', 'Cuerpos Cetonicos', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$H', '0', null, 'L');
INSERT INTO `defaults` VALUES ('64', '0', '010', 'ES', 'A', '0.00', '99.99', '1000', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$I', '0', null, 'L');
INSERT INTO `defaults` VALUES ('65', '0', '011', 'ES', 'A', '4.00', '6.99', '100', 'T', 'S', '', 'MUCOPOLISACARIDOS EN ORINA', '', '', '', '-99999.99', '338', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('66', '0', '011', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', '', 'Mucopolisacaridos', '', 'mg/dl          ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('67', '0', '011', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', '', 'Creatinina', '', 'mg/dl          ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('68', '0', '011', 'ES', 'A', '4.00', '6.99', '400', 'F', 'S', '', 'Resultado corregido', 'A/B/1000', 'mg/g.Creat.    ', '( Hasta 338 )', '0', '338', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL01', '0', '$A/$B/1000', 'R');
INSERT INTO `defaults` VALUES ('69', '0', '011', 'ES', 'A', '7.00', '11.99', '405', 'F', 'S', '', 'Resultado corregido', 'A/B/1000', 'mg/g.Creat.    ', '( Hasta 235 )', '0', '235', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL01', '0', '$A/$B/1000', 'R');
INSERT INTO `defaults` VALUES ('70', '0', '011', 'ES', 'A', '12.00', '99.99', '410', 'F', 'S', '', 'Resultado corregido', 'A/B/1000', 'mg/g.Creat.    ', '( Hasta 180 )', '0', '180', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL01', '0', '$A/$B/1000', 'R');
INSERT INTO `defaults` VALUES ('71', '0', '012', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'PRUEBA PRECOZ DE EMBARAZO EN O', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('72', '0', '012', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', '', 'Resultado', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('73', '0', '012', 'ES', 'A', '0.00', '99.99', '300', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('74', '0', '013', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'PRUEBA DE EMBARAZO EN ORINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('75', '0', '013', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', '', 'U.C.G', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('76', '0', '013', 'ES', 'A', '0.00', '99.99', '300', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('78', '0', '014', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', null, 'HCG-Cualitativa(orina):', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', null, '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('80', '0', '015', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'CREATINURIA/ 24 HRS', null, null, null, '0.8', '2.8', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 08:10:33', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('81', '0', '015', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Creatinina...................:', null, 'mg/dl   ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 11:08:58', null, '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('82', '0', '015', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Volumen (L)..................:', null, 'L/24 Hrs      ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 08:45:53', 'E', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('83', '0', '016', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'URICOSURIA/24 HRS.', null, '    ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-12 08:12:11', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('84', '0', '016', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Acido urico..................:', null, 'mg/dl    ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 06:59:59', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('85', '0', '016', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Volumen en dl................:', null, 'dl/24 Hrs      ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 08:48:30', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('86', '0', '016', 'ES', 'A', '0.00', '99.99', '400', 'F', 'S', null, 'Uricosuria 24 Hrs............:', 'A*B/100', 'mg/24 Hrs      ', '(250-750)', '250', '750', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 08:48:48', 'M', '$CAL03', '0', '$A*$B', 'R');
INSERT INTO `defaults` VALUES ('87', '0', '017', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'CALCIURIA 24 HRS', null, null, null, '-99999.99', '-99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-12 08:06:02', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('88', '0', '017', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Calcio.......................:', null, 'mg/dl    ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 07:37:20', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('89', '0', '017', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Volumen en dl................:', null, 'dl/24 Hrs     ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 08:50:04', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('90', '0', '018', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'FOSFATURIA /24 HRS', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-12 08:15:45', 'E', '$CAL05', '0', null, 'L');
INSERT INTO `defaults` VALUES ('91', '0', '018', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Fósforo......................:', null, 'gr/24 Hrs.     ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 08:51:01', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('92', '0', '018', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Volumen en dl................:', null, 'dl/24 Hrs      ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 08:51:44', 'E', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('93', '0', '019', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'PROTEINURIA 24 HRS', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-12 09:50:43', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('94', '0', '019', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Proteinuria..................:', null, 'mg/100 ml      ', '( menos de 5 )', '0', '5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 11:04:49', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('95', '0', '019', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Volumen......................:', null, 'ml/24 Hrs     ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 09:53:27', 'E', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('96', '0', '019', 'ES', 'A', '0.00', '99.99', '400', 'F', 'S', null, 'Proteinuria 24 Hrs...........:', null, 'mg/24 Hrs     ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 09:59:40', 'E', '$CAL06', '1', '$A*$B', 'R');
INSERT INTO `defaults` VALUES ('97', '0', '020', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Amilasuria 2hs...............:', null, 'U/L', '( 32 - 641 )', '32', '641', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 12:18:55', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('98', '0', '020', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:12:47', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('99', '0', '021', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'PLOMO EN ORINA 24HRS', '', '', '', '-99999.99', '100', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('100', '0', '021', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', '', 'Plomo Orina', '', 'ÃƒÂ¦g/dl.      ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('101', '0', '021', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', '', 'Volumen', '', 'ÃƒÂ¦g/24hs     ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('102', '0', '021', 'ES', 'A', '0.00', '99.99', '400', 'F', 'S', '', 'Plomo en orina 24Hrs.', 'A*B/100', 'ÃƒÂ¦g/24hs     ', '( < 100 )', '0', '100', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL07', '0', '$A*$B/100', 'R');
INSERT INTO `defaults` VALUES ('103', '0', '021', 'ES', 'A', '0.00', '99.99', '500', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'L');
INSERT INTO `defaults` VALUES ('104', '0', '022', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'DEPURACION DE CREATININA', null, '               ', ' ', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('105', '0', '022', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Creatinina(Orina)............:', null, 'mg/dl          ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 11:35:45', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('106', '0', '022', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Creatinina Suero.............:', null, 'mg/dl          ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 12:33:08', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('107', '0', '022', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'Volumen en ml/24 Hrs.........:', null, 'ml/24 Hrs    ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 09:38:09', 'E', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('108', '0', '022', 'ES', 'A', '0.00', '99.99', '600', 'F', 'S', null, 'Depuración de Creatinina.....:', '(C/1440)*A/B', 'ml/minuto      ', '( 61 - 166 )', '61', '166', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 07:11:59', 'M', '$CAL09', '0', '($A*$C/1440)/$B', 'R');
INSERT INTO `defaults` VALUES ('109', '0', '022', 'ES', 'A', '0.00', '99.99', '700', 'O', 'S', null, 'OBSERVACIONES................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 07:11:36', 'E', '$E', '0', null, 'L');
INSERT INTO `defaults` VALUES ('110', '0', '023', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'PRUEBAS TAMIZ PARA P.K.U.', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('111', '0', '023', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', '', 'Cloruro Ferrico', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('112', '0', '023', 'ES', 'A', '0.00', '99.99', '300', 'C', 'S', '', 'Dinitrofenilhidrazina', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('113', '0', '023', 'ES', 'A', '0.00', '99.99', '400', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('114', '0', '024', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'Bilis en Orina......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('115', '0', '025', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'Cetonas en orina....:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('116', '0', '026', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', '', 'Cromatografia de Aminoacidos', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1607', '0', '028', 'ES', 'M', '0.00', '99.99', '1800', 'N', 'S', null, 'Recuento Espermático/ml..:', null, 'ml', '( Mayor de 20 X 10*)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 12:11:05', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('118', '0', '028', 'ES', 'M', '0.00', '99.99', '100', 'T', 'S', null, 'ESPERMOGRAMA', null, null, null, '0', '0', '0', '0', '0', '0', null, '1', null, '1', '1', '16', '2007-02-16 10:01:57', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('119', '0', '028', 'ES', 'M', '0.00', '99.99', '500', 'N', 'S', null, 'Color....................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 10:05:30', 'E', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('120', '0', '028', 'ES', 'M', '0.00', '99.99', '600', 'N', 'S', null, 'Volumen..................:', null, 'ml        ', '( 1.5    -     5.0 )    ', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 13:29:29', 'E', '$B', '1', null, 'L');
INSERT INTO `defaults` VALUES ('121', '0', '028', 'ES', 'M', '0.00', '99.99', '700', 'N', 'S', null, 'Ph.......................:', null, null, '( 7.0    -     8.3 )', '7', '8.3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 10:03:59', 'E', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1587', '0', '028', 'ES', 'M', '0.00', '99.99', '1000', 'T', 'S', null, 'EXAMEN MICROSCOPICO', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '12', '2007-02-16 10:07:11', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('123', '0', '028', 'ES', 'M', '0.00', '99.99', '800', 'N', 'S', null, 'Licuefacción.............:', null, null, '( Antes de 1 Hora  )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 10:04:41', 'E', '$E', '0', null, 'L');
INSERT INTO `defaults` VALUES ('124', '0', '028', 'ES', 'M', '0.00', '99.99', '900', 'N', 'S', null, 'Viscosidad...............:', null, null, '(      Normal      )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 13:30:37', 'E', '$F', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1588', '0', '028', 'ES', 'A', '0.00', '99.99', '1100', 'T', 'S', null, 'MOTILIDAD ESPERMATICA', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 13:38:43', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1586', '0', '028', 'ES', 'M', '0.00', '99.99', '400', 'T', 'S', null, 'EXAMEN MACROSCOPICO', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '12', '2007-02-16 10:02:32', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1585', '0', '028', 'ES', 'M', '0.00', '99.99', '300', 'N', 'S', null, 'Hora de Recolección......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 09:59:33', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1584', '0', '028', 'ES', 'M', '0.00', '99.99', '200', 'N', 'S', null, 'Días de Abstinencia......:', null, 'Días', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 09:58:34', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('138', '0', '029', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'ANALISIS DE CALCULO', null, null, null, '0', '0', '0', '0', '0', '0', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('139', '0', '029', 'ES', 'A', '0.00', '99.99', '200', 'T', 'S', null, 'EXAMEN FISICO', null, null, null, '0', '0', '0', '0', '0', '0', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('140', '0', '029', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Dimensiones..................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 11:37:12', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('141', '0', '029', 'ES', 'A', '0.00', '99.99', '400', 'C', 'S', null, 'Color...............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('142', '0', '029', 'ES', 'A', '0.00', '99.99', '500', 'C', 'S', null, 'Textura.............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('143', '0', '029', 'ES', 'A', '0.00', '99.99', '600', 'C', 'S', null, 'Consistencia........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('145', '0', '029', 'ES', 'A', '0.00', '99.99', '800', 'C', 'S', '', 'Otros Hallazgos', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '0', null, 'L');
INSERT INTO `defaults` VALUES ('146', '0', '029', 'ES', 'A', '0.00', '99.99', '900', 'T', 'S', null, 'COMPOSICION QUIMICA', null, null, null, '0', '0', '0', '0', '0', '0', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('147', '0', '029', 'ES', 'A', '0.00', '99.99', '1000', 'C', 'S', null, 'Acido Urico.........:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$G', '0', null, 'L');
INSERT INTO `defaults` VALUES ('148', '0', '029', 'ES', 'A', '0.00', '99.99', '1100', 'C', 'S', null, 'Fosfatos............:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$H', '0', null, 'L');
INSERT INTO `defaults` VALUES ('149', '0', '029', 'ES', 'A', '0.00', '99.99', '1200', 'C', 'S', null, 'Carbonatos..........:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$I', '0', null, 'L');
INSERT INTO `defaults` VALUES ('150', '0', '029', 'ES', 'A', '0.00', '99.99', '1300', 'C', 'S', null, 'Oxalato de Calcio...:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$J', '0', null, 'L');
INSERT INTO `defaults` VALUES ('151', '0', '029', 'ES', 'A', '0.00', '99.99', '1400', 'C', 'S', null, 'Calcio Libre........:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$K', '0', null, 'L');
INSERT INTO `defaults` VALUES ('152', '0', '029', 'ES', 'A', '0.00', '99.99', '1500', 'C', 'S', null, 'Magnesio............:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', null, '$L', '0', null, 'L');
INSERT INTO `defaults` VALUES ('153', '0', '029', 'ES', 'A', '0.00', '99.99', '1600', 'C', 'S', null, 'Sulfatos............:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$M', '0', null, 'L');
INSERT INTO `defaults` VALUES ('154', '0', '029', 'ES', 'A', '0.00', '99.99', '1700', 'C', 'S', null, 'Amonio..............:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$N', '0', null, 'L');
INSERT INTO `defaults` VALUES ('155', '0', '029', 'ES', 'A', '0.00', '99.99', '1800', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$O', '0', null, 'L');
INSERT INTO `defaults` VALUES ('156', '0', '030', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'HEMOGRAMA', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', null, null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('157', '0', '030', 'ES', 'A', '0.17', '9.99', '200', 'N', 'S', null, 'Hemoglobina..................:', null, 'g/ml           ', '( 10.0-12.6 )', '10', '12.6', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 11:59:26', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('158', '0', '030', 'ES', 'A', '10.00', '14.99', '300', 'N', 'S', null, 'Hemoglobina..................:', null, 'g/ml           ', '( 11.7-14.1 )', '11.7', '14.1', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:00:11', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('159', '0', '030', 'ES', 'F', '15.00', '99.99', '400', 'N', 'S', null, 'Hemoglobina..................:', null, 'g/ml           ', '( 12.5-14.8 )', '12.5', '14.8', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 13:12:10', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('160', '0', '030', 'ES', 'M', '15.00', '99.99', '500', 'N', 'S', null, 'Hemoglobina..................:', null, 'g/ml           ', '( 14.3-17.0 )', '14.3', '17', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:01:38', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('161', '0', '030', 'ES', 'A', '0.16', '14.99', '600', 'N', 'S', null, 'Hematocrito...................', null, '%              ', '( 34.0-39.0 )', '34', '39', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:02:31', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('162', '0', '030', 'ES', 'F', '15.00', '99.99', '700', 'N', 'S', null, 'Hematocrito..................:', null, '%              ', '( 38.0-47.0 )', '38', '47', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:03:22', '', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('163', '0', '030', 'ES', 'M', '15.00', '99.99', '800', 'N', 'S', null, 'Hematocrito..................:', null, '%              ', '( 42.0-54.0 )', '42', '54', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:04:01', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('164', '0', '030', 'ES', 'A', '0.16', '9.99', '900', 'N', 'S', null, 'Eritrocitos..................:', null, 'millones/mm3   ', '( 3.7 - 4.4 )', '3.7', '4.4', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:05:17', '', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('165', '0', '030', 'ES', 'A', '10.00', '14.99', '1000', 'N', 'S', null, 'Eritrocitos..................:', null, 'millones/mm3   ', '( 3.7 - 4.5 )', '3.7', '4.5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:06:13', '', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('166', '0', '030', 'ES', 'F', '15.00', '99.99', '1100', 'N', 'S', null, 'Eritrocitos..................:', null, 'millones/mm3   ', '( 4.0 - 5.3 )', '4', '5.3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:06:51', '', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('167', '0', '030', 'ES', 'M', '15.00', '99.99', '1200', 'N', 'S', null, 'Eritrocitos..................:', null, 'millones/mm3   ', '( 4.5 - 6.5 )', '4.5', '6.5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:07:21', '', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('168', '0', '030', 'ES', 'A', '0.00', '99.99', '1300', 'F', 'S', null, 'CHCM.........................:', 'A*100/B', '%              ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 16:56:27', '', '$CAL1', '0', '$A*100/$B', 'R');
INSERT INTO `defaults` VALUES ('169', '0', '030', 'ES', 'A', '0.21', '99.99', '1400', 'F', 'S', null, 'HCM..........................:', 'A*10/C', 'pg             ', '( 28.0-34.0 )', '28', '34', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 13:13:52', '', '$CAL1', '0', '$A*10/$C', 'R');
INSERT INTO `defaults` VALUES ('170', '0', '030', 'ES', 'A', '0.00', '99.99', '1500', 'F', 'S', null, 'VCM..........................:', 'B*10/C', 'fl             ', '( 80.0-100.0)', '80', '100', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:09:59', '', '$CAL1', '0', '$B*10/$C', 'R');
INSERT INTO `defaults` VALUES ('171', '0', '030', 'ES', 'A', '0.00', '0.20', '1600', 'N', 'S', null, 'Leucocitos...................:', null, 'mm3            ', '(10000-12000)', '10000', '12000', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-07 06:34:08', '', '$D', '0', null, 'R');
INSERT INTO `defaults` VALUES ('172', '0', '030', 'ES', 'A', '0.21', '9.99', '1700', 'N', 'S', null, 'Leucocitos...................:', null, 'mm3            ', '( 5000-14000)', '5000', '14000', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:11:47', '', '$D', '0', null, 'R');
INSERT INTO `defaults` VALUES ('173', '0', '030', 'ES', 'A', '10.00', '99.99', '1800', 'N', 'S', null, 'Leucocitos...................:', null, 'mm3            ', '( 5000-10000)', '5000', '10000', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:12:19', '', '$D', '0', null, 'R');
INSERT INTO `defaults` VALUES ('174', '0', '030', 'ES', 'A', '0.00', '99.99', '1900', 'N', 'N', null, 'Mieloblastos.................:', '0.0', '%', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 07:07:35', 'M', '$R', '0', null, 'R');
INSERT INTO `defaults` VALUES ('175', '0', '030', 'ES', 'A', '0.00', '99.99', '2000', 'N', 'N', null, 'Promielocitos................:', '0.0', '%', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 07:08:00', 'M', '$S', '0', null, 'R');
INSERT INTO `defaults` VALUES ('176', '0', '030', 'ES', 'A', '0.00', '99.99', '2100', 'N', 'N', null, 'Mielocitos...................:', '0.0', '%              ', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 12:52:15', 'M', '$G', '1', null, 'R');
INSERT INTO `defaults` VALUES ('177', '0', '030', 'ES', 'A', '0.00', '99.99', '2200', 'N', 'N', null, 'Metamielocitos...............:', ' 0.0 ', '%              ', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 12:51:46', 'M', '$H', '1', null, 'R');
INSERT INTO `defaults` VALUES ('178', '0', '030', 'ES', 'A', '0.00', '0.10', '2300', 'N', 'S', null, 'En Banda.....................:', '0.0', '%              ', '( 1.0 - 5.0  )', '1', '5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:14:49', '', '$I', '1', null, 'R');
INSERT INTO `defaults` VALUES ('179', '0', '030', 'ES', 'A', '0.11', '99.99', '2400', 'N', 'S', null, 'En Banda.....................:', '0.0', '%              ', '( 0.0 - 3.0 )', '-99999.99', '3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 13:16:51', '', '$I', '1', null, 'R');
INSERT INTO `defaults` VALUES ('180', '0', '030', 'ES', 'A', '0.00', '0.08', '2500', 'N', 'S', null, 'Neutrofilos..................:', null, '%              ', '( 17.0-37.0 )', '17', '37', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:16:26', '', '$J', '1', null, 'R');
INSERT INTO `defaults` VALUES ('181', '0', '030', 'ES', 'A', '4.00', '9.99', '2600', 'N', 'S', null, 'Neutrofilos..................:', null, '%              ', '( 35.0-65.0 )', '35', '65', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:17:11', '', '$J', '1', null, 'R');
INSERT INTO `defaults` VALUES ('182', '0', '030', 'ES', 'A', '0.09', '3.99', '2600', 'N', 'S', null, 'Neutrofilos..................:', null, '%              ', '( 28.0-50.0 )', '28', '50', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 12:54:00', 'E', '$J', '1', null, 'R');
INSERT INTO `defaults` VALUES ('183', '0', '030', 'ES', 'A', '10.00', '15.99', '2700', 'N', 'S', null, 'Neutrofilos..................:', null, '%              ', '( 38.0-68.0 )', '38', '68', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:18:03', '', '$J', '1', null, 'R');
INSERT INTO `defaults` VALUES ('184', '0', '030', 'ES', 'A', '16.00', '99.99', '2800', 'N', 'S', null, 'Neutrofilos..................:', null, '%              ', '( 40.0-70.0 )', '40', '70', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:18:51', '', '$J', '1', null, 'R');
INSERT INTO `defaults` VALUES ('185', '0', '030', 'ES', 'A', '0.00', '99.99', '2900', 'N', 'S', null, 'Eosinofilos..................:', null, '%              ', '( 1.0 - 5.0 )', '1', '5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:19:33', '', '$E', '1', null, 'R');
INSERT INTO `defaults` VALUES ('186', '0', '030', 'ES', 'A', '0.00', '99.99', '3000', 'N', 'S', null, 'Basófilos....................:', null, '%              ', '( 0.0 - 1.0 )', '-99999.99', '1', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:20:11', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('187', '0', '030', 'ES', 'A', '0.11', '3.99', '3100', 'F', 'S', null, 'TOTAL GRANULOCITOS...........:', 'F+E+J+I+H+G+S+R', '%              ', '( 29.0-59.0 )', '29', '59', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:20:54', '', '$CAL1', '0', '$F+$E+$J+$I+$H+$G+$S+$R', 'R');
INSERT INTO `defaults` VALUES ('188', '0', '030', 'ES', 'A', '4.00', '9.99', '3200', 'F', 'S', null, 'TOTAL GRANULOCITOS...........:', 'F+E+J+I+H+G+S+R', '%              ', '( 36.0-74.0 )', '36', '74', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:21:35', '', '$CAL1', '0', '$F+$E+$J+$I+$H+$G+$S+$R', 'R');
INSERT INTO `defaults` VALUES ('189', '0', '030', 'ES', 'A', '0.00', '0.10', '3300', 'F', 'S', null, 'TOTAL GRANULOCITOs...........:', 'F+E+J+I+H+G+S+R', '%              ', '( 19.0-48.0 )', '19', '48', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:22:27', '', '$CAL1', '0', '$F+$E+$J+$I+$H+$G+$S+$R', 'R');
INSERT INTO `defaults` VALUES ('190', '0', '030', 'ES', 'A', '10.00', '15.99', '3400', 'F', 'S', null, 'TOTAL GRANULOCITOS...........:', 'F+E+J+I+H+G+S+R', '%              ', '( 39.0-77.0 )', '39', '77', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:23:15', '', '$CAL1', '0', '$F+$E+$J+$I+$H+$G+$S+$R', 'R');
INSERT INTO `defaults` VALUES ('191', '0', '030', 'ES', 'A', '16.00', '99.99', '3500', 'F', 'S', null, 'TOTAL GRANULOCITOS...........:', 'F+E+J+I+H+G+S+R', '%              ', '( 41.0-79.0 )', '41', '79', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:23:53', '', '$CAL1', '0', '$F+$E+$J+$I+$H+$G+$S+$R', 'R');
INSERT INTO `defaults` VALUES ('192', '0', '030', 'ES', 'A', '0.00', '99.99', '3600', 'N', 'N', null, 'Prolinfocitos................:', '0.0', '%', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 07:08:46', 'M', '$V', '0', null, 'R');
INSERT INTO `defaults` VALUES ('193', '0', '030', 'ES', 'A', '0.00', '0.10', '3700', 'N', 'S', null, 'Linfocitos...................:', null, '%              ', '( 41.0-71.0 )', '41', '71', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:25:19', '', '$K', '1', null, 'R');
INSERT INTO `defaults` VALUES ('194', '0', '030', 'ES', 'A', '0.11', '3.99', '3800', 'N', 'S', null, 'Linfocitos...................:', null, '%              ', '( 45.0-65.0 )', '45', '65', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:25:58', '', '$K', '1', null, 'R');
INSERT INTO `defaults` VALUES ('195', '0', '030', 'ES', 'A', '4.00', '9.99', '3900', 'N', 'S', null, 'Linfocitos...................:', null, '%              ', '( 35.0-55.0 )', '35', '55', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:26:32', '', '$K', '1', null, 'R');
INSERT INTO `defaults` VALUES ('196', '0', '030', 'ES', 'A', '10.00', '15.99', '4000', 'N', 'S', null, 'Linfocitos...................:', null, '%              ', '( 25.0-45.0 )', '25', '45', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:27:16', '', '$K', '1', null, 'R');
INSERT INTO `defaults` VALUES ('197', '0', '030', 'ES', 'A', '16.00', '99.99', '4100', 'N', 'S', null, 'Linfocitos...................:', null, '%              ', '( 24.0-44.0 )', '24', '44', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:27:47', '', '$K', '1', null, 'R');
INSERT INTO `defaults` VALUES ('198', '0', '030', 'ES', 'A', '0.00', '0.10', '5000', 'N', 'S', null, 'Monocitos....................:', null, '%              ', '( 2.0  -  8.0  )', '4', '8', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:29:07', '', '$L', '1', null, 'R');
INSERT INTO `defaults` VALUES ('199', '0', '030', 'ES', 'A', '0.11', '99.99', '5100', 'N', 'S', null, 'Monocitos....................:', null, '%              ', '( 2.0 - 8.0 )', '2', '8', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 12:29:35', '', '$L', '1', null, 'R');
INSERT INTO `defaults` VALUES ('200', '0', '030', 'ES', 'A', '0.00', '99.99', '5200', 'N', 'S', null, 'Linfocitos atípicos..........:', '0.0', '%              ', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 12:55:44', 'M', '$R', '0', null, 'R');
INSERT INTO `defaults` VALUES ('201', '0', '030', 'ES', 'A', '0.00', '99.99', '5400', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 15:46:16', 'E', '$M', '0', null, 'L');
INSERT INTO `defaults` VALUES ('202', '0', '032', 'ES', 'A', '0.00', '0.20', '100', 'N', 'S', null, 'Hemoglobina..................:', null, 'g/dl           ', '( Capilar 20.0 Ã¢â‚¬â€œ 24.6 )', '38791', '24.6', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 09:32:38', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('203', '0', '032', 'ES', 'A', '0.00', '0.20', '200', 'S', 'S', null, ' Hemoglobina.................:', null, 'g/dl           ', '( Venosa  18.0 - 21.6 )', '18', '21.6', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 09:33:50', '', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('204', '0', '032', 'ES', 'A', '0.00', '0.20', '300', 'S', 'S', null, 'Hemoglobina.................: ', null, 'g/dl           ', '( Cordón  15.3 - 17.5 )', '15.3', '17.5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 09:35:08', '', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('205', '0', '032', 'ES', 'A', '0.21', '9.99', '400', 'N', 'S', null, 'Hemoglobina..................:', null, 'g/dl           ', '( 10.0 - 12.4 )', '10', '12.4', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 09:35:46', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('206', '0', '032', 'ES', 'A', '10.00', '14.99', '500', 'N', 'S', null, 'Hemoglobina..................:', null, 'g/dl           ', '( 11.7 - 14.1 )', '11.7', '14.1', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 09:36:07', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('207', '0', '032', 'ES', 'F', '15.00', '99.99', '600', 'N', 'S', null, 'Hemoglobina..................:', null, 'g/dl           ', '( 12.5 - 14.8 )', '12.5', '14.8', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 09:36:31', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('208', '0', '032', 'ES', 'M', '15.00', '99.99', '700', 'N', 'S', null, 'Hemoglobina..................:', null, 'g/dl           ', '( 14.3 - 17.0 )', '14.3', '17', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 09:36:58', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('209', '0', '033', 'ES', 'A', '0.00', '0.20', '100', 'N', 'S', '', 'Hematocrito', '', '%              ', '( Cordon  43 Ã¢â‚¬â€œ 53 )', '43', '53', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('210', '0', '033', 'ES', 'A', '0.00', '0.20', '200', 'S', 'S', '', ' ', '', '%              ', '( Venosa  51 Ã¢â‚¬â€œ 63 )', '51', '63', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('211', '0', '033', 'ES', 'A', '0.00', '0.20', '300', 'S', 'S', '', ' ', '', '%              ', '( Capilar 59 Ã¢â‚¬â€œ 72 )', '59', '72', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('212', '0', '033', 'ES', 'A', '0.21', '14.99', '400', 'N', 'S', '', 'Hematocrito', '', '%              ', '( 34 - 37 )', '34', '37', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('213', '0', '033', 'ES', 'F', '15.00', '99.99', '500', 'N', 'S', '', 'Hematocrito', '', '%              ', '( 38 - 47 )', '38', '47', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('214', '0', '033', 'ES', 'M', '15.00', '99.99', '600', 'N', 'S', '', 'Hematocrito', '', '%              ', '( 42 - 54 )', '42', '54', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('215', '0', '034', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'BLANCO Y DIFERENCIAL', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$J', '0', null, 'R');
INSERT INTO `defaults` VALUES ('216', '0', '034', 'ES', 'A', '0.00', '0.20', '200', 'N', 'S', '', 'Leucocitos', '', '/mm3           ', '( 10000 - 15000 )', '10000', '15000', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('217', '0', '034', 'ES', 'A', '0.21', '9.99', '300', 'N', 'S', '', 'Leucocitos', '', '/mm3           ', '( 5000 - 14000 )', '5000', '14000', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('218', '0', '034', 'ES', 'A', '10.00', '99.99', '400', 'N', 'S', '', 'Leucocitos', '', '/mm3           ', '( 5000 - 10000 )', '5000', '10000', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('219', '0', '034', 'ES', 'A', '0.00', '99.99', '500', 'N', 'S', '', 'Eosinofilos', '', '%              ', '( 1 - 5 )', '1', '5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('220', '0', '034', 'ES', 'A', '0.00', '99.99', '600', 'N', 'S', '', 'Basofilos', '', '%              ', '( 0 - 1 )', '-99999.99', '1', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('221', '0', '034', 'ES', 'A', '0.00', '99.99', '700', 'N', 'S', '', 'Mielocitos', '', '%              ', '( 0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '1', null, 'R');
INSERT INTO `defaults` VALUES ('222', '0', '034', 'ES', 'A', '0.00', '99.99', '800', 'N', 'S', '', 'Metamielocitos', '', '%              ', '( 0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$E', '1', null, 'R');
INSERT INTO `defaults` VALUES ('223', '0', '034', 'ES', 'A', '0.11', '99.99', '900', 'N', 'S', '', 'En Banda', '', '%              ', '( 0 - 3 )', '-99999.99', '3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('224', '0', '034', 'ES', 'A', '0.00', '0.10', '900', 'N', 'S', '', 'En Banda', '', '%              ', '( 1 - 5 )', '1', '5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('225', '0', '034', 'ES', 'A', '0.00', '0.10', '1000', 'N', 'S', '', 'Neutrofilos', '', '%              ', '( 17 - 37 )', '17', '37', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$G', '1', null, 'R');
INSERT INTO `defaults` VALUES ('226', '0', '034', 'ES', 'A', '0.11', '3.99', '1100', 'N', 'S', '', 'Neutrofilos', '', '%              ', '( 28 - 50 )', '28', '50', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$G', '1', null, 'R');
INSERT INTO `defaults` VALUES ('227', '0', '034', 'ES', 'A', '4.00', '9.99', '1200', 'N', 'S', '', 'Neutrofilos', '', '%              ', '( 35 - 65 )', '35', '65', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$G', '1', null, 'R');
INSERT INTO `defaults` VALUES ('228', '0', '034', 'ES', 'A', '10.00', '15.99', '1300', 'N', 'S', '', 'Neutrofilos', '', '%              ', '( 38 - 68 )', '38', '68', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$G', '1', null, 'R');
INSERT INTO `defaults` VALUES ('229', '0', '034', 'ES', 'A', '16.00', '99.99', '1400', 'N', 'S', '', 'Neutrofilos', '', '%              ', '( 40 - 70 )', '40', '70', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$G', '1', null, 'R');
INSERT INTO `defaults` VALUES ('230', '0', '034', 'ES', 'A', '0.00', '0.10', '1500', 'F', 'S', '', 'TOTAL GRANULOCITOS', 'B+C+D+E+F+G', '%              ', '( 19 - 48 )', '19', '48', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL19', '0', '$B+$C+$D+$E+$F+$G', 'R');
INSERT INTO `defaults` VALUES ('231', '0', '034', 'ES', 'A', '0.11', '3.99', '1600', 'F', 'S', '', 'TOTAL GRANULOCITOS', 'B+C+D+E+F+G', '%              ', '( 29 - 59 )', '29', '59', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL19', '0', '$B+$C+$D+$E+$F+$G', 'R');
INSERT INTO `defaults` VALUES ('232', '0', '034', 'ES', 'A', '4.00', '9.99', '1700', 'F', 'S', '', 'TOTAL GRANULOCITOS', 'B+C+D+E+F+G', '%              ', '( 36 - 74 )', '36', '74', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL19', '0', '$B+$C+$D+$E+$F+$G', 'R');
INSERT INTO `defaults` VALUES ('233', '0', '034', 'ES', 'A', '10.00', '15.99', '1800', 'F', 'S', '', 'TOTAL GRANULOCITOS', 'B+C+D+E+F+G', '%              ', '( 39 - 77 )', '39', '77', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL19', '0', '$B+$C+$D+$E+$F+$G', 'R');
INSERT INTO `defaults` VALUES ('234', '0', '034', 'ES', 'A', '16.00', '99.99', '1900', 'F', 'S', '', 'TOTAL GRANULOCITOS', 'B+C+D+E+F+G', '%              ', '( 41 - 79 )', '41', '79', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL19', '0', '$B+$C+$D+$E+$F+$G', 'R');
INSERT INTO `defaults` VALUES ('235', '0', '034', 'ES', 'A', '0.00', '0.10', '2000', 'N', 'S', '', 'Linfocitos', '', '%              ', '( 41 - 71 )', '41', '71', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$H', '1', null, 'R');
INSERT INTO `defaults` VALUES ('236', '0', '034', 'ES', 'A', '0.11', '3.99', '2100', 'N', 'S', '', 'Linfocitos', '', '%              ', '( 45 - 65 )', '45', '65', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$H', '1', null, 'R');
INSERT INTO `defaults` VALUES ('237', '0', '034', 'ES', 'A', '4.00', '9.99', '2200', 'N', 'S', '', 'Linfocitos', '', '%              ', '( 35 - 55 )', '35', '55', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$H', '1', null, 'R');
INSERT INTO `defaults` VALUES ('238', '0', '034', 'ES', 'A', '10.00', '15.99', '2300', 'N', 'S', '', 'Linfocitos', '', '%              ', '( 25 - 45 )', '25', '45', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$H', '1', null, 'R');
INSERT INTO `defaults` VALUES ('239', '0', '034', 'ES', 'A', '16.00', '99.99', '2400', 'N', 'S', '', 'Linfocitos', '', '%              ', '( 24 - 44 )', '24', '44', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$H', '1', null, 'R');
INSERT INTO `defaults` VALUES ('240', '0', '034', 'ES', 'A', '0.00', '0.10', '2500', 'N', 'S', '', 'Monocitos', '', '%              ', '( 4 - 8 )', '4', '8', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$I', '1', null, 'R');
INSERT INTO `defaults` VALUES ('241', '0', '034', 'ES', 'A', '0.11', '99.99', '2600', 'N', 'S', '', 'Monocitos', '', '%              ', '( 2 - 4 )', '2', '4', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$I', '1', null, 'R');
INSERT INTO `defaults` VALUES ('242', '0', '034', 'ES', 'A', '0.11', '99.99', '2700', 'N', 'S', '', 'Virolinfocitos (linfocitos atÃ', '', '%              ', '( 2 - 4 )', '2', '4', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$O', '1', null, 'R');
INSERT INTO `defaults` VALUES ('243', '0', '034', 'ES', 'A', '0.00', '99.99', '3000', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$J', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1549', '0', '292', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Anti-Cardiolipina IgM........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:27:55', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1548', '0', '291', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Anti-Cardiolipina IgG........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:26:19', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1547', '0', '273', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Influenza B-IgM..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:24:31', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1546', '0', '035', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Reticulocitos................:', null, '%', '( 0.5 - 1.5 )', '0.5', '1.5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:22:28', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1545', '0', '272', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Influenza B-IgG..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:22:09', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1544', '0', '271', 'ES', 'A', '0.00', '99.99', null, 'N', 'S', '', 'Influenza A-IgM..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:20:01', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('251', '0', '036', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Plaquetas....................:', null, 'mil / mm³      ', '(150 - 450)', '150', '450', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 11:45:14', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1543', '0', '270', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Influenza A-IgG..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:20:59', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('255', '0', '038', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'Hierro Sérico................:', null, 'ug/dlL   ', '( 37 -  170 )', '37', '170', '-99999.99', '99999.99', '-99999.99', '99999.99', 'FE', null, null, null, '1', '10', '2007-02-22 10:46:38', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('257', '0', '038', 'ES', 'A', '0.00', '99.99', '600', 'N', 'S', null, 'Transferrina.................:', null, 'ug/dL    ', '( 250 - 450 )', '250', '450', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TIBC', null, null, null, '1', '10', '2007-02-22 10:46:58', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('258', '0', '038', 'ES', 'A', '0.00', '99.99', '700', 'F', 'S', null, '% de Saturación..............:', '$A/$B*100', '%              ', '( 20  -  55 )', '20', '55', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 16:38:41', '', '$CAL2', '0', '$A/$B*100', 'R');
INSERT INTO `defaults` VALUES ('259', '0', '039', 'ES', 'M', '0.00', '10.00', '100', 'N', 'S', null, 'V.E.S........................:', null, 'mm/hora        ', '( 0 - 15 )', '0', '15', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 18:12:44', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('260', '0', '039', 'ES', 'F', '10.01', '99.99', '200', 'N', 'S', null, 'V.E.S........................:', null, 'mm/hora        ', '( 0 - 20 )', '0', '20', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 18:13:39', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('262', '0', '039', 'ES', 'A', '0.00', '99.99', '300', 'O', 'S', null, 'OBSERVACIONES:Valor Corregido', null, '               ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('263', '0', '040', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Celulas L.E..................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:15:21', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('264', '0', '041', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'TIEMPO DE COAGULACION', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('265', '0', '041', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Minutos......................:', null, null, '( 5 - 15 )', '5', '15', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 18:30:27', '', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('266', '0', '041', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Segundos.....................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 18:31:24', '', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('267', '0', '041', 'ES', 'A', '0.00', '99.99', '400', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:14:32', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('268', '0', '042', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'TIEMPO DE SANGRADO', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('269', '0', '042', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Minutos......................:', null, null, '( 1 - 3 )', '1', '3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 18:33:45', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('270', '0', '042', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Segundos.....................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 18:34:31', '', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('271', '0', '042', 'ES', 'A', '0.00', '99.99', '400', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:15:13', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('272', '0', '043', 'ES', 'A', '0.00', '99.99', '100', 'T', null, null, 'TIEMPO DE PROTROMBINA', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('273', '0', '043', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Paciente.....................:', null, 'segundos       ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 06:06:10', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('274', '0', '043', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Control Normal...............:', null, 'segundos       ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 06:06:28', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1557', '0', '205', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Hemoglobina A1...............:', null, '%', '( 96 - 98.5 )', '96', '98.5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 09:30:01', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('276', '0', '044', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'T. DE TROMBOPLASTINA PARC.', null, '      ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('277', '0', '044', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Paciente.....................:', null, 'segundos       ', '( 30 - 40 )', '30', '40', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 06:07:42', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('278', '0', '044', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Control Normal...............:', null, 'Segundos       ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 06:08:20', 'E', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('279', '0', '045', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'Eosinófilo(Moco Nasal)', null, '     ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 07:04:59', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1502', '0', '017', 'ES', 'A', '0.00', '99.99', '400', 'F', 'S', null, 'Calciuria  24/ Hrs...........:', null, null, '( 100 - 300 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 08:09:12', 'E', null, '0', '$A*$B', 'R');
INSERT INTO `defaults` VALUES ('282', '0', '045', 'ES', 'A', '0.00', '99.99', '400', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:08:07', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('283', '0', '046', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'PLACA POR MALARIA', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('284', '0', '046', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', null, 'Resultado...........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('285', '0', '046', 'ES', 'A', '0.00', '99.99', '300', 'C', 'S', null, 'Parasito encontrado :', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('286', '0', '046', 'ES', 'A', '0.00', '99.99', '400', 'C', 'S', null, 'Método utilizado....:', 'Gota Gruesa', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 07:24:45', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('287', '0', '047', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Grupo........................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:17:15', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('288', '0', '047', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Factor Rh....................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:18:53', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('289', '0', '047', 'ES', 'A', '0.00', '99.99', '300', 'O', 'S', null, 'Observaciones.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:09:13', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('290', '0', '048', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'Coombs Directo...............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:20:38', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('291', '0', '049', 'ES', 'A', '0.00', '99.99', '500', 'N', 'S', null, 'Coombs Indirecto.............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:21:07', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('293', '0', '050', 'ES', 'A', '0.00', '99.99', '700', 'C', 'S', '', 'Isoaglutininas', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('294', '0', '050', 'ES', 'A', '0.00', '99.99', '800', 'C', 'S', '', '1:', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('295', '0', '051', 'ES', 'A', '0.00', '99.99', '900', 'N', 'S', null, 'Crioaglutininas..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:21:37', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('297', '0', '052', 'ES', 'A', '0.00', '99.99', '1100', 'N', 'S', null, 'Glucosa......................:', null, 'mg/dl          ', '( 70 -  100 )', '70', '100', '-99999.99', '99999.99', '-99999.99', '99999.99', 'GLU', null, null, null, '1', '10', '2007-02-17 08:52:31', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('298', '0', '053', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'CURVA TOLERANCIA A GLUCOSA 2HS', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 10:46:20', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('299', '0', '053', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Glucosa en Ayunas............:', null, 'mg/dl          ', '( 70.0-100.0)', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:30:57', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('300', '0', '053', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'Glucosa  30 min..............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 10:37:50', 'E', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1573', '0', '054', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', null, 'Post  Ingesta de 75 g/dextrosa', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 10:34:24', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('302', '0', '053', 'ES', 'A', '0.00', '99.99', '500', 'N', 'S', null, 'Glucosa  1 Hora..............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:33:17', 'E', '$D', '1', null, 'R');
INSERT INTO `defaults` VALUES ('303', '0', '053', 'ES', 'A', '0.00', '99.99', '600', 'N', 'S', null, 'Glucosa 2 Horas..............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:33:59', 'E', '$E', '1', null, 'R');
INSERT INTO `defaults` VALUES ('304', '0', '053', 'ES', 'A', '0.00', '99.99', '700', 'O', 'S', null, 'Observación.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 09:32:03', 'E', '$F', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1670', '0', '030', 'ES', 'A', '0.00', '99.99', '3600', 'O', 'S', null, null, null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 16:27:55', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('306', '0', '054', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'CURVA TOLERANCIA A GLUCOSA 3HS', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 10:31:42', 'E', '$H', '0', null, 'R');
INSERT INTO `defaults` VALUES ('307', '0', '054', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Glucosa en Ayunas............:', null, 'mg/dl          ', '( 70.0-100.0)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:35:42', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('308', '0', '054', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'Glucosa 30 min...............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 10:33:50', 'E', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('309', '0', '054', 'ES', 'A', '0.00', '99.99', '500', 'N', 'S', null, 'Glucosa 1 Hora...............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:36:30', 'E', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('311', '0', '054', 'ES', 'A', '0.00', '99.99', '600', 'N', 'S', null, 'Glucosa 2 Horas..............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:37:15', 'E', '$E', '1', null, 'R');
INSERT INTO `defaults` VALUES ('312', '0', '054', 'ES', 'A', '0.00', '99.99', '700', 'N', 'S', null, 'Glucosa 3 Horas..............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:37:52', 'E', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('313', '0', '054', 'ES', 'A', '0.00', '99.99', '800', 'C', 'S', null, 'Post Ingesta de 75 g/dextrosa:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:39:40', 'E', '$G', '0', null, 'L');
INSERT INTO `defaults` VALUES ('315', '0', '055', 'ES', 'A', '0.00', '99.99', '100', 'T', null, null, 'CURVA TOLERANCIA A GLUCOSA 5HS', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 08:56:00', '', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('316', '0', '055', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Glucosa en Ayunas............:', null, 'mg/dl          ', '( 70.0-100.0)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:42:14', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('317', '0', '055', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'Glucosa 30 min...............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 10:51:08', 'E', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('318', '0', '055', 'ES', 'A', '0.00', '99.99', '500', 'N', 'S', null, 'Glucosa 1 Hora...............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:42:58', 'E', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('320', '0', '055', 'ES', 'A', '0.00', '99.99', '600', 'N', 'S', null, 'Glucosa 2 Horas..............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:43:30', 'E', '$E', '1', null, 'R');
INSERT INTO `defaults` VALUES ('321', '0', '055', 'ES', 'A', '0.00', '99.99', '700', 'N', 'S', null, 'Glucosa 3 Horas..............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:43:59', 'E', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('322', '0', '055', 'ES', 'A', '0.00', '99.99', '800', 'N', 'S', null, 'Glucosa 4 Horas..............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:52:44', 'E', '$G', '1', null, 'R');
INSERT INTO `defaults` VALUES ('323', '0', '055', 'ES', 'A', '0.00', '99.99', '900', 'N', 'S', null, 'Glucosa 5 Horas..............:', null, 'mg/dl          ', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:45:21', 'E', '$H', '1', null, 'R');
INSERT INTO `defaults` VALUES ('324', '0', '055', 'ES', 'A', '0.00', '99.99', '1000', 'O', 'S', null, 'Observación.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 10:54:54', 'E', '$I', '0', null, 'L');
INSERT INTO `defaults` VALUES ('326', '0', '056', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Glucosa 2hs.P.P..............:', null, 'mg/dl          ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 09:46:05', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('327', '0', '057', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'A1C (Hgb Glicosilada)........:', null, '%              ', '( 4.5 - 6.3 )', '4.5', '6.3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 09:46:58', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('328', '0', '057', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 09:58:34', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('329', '0', '058', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Colesterol Total.............:', null, 'mg/dl          ', '( Deseable:... Menos de 200)\r\n( Promedio:.......201 - 239)\r\n( Alto Riesgo:  Mayor de 240)', '100', '200', '50', '1500', '20', '2000', 'CHOL', null, null, null, '1', '10', '2007-02-17 08:32:43', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1472', '0', '128', 'ES', 'A', '0.00', '99.99', '72500', 'O', 'S', null, 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 07:51:34', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('332', '0', '059', 'ES', 'A', '0.00', '999.99', '100', 'N', 'S', null, 'HDL-Colesterol...............:', null, 'mg/dl          ', ' (Mayor de 45)', '45', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'dHDL', null, null, null, '1', '10', '2007-02-17 08:43:19', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1644', '0', '031', 'ES', 'A', '10.00', '15.99', '2700', 'N', 'S', '', 'Neutrófilos..................:', null, '%', '( 38.0-68.0 )', '38', '68', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:17:51', 'E', '$J', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1645', '0', '031', 'ES', 'A', '16.00', '99.99', '2800', 'N', 'S', '', 'Neutrófilos..................:', null, '%', '( 40.0-70.0 )', '40', '70', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:19:44', 'E', '$J', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1646', '0', '031', 'ES', 'A', '0.00', '99.99', '2900', 'N', 'S', '', 'Eosinófilos..................:', null, '%', '( 1.0 - 5.0 )', '1', '5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:21:40', 'E', '$E', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1647', '0', '031', 'ES', 'A', '0.00', '99.99', '3000', 'N', 'S', '', 'Basófilos....................:', null, '%', '( 0.0 - 1.0 )', '-99999.99', '1', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:23:29', 'E', '$F', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1648', '0', '031', 'ES', 'A', '0.11', '3.99', '3100', 'F', 'S', null, 'TOTAL GRANULOCITOS...........:', 'F+E+J+I+H+G+S+R', '%', '( 29.0-59.0 )', '29', '59', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:35:21', 'M', '$CAL1', '0', '$F+$E+$J+$I+$H+$G+$S+$R', 'R');
INSERT INTO `defaults` VALUES ('1649', '0', '031', 'ES', 'A', '4.00', '9.99', '3200', 'F', 'S', '', 'TOTAL GRANULOCITOS...........:', 'F+E+J+I+H+G+S+R', '%', '( 36.0-74.0 )', '36', '74', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:39:18', 'M', '$CAL1', '0', '$F+$E+$J+$I+$H+$G+$S+$R', 'R');
INSERT INTO `defaults` VALUES ('1650', '0', '031', 'ES', 'A', '0.00', '0.10', '3300', 'F', 'S', '', 'TOTAL DE GRANULOCITOS......:', 'F+E+J+I+H+G+S+R', '%', '( 19.0-48.0 )', '19', '48', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:43:00', 'M', '$SCL1', '0', '$F+$E+$J+$I+$H+$G+$S+$R', 'R');
INSERT INTO `defaults` VALUES ('1651', '0', '031', 'ES', 'A', '10.00', '15.99', '3400', 'F', 'S', '', 'TOTAL DE GRANULOCITOS........:', 'F+E+J+I+H+G+S+R', '%', '( 39.0-77.0 )', '39', '77', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:46:59', 'M', '$SCL1', '0', '$F+$E+$J+$I+$H+$G+$S+$R', 'R');
INSERT INTO `defaults` VALUES ('1652', '0', '031', 'ES', 'A', '16.00', '99.99', '3500', 'F', 'S', '', 'TOTAL DE GRANULOCITOS........:', 'F+E+J+I+H+G+S+R', '%', '( 41.0-79.0 )', '41', '79', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:50:11', 'M', '$SCAL', '0', '$F+$E+$J+$I+$H+$G+$S+$R', 'R');
INSERT INTO `defaults` VALUES ('1653', '0', '031', 'ES', 'A', '0.00', '99.99', '3600', 'N', 'S', null, 'Prolinfocitos................:', '0.0', '%', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 07:12:03', 'M', '$V', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1654', '0', '031', 'ES', 'A', '0.00', '0.10', '3700', 'N', 'S', '', 'Linfocitos...................:', null, '%', '( 41.0-71.0 )', '41', '71', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:53:48', 'E', '$K', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1655', '0', '031', 'ES', 'A', '0.11', '3.99', '3800', 'N', 'S', '', 'Linfocitos...................:', null, '%', '( 45.0-65.0 )', '45', '65', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:55:47', 'E', '$K', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1656', '0', '031', 'ES', 'A', '4.00', '9.99', '3900', 'N', 'S', '', 'Linfocitos...................:', null, '%', '( 35.0-55.0 )', '35', '55', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:58:13', 'E', '$K', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1657', '0', '031', 'ES', 'A', '10.00', '15.99', '4000', 'N', 'S', null, 'Linfocitos...................:', null, '%', '( 25.0-45.0 )', '25', '45', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 11:59:05', 'E', '$K', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1658', '0', '031', 'ES', 'A', '16.00', '99.99', '4100', 'N', 'S', '', 'Linfocitos...................:', null, '%', '( 24.0-44.0 )', '24', '44', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 09:14:11', 'E', '$K', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1659', '0', '031', 'ES', 'A', '0.00', '0.10', '4200', 'N', 'S', null, 'Monocitos....................:', null, '%', '( 2.0 - 8.0 )', '2', '8', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 15:39:42', 'E', '$L', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1660', '0', '031', 'ES', 'A', '0.11', '99.99', '4300', 'N', 'S', null, 'Monocitos....................:', null, '%', '( 2.0 - 8.0 )', '2', '8', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 15:40:10', 'E', '$L', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1661', '0', '031', 'ES', 'A', '0.00', '99.99', '4400', 'N', 'S', null, 'Linfocitos Atípicos...........', '0.0', '%', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 15:40:32', 'M', '$R', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1662', '0', '031', 'ES', 'A', '0.00', '99.99', '4600', 'O', 'S', null, 'Observaciones.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 16:13:14', 'E', '$M', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1663', '0', '031', 'ES', 'A', '0.00', '99.99', '4500', 'N', 'S', null, 'Plaquetas....................:', null, 'mil/mm³', '( 150 - 450 )', '150', '450', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 16:12:12', 'E', '$P', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1665', '0', '116', 'ES', 'A', '0.00', '99.99', '200', 'S', 'S', null, 'Sigue Normal', null, null, '( 11.0- 16.0...6140-103000 )\r\n( 16.0- 21.0....4720-80100 )\r\n( 21.0- 39.0....2700-78100 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 16:33:33', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1578', '0', '063', 'ES', 'A', '0.00', '99.99', '300', 'F', 'S', null, 'Urea Total...................:', null, 'mg/dl', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'BUN', null, null, null, '1', '10', '2007-02-22 10:36:26', 'E', null, '0', '$A*2', 'R');
INSERT INTO `defaults` VALUES ('366', '0', '060', 'ES', 'F', '5.00', '9.99', '100', 'N', 'S', null, 'LDL-Colesterol', null, 'mg/dl          ', '( 68 - 115 )', '68', '115', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:34:03', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('367', '0', '060', 'ES', 'F', '10.00', '14.99', '200', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 68 - 110 )', '68', '110', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('368', '0', '060', 'ES', 'F', '15.00', '19.99', '300', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 59 - 111 )', '59', '111', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('369', '0', '060', 'ES', 'F', '20.00', '24.99', '400', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 57 - 118 )', '57', '118', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('370', '0', '060', 'ES', 'F', '25.00', '29.99', '500', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 71 - 126 )', '71', '126', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('371', '0', '060', 'ES', 'F', '30.00', '34.99', '600', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 70 - 128 )', '70', '128', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('372', '0', '060', 'ES', 'F', '35.00', '39.99', '700', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 75 - 139 )', '75', '139', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('373', '0', '060', 'ES', 'F', '40.00', '44.99', '800', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 74 - 146 )', '74', '146', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('374', '0', '060', 'ES', 'F', '45.00', '49.99', '900', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 79 - 150 )', '79', '150', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('375', '0', '060', 'ES', 'F', '50.00', '54.99', '1000', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 88 - 160 )', '88', '160', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('376', '0', '060', 'ES', 'F', '55.00', '59.99', '1100', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 89 - 168 )', '89', '168', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('377', '0', '060', 'ES', 'F', '60.00', '64.99', '1200', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 100 - 168 )', '100', '168', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('378', '0', '060', 'ES', 'F', '65.00', '69.99', '1300', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 92 - 184 )', '92', '184', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('379', '0', '060', 'ES', 'F', '70.00', '99.99', '1400', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 96 - 170 )', '96', '170', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('380', '0', '060', 'ES', 'M', '5.00', '9.99', '1500', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 63 - 103 )', '63', '103', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('381', '0', '060', 'ES', 'M', '10.00', '14.99', '1600', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 64 - 109 )', '64', '109', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('382', '0', '060', 'ES', 'M', '15.00', '19.99', '1700', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 62 - 109 )', '62', '109', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('383', '0', '060', 'ES', 'M', '20.00', '24.99', '1800', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 66 - 118 )', '66', '118', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('384', '0', '060', 'ES', 'M', '25.00', '29.99', '1900', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 70 - 138 )', '70', '138', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('385', '0', '060', 'ES', 'M', '30.00', '34.99', '2000', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 78 - 144 )', '78', '144', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('386', '0', '060', 'ES', 'M', '35.00', '39.99', '2100', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 81 - 154 )', '81', '154', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('387', '0', '060', 'ES', 'M', '40.00', '44.99', '2200', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 87 - 157 )', '87', '157', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('388', '0', '060', 'ES', 'M', '45.00', '49.99', '2300', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 98 - 163 )', '98', '163', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('389', '0', '060', 'ES', 'M', '50.00', '54.99', '2400', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 89 - 162 )', '89', '162', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('390', '0', '060', 'ES', 'M', '55.00', '59.99', '2500', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 88 - 168 )', '88', '168', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('391', '0', '060', 'ES', 'M', '60.00', '64.99', '2600', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 83 - 165 )', '83', '165', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('392', '0', '060', 'ES', 'M', '65.00', '69.99', '2700', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 98 - 170 )', '98', '170', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('393', '0', '060', 'ES', 'M', '70.00', '99.99', '2800', 'N', 'S', '', 'LDL-Colesterol', '', 'mg/dl          ', '( 88 - 164 )', '88', '164', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('394', '0', '060', 'ES', 'F', '5.00', '9.99', '2900', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 36 - 61 )', '36', '61', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('395', '0', '060', 'ES', 'F', '10.00', '14.99', '3000', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 37 - 58 )', '37', '58', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('396', '0', '060', 'ES', 'F', '15.00', '19.99', '3100', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 35 - 61 )', '35', '61', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('397', '0', '060', 'ES', 'F', '20.00', '24.99', '3200', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 33 - 62 )', '33', '62', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('398', '0', '060', 'ES', 'F', '25.00', '29.99', '3300', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 37 - 63 )', '37', '63', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('399', '0', '060', 'ES', 'F', '30.00', '34.99', '3400', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 36 - 64 )', '36', '64', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('400', '0', '060', 'ES', 'F', '35.00', '39.99', '3500', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 34 - 64 )', '34', '64', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('401', '0', '060', 'ES', 'F', '40.00', '44.99', '3600', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 34 - 65 )', '34', '65', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('402', '0', '060', 'ES', 'F', '45.00', '49.99', '3700', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 34 - 68 )', '34', '68', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('403', '0', '060', 'ES', 'F', '50.00', '54.99', '3800', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 37 - 71 )', '37', '71', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('404', '0', '060', 'ES', 'F', '55.00', '59.99', '3900', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 37 - 73 )', '37', '73', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('405', '0', '060', 'ES', 'F', '60.00', '64.99', '4000', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 38 - 75 )', '38', '75', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('406', '0', '060', 'ES', 'F', '65.00', '69.99', '4100', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 35 - 73 )', '35', '73', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('407', '0', '060', 'ES', 'F', '70.00', '99.99', '4200', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 33 - 71 )', '33', '71', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('408', '0', '060', 'ES', 'M', '5.00', '9.99', '4300', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 38 - 63 )', '38', '63', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('409', '0', '060', 'ES', 'M', '10.00', '14.99', '4400', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 37 - 61 )', '37', '61', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('410', '0', '060', 'ES', 'M', '15.00', '19.99', '4500', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 30 - 52 )', '30', '52', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('411', '0', '060', 'ES', 'M', '20.00', '24.99', '4600', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 30 - 51 )', '30', '51', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('412', '0', '060', 'ES', 'M', '25.00', '29.99', '4700', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 31 - 50 )', '31', '50', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('413', '0', '060', 'ES', 'M', '30.00', '34.99', '4800', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 28 - 52 )', '28', '52', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('414', '0', '060', 'ES', 'M', '35.00', '39.99', '4900', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 29 - 49 )', '29', '49', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('415', '0', '060', 'ES', 'M', '40.00', '44.99', '5000', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 27 - 51 )', '27', '51', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('416', '0', '060', 'ES', 'M', '45.00', '49.99', '5100', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 30 - 52 )', '30', '52', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('417', '0', '060', 'ES', 'M', '50.00', '54.99', '5200', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 28 - 51 )', '28', '51', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('418', '0', '060', 'ES', 'M', '55.00', '59.99', '5300', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 28 - 55 )', '28', '55', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('419', '0', '060', 'ES', 'M', '60.00', '64.99', '5400', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 30 - 61 )', '30', '61', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('420', '0', '060', 'ES', 'M', '65.00', '69.99', '5500', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 30 - 62 )', '30', '62', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('421', '0', '060', 'ES', 'M', '70.00', '99.99', '5600', 'N', 'S', '', 'HDL-Colesterol', '', 'mg/dl          ', '( 31 - 56 )', '31', '56', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('422', '0', '060', 'ES', 'A', '0.00', '99.99', '5700', 'M', 'S', '', 'LDL-Colest./HDL-Colest', '$B/$A', '', '( 3.4 - 4.3 )', '3.4', '4.3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL25', '0', null, 'R');
INSERT INTO `defaults` VALUES ('423', '0', '060', 'ES', 'A', '0.00', '99.99', '5800', 'F', 'S', '', 'LDL-Colest./HDL-Colest', '$B/$A', '', '( 2.9 - 3.3 )', '2.9', '3.3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL25', '0', '$B/$A', 'R');
INSERT INTO `defaults` VALUES ('424', '0', '060', 'ES', 'A', '0.00', '99.99', '6000', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('425', '0', '061', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Trigliceridos................:', null, 'mg/dl          ', '( Hasta 150 )', '-99999.99', '150', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TRIG', null, null, null, '1', '10', '2007-02-17 09:10:10', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('427', '0', '062', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Lipidos Totales', '', 'mg/dl          ', '( 450 - 850 )', '450', '850', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1609', '0', '028', 'ES', 'M', '0.00', '99.99', '2000', 'N', 'S', null, 'Recuento de Leucocitos/ml', null, 'ml', '(Menos de 1 X 10*)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 12:05:00', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1608', '0', '028', 'ES', 'M', '0.00', '99.99', '1900', 'N', 'S', null, 'Recuento espermático Total', null, null, '(Mayor de 40 X 10*)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 12:03:20', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1602', '0', '028', 'ES', 'M', '0.00', '99.99', '1400', 'N', 'S', null, 'Grado 2+.................:', null, '%', '(Desplazamiento Lento)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 10:49:12', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1603', '0', '028', 'ES', 'M', '0.00', '99.99', '1500', 'N', 'S', null, 'Grado 3+.................:', null, '%', '(Desplazamiento Moderado)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 10:49:34', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1599', '0', '328', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'EBV-VCA (IgG)................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:14:37', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1598', '0', '327', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'EBV-VCA (IgM)................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:13:37', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1597', '0', '326', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Herpes II IgM................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:12:33', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1577', '0', '063', 'ES', 'F', '0.00', '99.99', '200', 'N', 'S', null, 'Nitrógeno de urea............:', null, 'mg/dl', '( 7.0 -17.0 )', '7', '17', '-99999.99', '99999.99', '-99999.99', '99999.99', 'BUN', null, null, null, '1', '10', '2007-02-22 10:35:42', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1576', '0', '063', 'ES', 'M', '0.00', '99.99', '100', 'N', 'S', null, 'Nitrógeno de Urea............:', null, 'mg/dl', '( 9.0 -20.0 )', '9', '20', '-99999.99', '99999.99', '-99999.99', '99999.99', 'BUN', null, null, null, '1', '10', '2007-02-22 10:35:27', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1596', '0', '325', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Herpes II IgG................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:11:38', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('443', '0', '065', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Creatinina...................:', null, 'mg/dl          ', '( 0.2 - 1.3 )', '0.2', '1.3', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CREA', null, null, null, '1', '10', '2007-02-17 08:36:49', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('444', '0', '066', 'ES', 'F', '0.00', '99.99', '100', 'N', 'S', null, 'Acido Urico..................:', null, 'mg/dl          ', '( 2.5 - 7.5 )', '2.5', '7.5', '-99999.99', '99999.99', '-99999.99', '99999.99', 'URIC', null, null, null, '1', '10', '2007-02-17 09:10:39', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('445', '0', '066', 'ES', 'M', '0.00', '99.99', '200', 'N', 'S', null, 'Acido Urico..................:', null, 'mg/dl          ', '( 3.5 - 8.5 )', '3.5', '8.5', '-99999.99', '99999.99', '-99999.99', '99999.99', 'URIC', null, null, null, '1', '10', '2007-02-17 09:10:52', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('446', '0', '067', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'Proteínas Totales y Rel. A/G', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-17 09:06:55', 'E', null, '1', null, 'L');
INSERT INTO `defaults` VALUES ('447', '0', '067', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Proteina Total...............:', null, 'g/dl           ', '( 6.3 - 8.2 )', '6.3', '8.2', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TP', null, null, null, '1', '10', '2007-02-17 09:07:13', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('448', '0', '067', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Albumina.....................:', null, 'g/dl           ', '( 3.5 - 5.0 )', '3.5', '5', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TP', null, null, null, '1', '10', '2007-02-17 09:07:29', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('449', '0', '067', 'ES', 'A', '0.00', '99.99', '400', 'F', 'S', null, 'Globulinas...................:', 'A-B', 'g/dl           ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:41:48', '', '$CALG', '0', '$A-$B', 'R');
INSERT INTO `defaults` VALUES ('450', '0', '067', 'ES', 'A', '0.00', '99.99', '500', 'F', 'S', null, 'Albumina/Globulinas..........:', 'B/CALG', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:42:16', '', '$CAL31', '0', '$B/$CALG', 'R');
INSERT INTO `defaults` VALUES ('1619', '0', '031', 'ES', 'F', '15.00', '99.99', '400', 'N', 'S', '', 'Hemoglobina..................:', null, 'mg/dl', '( 12.5-14.8 )', '12.5', '14.8', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 15:37:32', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1618', '0', '031', 'ES', 'A', '10.00', '14.99', '300', 'N', 'S', '', 'Hemoglobina..................:', null, 'g/ml', '( 11.7-14.1 )', '11.7', '14.1', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 15:12:05', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1615', '0', '028', 'ES', 'M', '0.00', '99.99', '2800', 'O', 'S', '', 'Observación............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 12:33:37', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1612', '0', '028', 'ES', 'M', '0.00', '99.99', '2200', 'T', 'S', null, 'Morfología', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 12:21:55', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1613', '0', '028', 'ES', 'M', '0.00', '99.99', '2400', 'N', 'S', '', 'Formas Anormales.........:', null, '%', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 12:25:31', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1611', '0', '028', 'ES', 'M', '0.00', '99.99', '2300', 'N', 'S', null, 'Formas Normales..........:', null, '%', '(Mayor de 30%)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 12:22:58', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1574', '0', '053', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', null, 'Post Ingesta de 75 g/dextrosa', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:29:08', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('460', '0', '069', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Sodio........................:', null, 'mmol/L         ', '( 137 - 145 )', '137', '145', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Na+', null, null, null, '1', '10', '2007-02-17 08:55:27', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('461', '0', '070', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Potasio......................:', null, 'mmol/L        ', '( 3.6 - 5.0 )', '3.6', '5', '-99999.99', '99999.99', '-99999.99', '99999.99', 'K+', null, null, null, '1', '10', '2007-02-17 08:52:58', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('462', '0', '071', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Cloruro......................:', null, 'mmol/L        ', '( 98 -  107 )', '98', '107', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Cl-', null, null, null, '1', '10', '2007-02-17 08:36:19', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('463', '0', '072', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'C02..........................:', null, 'mmol/L         ', '( 22  -  30 )', '22', '30', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ECO2', null, null, null, '1', '10', '2007-02-17 08:44:41', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('464', '0', '073', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Calcio.......................:', null, 'mg/dl          ', '( 8.4 - 10.2)', '8.4', '10.2', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CA', null, null, null, '1', '10', '2007-02-17 08:45:15', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('465', '0', '074', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Fósforo......................:', null, 'mg/dl          ', '( 2.5 - 4.5 )', '2.5', '4.5', '-99999.99', '99999.99', '-99999.99', '99999.99', 'PHOS', null, null, null, '1', '10', '2007-02-17 08:57:03', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1471', '0', '128', 'ES', 'A', '0.00', '99.99', '72400', 'N', 'S', null, 'Brucella abortus.............:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:27:20', 'M', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('467', '0', '075', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Magnesio.....................:', null, 'mg/dl         ', '( 1.6 - 2.3 )', '1.6', '2.3', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Mg', null, null, null, '1', '10', '2007-02-17 08:54:56', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('468', '0', '076', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'BILIRRUBINA TOTAL Y DIRECTA', ' ', '               ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-17 09:05:35', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1414', '0', '076', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Bilirrubina Total............:', null, 'mg/dl', '( 0.0 - 1.0 )', '0', '1', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TBIL', null, null, null, '1', '10', '2007-02-17 08:58:57', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('470', '0', '076', 'ES', 'A', '0.00', '0.08', '300', 'N', 'S', null, 'Bilirrubina Total............:', null, 'mg/dl          ', '( 0.0- 12.0 )', '-99999.99', '12', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TBIL', null, null, null, '1', '10', '2007-02-17 08:59:12', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('471', '0', '076', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'Bilirrubina Directa..........:', null, 'mg/dl          ', '( 0.0 -0.25 )', '-99999.99', '0.25', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TBIL', null, null, null, '1', '10', '2007-02-17 08:59:30', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('472', '0', '076', 'ES', 'A', '0.00', '99.99', '500', 'F', 'S', null, 'Bilirrubina Indirecta........:', null, 'mg/dl          ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 09:09:52', 'E', '$CAL38', '0', '$A-$B', 'R');
INSERT INTO `defaults` VALUES ('473', '0', '077', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Amonemia', '', 'ÃƒÂ¦g/dl       ', '( 25 - 94 )', '40', '80', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('474', '0', '077', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('475', '0', '078', 'ES', 'M', '0.00', '99.99', '100', 'N', 'S', null, 'S.G.O.T./A.S.T...............:', null, 'U/L            ', '( 17 -   59 )', '17', '59', '-99999.99', '99999.99', '-99999.99', '99999.99', 'AST', null, null, null, '1', '10', '2007-02-17 08:29:37', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('476', '0', '078', 'ES', 'F', '0.00', '99.99', '200', 'N', 'S', null, 'S.G.O.T./A.S.T...............:', null, 'U/L            ', '( 14 - 36 )', '14', '36', '-99999.99', '99999.99', '-99999.99', '99999.99', 'AST', null, null, null, '1', '10', '2007-02-17 08:29:49', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('477', '0', '079', 'ES', 'M', '0.00', '99.99', '100', 'N', 'S', null, 'S.G.P.T./A.L.T...............:', null, 'U/L            ', '( 21  -  72 )', '21', '72', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ALT', null, null, null, '1', '10', '2007-02-17 08:26:19', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('478', '0', '079', 'ES', 'F', '0.00', '99.99', '200', 'N', 'S', null, 'S.G.P.T./A.L.T...............:', null, 'U/L            ', '(  9  -  52  )', '9', '52', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ALT', null, null, null, '1', '10', '2007-02-17 08:26:32', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('479', '0', '080', 'ES', 'M', '0.00', '99.99', '100', 'N', 'S', null, 'GGT..........................:', null, 'U/L            ', '( 15  -  73 )', '15', '73', '-99999.99', '99999.99', '-99999.99', '99999.99', 'GGG', null, null, null, '1', '10', '2007-02-17 08:51:42', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('480', '0', '080', 'ES', 'F', '0.00', '99.99', '200', 'N', 'S', null, 'GGT..........................:', null, 'U/L            ', '( 12  -  43 )', '12', '43', '-99999.99', '99999.99', '-99999.99', '99999.99', 'GGG', null, null, null, '1', '10', '2007-02-17 08:51:53', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('481', '0', '081', 'ES', 'A', '20.00', '99.99', '100', 'N', 'S', null, 'Fosfatasa Alcalina...........:', null, 'U/L            ', '( 38 -  126 )', '38', '126', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ALKP', null, null, null, '1', '10', '2007-02-17 08:24:06', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('482', '0', '081', 'ES', 'A', '0.00', '1.00', '200', 'N', 'S', null, 'Fosfatasa Alcalina...........:', null, 'U/L            ', '( 0 -  189  )', '-99999.99', '189', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ALKP', null, null, null, '1', '10', '2007-02-17 08:24:21', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('483', '0', '081', 'ES', 'A', '1.00', '2.00', '300', 'N', 'S', null, 'Fosfatasa Alcalina...........:', null, 'U/L            ', '(  0 -  171  )', '-99999.99', '171', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ALKP', null, null, null, '1', '10', '2007-02-17 08:24:40', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('484', '0', '081', 'ES', 'A', '3.00', '11.00', '400', 'N', 'S', null, 'Fosfatasa Alcalina...........:', null, 'U/L            ', '(  0 -  270  )', '3', '11', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ALKP', null, null, null, '1', '10', '2007-02-17 08:24:57', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('485', '0', '081', 'ES', 'A', '12.00', '15.00', '500', 'N', 'S', null, 'Fosfatasa Alcalina...........:', null, 'U/L            ', '( 0  -  320 )', '12', '15', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ALKP', null, null, null, '1', '10', '2007-02-17 08:25:16', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('486', '0', '081', 'ES', 'A', '16.00', '18.00', '600', 'N', 'S', null, 'Fosfatasa Alcalina...........:', null, 'U/L            ', '( 0  -  114 )', '16', '18', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ALKP', null, null, null, '1', '10', '2007-02-17 08:25:34', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('488', '0', '082', 'ES', 'A', '0.00', '11.99', '100', 'N', 'S', '', 'Total', '', 'UI/L           ', '( Hasta 350 )', '-99999.99', '350', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('489', '0', '082', 'ES', 'A', '20.00', '99.99', '200', 'N', 'S', '', 'Total', '', 'UI/L           ', '( 26 - 100 )', '26', '100', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('490', '0', '082', 'ES', 'F', '12.00', '14.99', '300', 'N', 'S', '', 'Total', '', 'UI/L           ', '( Hasta 280 )', '-99999.99', '280', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('491', '0', '082', 'ES', 'F', '15.00', '19.99', '400', 'N', 'S', '', 'Total', '', 'UI/L           ', '( Hasta 150 )', '-99999.99', '150', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('492', '0', '082', 'ES', 'M', '12.00', '14.99', '500', 'N', 'S', '', 'Total', '', 'UI/L           ', '( Hasta 500 )', '-99999.99', '500', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('493', '0', '082', 'ES', 'M', '15.00', '19.99', '600', 'N', 'S', '', 'Total', '', 'UI/L           ', '( Hasta 155 )', '-99999.99', '155', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('494', '0', '082', 'ES', 'A', '0.00', '99.99', '700', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$O', '0', null, 'L');
INSERT INTO `defaults` VALUES ('495', '0', '082', 'ES', 'A', '0.00', '99.99', '800', 'C', 'S', '', 'Fraccion Hepatica Rapida', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$V', '0', null, 'L');
INSERT INTO `defaults` VALUES ('496', '0', '082', 'ES', 'A', '0.00', '99.99', '900', 'C', 'S', '', 'Fraccion Hepatica', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$W', '0', null, 'L');
INSERT INTO `defaults` VALUES ('497', '0', '082', 'ES', 'A', '0.00', '99.99', '1000', 'C', 'S', '', 'Fraccion Osea', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$X', '0', null, 'L');
INSERT INTO `defaults` VALUES ('498', '0', '082', 'ES', 'A', '0.00', '99.99', '1100', 'C', 'S', '', 'Fraccion Post-Osea', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$Y', '0', null, 'L');
INSERT INTO `defaults` VALUES ('499', '0', '082', 'ES', 'A', '0.00', '99.99', '1200', 'C', 'S', '', 'Fraccion Intestinal', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$Z', '0', null, 'L');
INSERT INTO `defaults` VALUES ('500', '0', '083', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'CEA..........................:', null, 'ng/ml          ', '( Fumadores:......Hasta 5.1 )\r\n( No Fumadore:....Hasta 3.5 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CEA', null, null, null, '1', '10', '2007-02-22 08:07:58', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('503', '0', '084', 'ES', 'A', '1.00', '99.00', '52100', 'N', 'S', null, 'Alfa-Fetoproteina............:', null, 'ng/ml          ', '( 0 - 7.5)', '-99999.99', '7.5', '-99999.99', '99999.99', '-99999.99', '99999.99', 'AFP', null, null, null, '1', '10', '2007-02-22 08:03:58', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('504', '0', '084', 'ES', 'A', '0.00', '99.99', '52200', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:10:05', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('505', '0', '085', 'ES', 'A', '0.00', '99.99', '52300', 'N', 'S', null, 'Amilasa......................:', null, 'U/L            ', '( 30 -  110 )', '30', '110', '-99999.99', '99999.99', '-99999.99', '99999.99', 'AMYL', null, null, null, '1', '10', '2007-02-17 08:29:08', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('507', '0', '086', 'ES', 'A', '0.00', '99.99', '52500', 'N', 'S', null, 'D.H.L........................:', null, 'U/L            ', '( 313 - 618 )', '313', '618', '-99999.99', '99999.99', '-99999.99', '99999.99', 'LDH', null, null, null, '1', '10', '2007-02-17 08:53:25', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('509', '0', '087', 'ES', 'M', '0.00', '99.99', '52700', 'N', 'S', null, 'C.P.K........................:', null, 'U/L            ', '( 55 -  170 )', '55', '170', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CK', null, null, null, '1', '10', '2007-02-17 08:33:21', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('510', '0', '087', 'ES', 'F', '0.00', '99.99', '52800', 'N', 'S', null, 'C.P.K........................:', null, 'U/L            ', '( 30 -  135 )', '30', '135', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CK', null, null, null, '1', '10', '2007-02-17 08:33:35', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('513', '0', '088', 'ES', 'A', '0.00', '99.99', '53100', 'N', 'S', '', 'DHL TOTAL', '', 'UI/L           ', '( 160 - 320 )', '160', '320', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('514', '0', '088', 'ES', 'A', '0.00', '99.99', '53200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$O', '0', null, 'L');
INSERT INTO `defaults` VALUES ('515', '0', '088', 'ES', 'A', '0.00', '99.99', '53300', 'C', 'S', '', 'DHL-1', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$V', '0', null, 'L');
INSERT INTO `defaults` VALUES ('516', '0', '088', 'ES', 'A', '0.00', '99.99', '53400', 'C', 'S', '', 'DHL-2', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$W', '0', null, 'L');
INSERT INTO `defaults` VALUES ('517', '0', '088', 'ES', 'A', '0.00', '99.99', '53500', 'C', 'S', '', 'DHL-3', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$X', '0', null, 'L');
INSERT INTO `defaults` VALUES ('518', '0', '088', 'ES', 'A', '0.00', '99.99', '53600', 'C', 'S', '', 'DHL-4', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$Y', '0', null, 'L');
INSERT INTO `defaults` VALUES ('519', '0', '088', 'ES', 'A', '0.00', '99.99', '53700', 'C', 'S', '', 'DHL-5', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$Z', '0', null, 'L');
INSERT INTO `defaults` VALUES ('520', '0', '088', 'ES', 'A', '0.00', '99.99', '53800', '', 'S', '', 'DHL-1/DHL-2', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('521', '0', '089', 'ES', 'F', '0.00', '99.99', '53900', 'N', 'S', '', 'CPK-TOTAL', '', 'UI/L           ', '( 15 - 110 )', '15', '110', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '1', null, 'R');
INSERT INTO `defaults` VALUES ('522', '0', '089', 'ES', 'M', '0.00', '99.99', '54000', 'N', 'S', '', 'CPK-TOTAL', '', 'UI/L           ', '( 15 - 130 )', '15', '130', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '1', null, 'R');
INSERT INTO `defaults` VALUES ('523', '0', '089', 'ES', 'A', '0.00', '99.99', '54100', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$O', '0', null, 'L');
INSERT INTO `defaults` VALUES ('524', '0', '089', 'ES', 'A', '0.00', '99.99', '54200', 'C', 'S', '', 'CPK-1(MM)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$X', '0', null, 'L');
INSERT INTO `defaults` VALUES ('525', '0', '089', 'ES', 'A', '0.00', '99.99', '54300', 'C', 'S', '', 'CPK-2(MB)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$Y', '0', null, 'L');
INSERT INTO `defaults` VALUES ('526', '0', '089', 'ES', 'A', '0.00', '99.99', '54400', 'C', 'S', '', 'CPK-3(BB)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$Z', '0', null, 'L');
INSERT INTO `defaults` VALUES ('527', '0', '090', 'ES', 'F', '0.00', '99.99', '54500', 'N', 'S', null, 'Fosfatasa Acida..............:', null, 'U/l            ', '( 0  -  3.0 )', '0', '3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 13:42:23', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('528', '0', '090', 'ES', 'M', '0.00', '99.99', '54600', 'N', 'S', null, 'Fosfatasa Acida..............:', null, 'U/l            ', '( 0  -  3.6 )', '0', '3.6', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 13:43:15', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('529', '0', '091', 'ES', 'M', '0.00', '99.99', '54700', 'N', 'S', null, 'Fraccion Prostatica..........:', null, 'U/l            ', '( 0  -  1.5 )', '0', '1.5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:28:14', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('530', '0', '092', 'ES', 'A', '0.00', '99.99', '54800', 'N', 'S', null, 'Fenitoína....................:', null, 'ug/ml       ', '( 10 - 20 )', '10', '20', '-99999.99', '99999.99', '-99999.99', '99999.99', 'PHYT', null, null, null, '1', '10', '2007-02-17 08:57:35', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('531', '0', '092', 'ES', 'A', '0.00', '99.99', '54900', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:10:42', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('532', '0', '093', 'ES', 'A', '0.00', '99.99', '55000', 'N', 'S', '', 'Primidona', '', 'ÃƒÂ¦g/ml       ', '( 5 - 12 )', '5', '12', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('533', '0', '093', 'ES', 'A', '0.00', '99.99', '55100', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('534', '0', '094', 'ES', 'A', '0.00', '99.99', '55200', 'N', 'S', null, 'Fenobarbital.................:', null, 'ug/ml     ', '( 15 - 40 )', '15', '40', '-99999.99', '99999.99', '-99999.99', '99999.99', 'PHBR', null, null, null, '1', '10', '2007-02-17 08:55:55', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('535', '0', '094', 'ES', 'A', '0.00', '99.99', '55300', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:11:24', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('536', '0', '095', 'ES', 'A', '0.00', '99.99', '55400', 'N', 'S', null, 'Carbamazepina................:', null, 'ug/ml       ', '( 4 -  10 )', '4', '10', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 08:14:12', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('537', '0', '095', 'ES', 'A', '0.00', '99.99', '55500', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-06 10:12:05', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('538', '0', '096', 'ES', 'A', '0.00', '99.99', '55600', 'N', 'S', null, 'Acido Valproico..............:', null, 'ug/ml       ', '( 50 -  100 )', '50', '100', '-99999.99', '99999.99', '-99999.99', '99999.99', 'VAL', null, null, null, '1', '10', '2007-02-22 08:03:18', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('540', '0', '097', 'ES', 'A', '0.00', '99.99', '55800', 'N', 'S', '', 'Etosuximida', '', 'ÃƒÂ¦g/ml       ', '( 40 - 100 )', '40', '100', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('541', '0', '097', 'ES', 'A', '0.00', '99.99', '55900', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('542', '0', '098', 'ES', 'A', '0.00', '99.99', '56000', 'N', 'S', null, 'Teofilina....................:', null, 'ug/ml       ', '( 10  -  20 )', '10', '20', '-99999.99', '99999.99', '-99999.99', '99999.99', 'THEO', null, null, null, '1', '10', '2007-02-17 09:06:19', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('544', '0', '099', 'ES', 'A', '0.00', '99.99', '56200', 'N', 'S', '', 'Gentamicina', '', 'ÃƒÂ¦g/ml       ', '( 4 - 10 )', '4', '10', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('545', '0', '099', 'ES', 'A', '0.00', '99.99', '56300', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('546', '0', '100', 'ES', 'A', '0.00', '99.99', '56400', 'N', 'S', null, 'Digoxina.....................:', null, 'ng/ml          ', '( 0.8 - 2.1 )', '0.8', '2.1', '-99999.99', '99999.99', '-99999.99', '99999.99', 'DGNX', null, null, null, '1', '10', '2007-02-17 08:42:47', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('548', '0', '101', 'ES', 'A', '0.00', '99.99', '56600', 'N', 'S', '', 'Netilmicina', '', 'ÃƒÂ¦g/ml       ', '( 0 - 35 )', '-99999.99', '35', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('549', '0', '101', 'ES', 'A', '0.00', '99.99', '56700', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('550', '0', '102', 'ES', 'A', '0.00', '99.99', '56800', 'C', 'S', '', 'Sub-Unidad Beta HCG (Orina)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('551', '0', '102', 'ES', 'A', '0.00', '99.99', '56900', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('552', '0', '103', 'ES', 'A', '0.00', '99.99', '57000', 'N', 'S', '', 'Amikacina', '', 'ÃƒÂ¦g/ml       ', '( 20 - 25 )', '20', '25', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('553', '0', '104', 'ES', 'A', '0.00', '99.99', '57100', 'N', 'S', '', 'Kanamicina', '', 'ÃƒÂ¦g/ml       ', '( 5 - 25 )', '5', '25', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('554', '0', '104', 'ES', 'A', '0.00', '99.99', '57200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1469', '0', '142', 'ES', 'A', '0.00', '99.99', '75600', 'O', 'S', '', 'ANA (Anti-Nucleares):', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 07:15:33', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1415', '0', '105', 'ES', 'F', '0.00', '99.99', '100', 'N', 'S', null, 'Estradiol....................:', null, 'pg/ml', '(Fase Folicular:...........26 - 161)\r\n(Fase Lutea:.............32.7 - 201)\r\n(Periovulatoria+ - 3d:.... 186-382)\r\n(Post-Menopàusica:5.37 - 65.9)\r\n \r\n', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'E2', null, null, null, '1', '10', '2007-02-22 08:08:27', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('562', '0', '106', 'ES', 'A', '13.00', '99.99', '58000', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '( 96.9 - 169.0 )', '96.9', '169', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:29:55', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('563', '0', '106', 'ES', 'A', '1.00', '1.99', '58100', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '( N.D - 256 )', '-99999.99', '256', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:30:17', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('564', '0', '106', 'ES', 'A', '2.00', '2.99', '58200', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '(36.0 - 254.0)', '36', '254', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:33:33', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('565', '0', '106', 'ES', 'A', '3.00', '3.99', '58300', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '(42.0 -  248.0)', '42', '248', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:37:19', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('566', '0', '106', 'ES', 'A', '4.00', '4.99', '58400', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '(44.0 - 236.0)', '44', '236', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:34:34', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('567', '0', '106', 'ES', 'A', '5.00', '5.99', '58500', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '(44.0 - 225.0)', '44', '225', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:37:47', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('568', '0', '106', 'ES', 'A', '6.00', '6.99', '58600', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '(44.0 - 231.0)', '44', '231', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:38:07', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('569', '0', '106', 'ES', 'A', '7.00', '7.99', '58700', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '(43.0 - 220.0)', '43', '220', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:38:29', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('570', '0', '106', 'ES', 'A', '8.00', '8.99', '58800', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '(42.0 - 216.0)', '42', '216', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:38:52', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('571', '0', '106', 'ES', 'A', '9.00', '9.99', '58900', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '(42.0 - 212.0)', '42', '212', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:39:34', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('572', '0', '106', 'ES', 'A', '10.00', '10.99', '59000', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '(42.0 - 209.0)', '42', '209', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:39:12', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('573', '0', '106', 'ES', 'A', '11.00', '11.99', '59100', 'N', 'S', null, 'T-3..........................:', null, 'ng/dl          ', '(41.0 - 205.0)', '41', '205', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT3', null, null, null, '1', '10', '2007-02-22 08:39:49', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('576', '0', '107', 'ES', 'A', '1.00', '99.99', '59400', 'N', 'S', null, 'T-4..........................:', null, 'ug/dl      ', '(5.5 -  11.0)', '5.5', '11', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TT4', null, null, null, '1', '10', '2007-02-22 08:40:53', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('578', '0', '108', 'ES', 'M', '0.00', '99.99', '59600', 'N', 'S', null, 'Prolactina...................:', null, 'ng/ml          ', '( 2.5 - 17 )', '2.5', '17', '-99999.99', '99999.99', '-99999.99', '99999.99', 'PRL', null, null, null, '1', '10', '2007-02-22 07:44:37', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('579', '0', '108', 'ES', 'F', '0.00', '99.99', '59700', 'N', 'S', null, 'Prolactina...................:', null, 'ng/ml          ', '(1.9 -  25.0)', '1.9', '25', '-99999.99', '99999.99', '-99999.99', '99999.99', 'PRL', null, null, null, '1', '10', '2007-02-22 07:44:49', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1416', '0', '109', 'ES', 'F', '0.00', '99.99', '100', 'N', 'S', null, 'FSH..........................:', null, 'mUI/ml', '( Fase Folicular: 2.8- 14.4 )\r\n( Fase Lútea:.....1.2 - 9.0 )\r\n( Post-Menopausia: 9.7 -111 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'FSH', null, null, null, '1', '10', '2007-02-22 07:43:07', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('586', '0', '109', 'ES', 'M', '0.00', '99.99', '200', 'N', 'S', null, 'F.S.H........................:', null, 'mUI/ml         ', '( 1.55 - 9.74 )', '1.55', '9.74', '-99999.99', '99999.99', '-99999.99', '99999.99', 'FSH', null, null, null, '1', '10', '2007-02-22 07:43:22', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1420', '0', '120', 'ES', 'A', '0.00', '99.99', '100', 'O', 'S', null, 'Cultivo de..........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 08:17:40', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1419', '0', '119', 'ES', 'A', '0.00', '99.99', null, 'O', 'S', null, 'Frotis por GRAM.....:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 06:11:23', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1418', '0', '105', 'ES', 'M', '0.00', '99.99', '200', 'N', 'S', null, 'Estradiol....................:', null, 'pg/ml', '( 5.37 - 65.9 )', '5.37', '65.9', '-99999.99', '99999.99', '-99999.99', '99999.99', 'E2', null, null, null, '1', '10', '2007-02-22 08:08:44', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('594', '0', '110', 'ES', 'M', '0.00', '99.99', '61200', 'N', 'S', null, 'L.H..........................:', null, 'mUI/ml         ', '( 1.4 -  7.7 )', '1.4', '7.7', '-99999.99', '99999.99', '-99999.99', '99999.99', 'LH', null, null, null, '1', '10', '2007-02-22 07:44:03', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1417', '0', '110', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'L.H..........................:', null, 'mUI/ml', '( Fase Folicular:1.1 - 11.6 )\r\n( Ciclo Medio:      17 - 77 )\r\n( Fase Lútea:.....ND - 14.7 )\r\n( Perimenstrual:....ND - 12 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'LH', null, null, null, '1', '10', '2007-02-22 07:43:49', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('597', '0', '111', 'ES', 'M', '0.00', '99.99', '300', 'N', 'S', null, 'Progesterrona................:', null, 'ng/ml', '( ND - 0.75 )', '-99999.99', '0.75', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 18:00:06', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('598', '0', '111', 'ES', 'F', '0.00', '99.99', '100', 'N', 'S', null, 'Progesterona.................:', null, 'ng/ml', '  NO EMBARAZADAS\r\n( Fase Folicular:...ND-1.13 )\r\n( F.Folicular Media: ND-0.98)\r\n( Medio Ciclo:....0.48-1.72 )\r\n( Fase Lutea:.....0.95-21.0 )\r\n( F.Lutea Media:...6.0-24.0 )\r\n( Post Menopausica:..ND-1.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'PGN', null, null, null, '1', '10', '2007-02-23 07:14:45', 'E', '$VER', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1639', '0', '031', 'ES', 'A', '0.00', '0.10', '2300', 'N', 'S', '', 'En Banda.....................:', '0.0', '%', '( 1.0 - 5.0 )', '1', '5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 07:59:40', 'M', '$I', '0', null, 'R');
INSERT INTO `defaults` VALUES ('600', '0', '112', 'ES', 'F', '0.00', '99.99', '61800', 'N', 'S', null, 'Testosterona.................:', null, 'ng/dl          ', '( 5.71 - 77.0) ', '5.71', '77', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Testo', null, null, null, '1', '10', '2007-02-22 08:28:10', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('601', '0', '112', 'ES', 'M', '20.00', '49.00', '61900', 'N', 'S', null, 'Testosterona.................:', null, 'ng/dl          ', '( 132 -  813 ) ', '132', '813', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Testo', null, null, null, '1', '10', '2007-02-22 08:28:49', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('602', '0', '112', 'ES', 'M', '50.00', '99.99', '62000', 'N', 'S', null, 'Testosterona.................:', null, 'ng/dl          ', '( 71.8 - 623 )', '71.8', '623', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Testo', null, null, null, '1', '10', '2007-02-22 08:29:05', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('605', '0', '113', 'ES', 'A', '0.00', '99.99', '62300', 'N', 'S', '', 'Cortisol', '', 'ÃƒÂ¦g/24       ', '( 20 - 90 )', '20', '90', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('606', '0', '113', 'ES', 'A', '0.00', '99.99', '62400', 'N', 'S', '', 'Creatinina en Orina', '', 'mg/dl          ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('607', '0', '113', 'ES', 'A', '0.00', '99.99', '62500', 'N', 'S', '', 'Volumen', '', 'ml/24          ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('608', '0', '113', 'ES', 'A', '0.00', '99.99', '62600', 'N', 'S', '', 'Creatininuria 24 hs', '', 'g/24           ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL54', '1', null, 'R');
INSERT INTO `defaults` VALUES ('609', '0', '113', 'ES', 'F', '0.00', '99.99', '62700', 'N', 'S', '', 'Creatininuria 24 hs', '', 'g/24           ', '( 0.8 - 1.8 )', '0.8', '1.8', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL54', '1', null, 'R');
INSERT INTO `defaults` VALUES ('610', '0', '113', 'ES', 'M', '0.00', '99.99', '62800', 'N', 'S', '', 'Creatininuria 24 hs', '', 'g/24           ', '( 1.0 - 2.0 )', '1', '2', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL54', '1', null, 'R');
INSERT INTO `defaults` VALUES ('611', '0', '113', 'ES', 'A', '0.00', '99.99', '62900', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('612', '0', '114', 'ES', 'A', '1.00', '99.99', '63000', 'N', 'S', null, 'Insulina- Ayunas.............:', null, 'uUI/ml      ', '( 6.0 -  27.0 )', '6', '27', '-99999.99', '99999.99', '-99999.99', '99999.99', 'INS', null, null, null, '1', '10', '2007-02-22 07:48:31', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('613', '0', '114', 'ES', 'A', '0.00', '99.99', '63100', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('614', '0', '115', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', '17-CETOSTEROIDES CETOGENICOS ', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'R');
INSERT INTO `defaults` VALUES ('615', '0', '115', 'ES', 'M', '0.00', '99.99', '200', 'N', 'S', '', 'Resultado', '', 'mg/24hs        ', '( 8.0 - 16.0 )', '8', '16', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('616', '0', '115', 'ES', 'F', '0.00', '99.99', '300', 'N', 'S', '', 'Resultado', '', 'mg/24hs        ', '( 6.0 - 17.0 )', '6', '17', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('617', '0', '115', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', '', 'Volumen', '', 'ml/24hs        ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('618', '0', '115', 'ES', 'A', '0.00', '99.99', '1000', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1594', '0', '323', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Herpes I IgG.................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:09:45', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1593', '0', '309', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Micoplasma IgM...............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:08:34', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1592', '0', '308', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Micoplasma IgG...............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:04:21', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1591', '0', '303', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Antígeno por Giardia.........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:03:11', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1590', '0', '294', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Helicobacter Pylori- IgA.....:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 13:57:45', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1604', '0', '028', 'ES', 'M', '0.00', '99.99', '1600', 'N', 'S', null, 'Grado 4+.................:', null, '%', '(Dezplazamiento Alto)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 10:50:10', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1601', '0', '028', 'ES', 'M', '0.00', '99.99', '1200', 'N', 'S', null, 'Grado 0..................:', null, '%', '(Inactividad)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 10:48:03', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1606', '0', '028', 'ES', 'M', '0.00', '99.99', '1700', 'T', 'S', null, 'Concentración', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 11:29:17', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1579', '0', '116', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'HCG-Cuantitativo.............:', null, 'mUI/ml', ' Semanas           mUI/ml\r\n( 1.3 - 2.0..........16-56 )\r\n( 2.0 - 3.0.......101-4870 )\r\n( 3.0 - 4.0.....1110-31500 )\r\n( 4.0 - 5.0.....2560-82300 )\r\n( 5.0 - 6.0...23100-151000 )\r\n( 6.0 - 7.0...27300-233000 )\r\n( 7.0 -11.0...20900-291000 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 16:34:59', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1666', '0', '111', 'ES', 'F', '0.00', '99.99', '200', 'S', 'S', null, 'Siguen Normales', null, 'ng/ml', '( Anticonc.Orales:0.34-0.92 )\r\n  EMBARAZADAS\r\n( Primer Trimestre:9.3-33.2 )\r\n( segundo Trimestre:29.5-50 )\r\n( Tercer Trimestre:  83-160 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 17:59:34', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('633', '0', '118', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'HCG-Cualitativa(Suero):', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 07:01:30', null, '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1468', '0', '122', 'ES', 'A', '0.00', '99.99', '69000', 'O', 'S', '', 'UROCULTIVO', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 06:19:50', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('635', '0', '121', 'ES', 'A', '0.00', '99.99', '65700', 'C', 'S', '', 'Organismo en prueba', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('636', '0', '121', 'ES', 'A', '0.00', '99.99', '65800', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$H1', '0', null, 'L');
INSERT INTO `defaults` VALUES ('637', '0', '121', 'ES', 'A', '0.00', '99.99', '65900', '', 'S', '', 'MIRAXID', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('638', '0', '121', 'ES', 'A', '0.00', '99.99', '66000', '', 'S', '', 'POLYMOX', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('639', '0', '121', 'ES', 'A', '0.00', '99.99', '66100', '', 'S', '', 'ZOROXIN', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('640', '0', '121', 'ES', 'A', '0.00', '99.99', '66200', '', 'S', '', 'SELEXID', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('641', '0', '121', 'ES', 'A', '0.00', '99.99', '66300', '', 'S', '', 'MACROFURADANTINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('642', '0', '121', 'ES', 'A', '0.00', '99.99', '66400', '', 'S', '', 'PIPRIL', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('643', '0', '121', 'ES', 'A', '0.00', '99.99', '66500', '', 'S', '', 'CEFALOTINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('644', '0', '121', 'ES', 'A', '0.00', '99.99', '66600', '', 'S', '', 'PENTREXIL', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('645', '0', '121', 'ES', 'A', '0.00', '99.99', '66700', '', 'S', '', 'ROCEPHIN', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('646', '0', '121', 'ES', 'A', '0.00', '99.99', '66800', '', 'S', '', 'SEPTRAN O BACTRIN', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('647', '0', '121', 'ES', 'A', '0.00', '99.99', '66900', '', 'S', '', 'TETRACICLINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('648', '0', '121', 'ES', 'A', '0.00', '99.99', '67000', '', 'S', '', 'CIPROXINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('649', '0', '121', 'ES', 'A', '0.00', '99.99', '67100', '', 'S', '', 'CLINDAMICINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('650', '0', '121', 'ES', 'A', '0.00', '99.99', '67200', '', 'S', '', 'DICLOCIL', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('651', '0', '121', 'ES', 'A', '0.00', '99.99', '67300', '', 'S', '', 'AMIKACIN', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('652', '0', '121', 'ES', 'A', '0.00', '99.99', '67400', '', 'S', '', 'CARBENICILINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('653', '0', '121', 'ES', 'A', '0.00', '99.99', '67500', '', 'S', '', 'GENTAMICINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('654', '0', '121', 'ES', 'A', '0.00', '99.99', '67600', '', 'S', '', 'KANAMICINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('655', '0', '121', 'ES', 'A', '0.00', '99.99', '67700', '', 'S', '', 'LINCOMICINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('656', '0', '121', 'ES', 'A', '0.00', '99.99', '67800', '', 'S', '', 'CEFATOXINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('657', '0', '121', 'ES', 'A', '0.00', '99.99', '67900', '', 'S', '', 'ERITROMICINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('658', '0', '121', 'ES', 'A', '0.00', '99.99', '68000', '', 'S', '', 'DURACEF', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('659', '0', '121', 'ES', 'A', '0.00', '99.99', '68100', '', 'S', '', 'VANCOMICINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('660', '0', '121', 'ES', 'A', '0.00', '99.99', '68200', '', 'S', '', 'ACIDO NALIDIXICO', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('661', '0', '121', 'ES', 'A', '0.00', '99.99', '68300', '', 'S', '', 'MINOCIN', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('662', '0', '121', 'ES', 'A', '0.00', '99.99', '68400', '', 'S', '', 'CLORANFENICOL', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('663', '0', '121', 'ES', 'A', '0.00', '99.99', '68500', '', 'S', '', 'ESTREPTOMICINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('664', '0', '121', 'ES', 'A', '0.00', '99.99', '68600', '', 'S', '', 'PENICILINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('665', '0', '121', 'ES', 'A', '0.00', '99.99', '68700', '', 'S', '', 'PROSTAFILINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('666', '0', '121', 'ES', 'A', '0.00', '99.99', '68800', '', 'S', '', 'CECLOR', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('667', '0', '121', 'ES', 'A', '0.00', '99.99', '68900', '', 'S', '', 'TOBRAMICINA', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('668', '0', '122', 'ES', 'A', '0.00', '99.99', '69100', 'C', 'S', null, 'Resultado...........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 06:17:22', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('669', '0', '122', 'ES', 'A', '0.00', '99.99', '69300', 'C', 'S', null, 'Recuento de Colonias:', null, '/ml', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 06:25:16', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('670', '0', '122', 'ES', 'A', '0.00', '99.99', '69200', 'C', 'S', null, 'Organismo Aislado...:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 06:24:57', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('671', '0', '123', 'ES', 'A', '0.00', '99.99', '69300', 'C', 'S', null, 'Coprocultivo........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('672', '0', '123', 'ES', 'A', '0.00', '99.99', '69400', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-07 13:21:55', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('673', '0', '124', 'ES', 'A', '0.00', '99.99', '69500', 'C', 'S', null, 'Cultivo por BAR.....:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('674', '0', '124', 'ES', 'A', '0.00', '99.99', '69600', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-07 13:23:11', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('675', '0', '125', 'ES', 'A', '0.00', '99.99', '69700', 'C', 'S', null, 'Cultivo por Hongos  :', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('676', '0', '125', 'ES', 'A', '0.00', '99.99', '69800', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-07 13:24:31', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('677', '0', '126', 'ES', 'A', '0.00', '99.99', '69900', 'C', 'S', null, 'Hemocultivo.........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('678', '0', '126', 'ES', 'A', '0.00', '99.99', '70000', 'C', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-07 13:25:35', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('679', '0', '127', 'ES', 'A', '0.00', '99.99', '70100', 'N', 'S', null, 'V.D.R.L......................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:22:47', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('680', '0', '127', 'ES', 'A', '0.00', '99.99', '70200', 'N', 'S', null, 'Título.......................:', '1:', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:23:03', 'M', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('681', '0', '127', 'ES', 'A', '0.00', '99.99', '70300', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-07 13:26:45', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('682', '0', '128', 'ES', 'A', '0.00', '99.99', '70400', 'N', 'S', null, 'S.Typhosa O (somático).......:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:23:56', 'M', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('683', '0', '128', 'ES', 'A', '0.00', '99.99', '70500', 'O', 'S', null, 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 07:29:54', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('684', '0', '128', 'ES', 'A', '0.00', '99.99', '70600', 'N', 'S', null, 'S.Typhosa H(flagelar)........:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:24:15', 'M', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('685', '0', '128', 'ES', 'A', '0.00', '99.99', '70700', 'O', 'S', null, 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 07:30:54', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('686', '0', '128', 'ES', 'A', '0.00', '99.99', '70800', 'N', 'S', null, 'Parathyphi A(somático).......:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:24:49', 'M', '$E', '0', null, 'R');
INSERT INTO `defaults` VALUES ('687', '0', '128', 'ES', 'A', '0.00', '99.99', '70900', 'O', 'S', null, 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 07:31:47', '', '$F', '0', null, 'L');
INSERT INTO `defaults` VALUES ('688', '0', '128', 'ES', 'A', '0.00', '99.99', '71000', 'N', 'S', null, 'Parathyphi B(somatico).......:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:25:37', 'M', '$G', '0', null, 'R');
INSERT INTO `defaults` VALUES ('689', '0', '128', 'ES', 'A', '0.00', '99.99', '71100', 'O', 'S', null, 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 07:32:50', '', '$H', '0', null, 'L');
INSERT INTO `defaults` VALUES ('696', '0', '128', 'ES', 'A', '0.00', '99.99', '71800', 'N', 'S', null, 'Proteus OX-K.................:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:26:00', 'M', '$O', '0', null, 'R');
INSERT INTO `defaults` VALUES ('697', '0', '128', 'ES', 'A', '0.00', '99.99', '71900', 'O', 'S', null, 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 07:36:23', '', '$P', '0', null, 'L');
INSERT INTO `defaults` VALUES ('698', '0', '128', 'ES', 'A', '0.00', '99.99', '72000', 'N', 'S', null, 'Proteus OX-2.................:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:26:30', 'M', '$Q', '0', null, 'R');
INSERT INTO `defaults` VALUES ('699', '0', '128', 'ES', 'A', '0.00', '99.99', '72100', 'O', 'S', null, 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 07:36:57', '', '$R', '0', null, 'L');
INSERT INTO `defaults` VALUES ('700', '0', '128', 'ES', 'A', '0.00', '99.99', '72200', 'N', 'S', null, 'Proteus OX-19................:', 'NEGATIVO', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:26:54', 'M', '$S', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1473', '0', '128', 'ES', 'A', '0.00', '99.99', '72300', 'O', 'S', '', 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 07:53:32', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1643', '0', '031', 'ES', 'A', '0.09', '3.99', '2600', 'N', 'S', null, 'Neutrófilos..................:', null, '%', '( 28.0-50.0 ) ', '28', '50', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:15:22', 'E', '$J', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1474', '0', '120', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', null, 'Resultado...........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 08:26:07', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('706', '0', '129', 'ES', 'A', '0.00', '99.99', '72800', 'N', 'S', null, 'Factor Reumatoideo...........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:27:57', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('707', '0', '129', 'ES', 'A', '0.00', '99.99', '72900', 'N', 'S', null, 'Título.......................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:28:17', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('708', '0', '130', 'ES', 'A', '0.00', '99.99', '73000', 'N', 'S', null, 'Proteina C Reactiva..........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CRP', null, null, null, '1', '10', '2007-02-17 08:42:00', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('709', '0', '130', 'ES', 'A', '0.00', '99.99', '73100', 'N', 'S', null, 'Título.......................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CRP', null, null, null, '1', '10', '2007-02-17 08:42:13', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('710', '0', '131', 'ES', 'A', '0.00', '99.99', '73200', 'N', 'S', null, 'A.S.T.O......................:', null, '         ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:29:50', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('711', '0', '131', 'ES', 'A', '0.00', '99.99', '73300', 'O', 'S', null, 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 06:38:26', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('712', '0', '132', 'ES', 'A', '0.00', '99.99', '73400', 'N', 'S', null, 'Mono-Test...........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 10:22:44', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1616', '0', '031', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'HEMOGRAMA COMPLETO', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 17:55:03', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1556', '0', '205', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'ELECTROFORESIS DE HEMOGLOBINA', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 06:09:11', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('714', '0', '133', 'ES', 'A', '0.00', '99.99', '73600', 'C', 'S', '', 'Paul-Bunnell', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('715', '0', '133', 'ES', 'A', '0.00', '99.99', '73700', 'C', 'S', '', 'TÃƒÂ­tulo 1', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('716', '0', '133', 'ES', 'A', '0.00', '99.99', '73800', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('717', '0', '134', 'ES', 'A', '0.00', '99.99', '73900', 'C', 'S', '', 'I.F.A. Toxoplasma (IgG)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('718', '0', '134', 'ES', 'A', '0.00', '99.99', '74000', 'C', 'S', '', 'TÃƒÂ­tulo 1', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('719', '0', '135', 'ES', 'A', '0.00', '99.99', '74100', 'C', 'S', '', 'I.F.A. Toxoplasma (IgM)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('720', '0', '135', 'ES', 'A', '0.00', '99.99', '74200', 'C', 'S', '', 'TÃƒÂ­tulo 1', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('721', '0', '136', 'ES', 'A', '0.00', '99.99', '74300', 'N', 'S', null, 'F.T.A./ABS...................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 15:30:46', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('723', '0', '137', 'ES', 'A', '0.00', '99.99', '74500', 'C', 'S', '', '35b', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$4', '0', null, 'L');
INSERT INTO `defaults` VALUES ('724', '0', '137', 'ES', 'A', '0.00', '99.99', '74600', 'C', 'S', '', 'Tuberculina (RT-23)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('725', '0', '138', 'ES', 'A', '0.00', '99.99', '74700', 'C', 'S', '', 'HLA-B 27', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('726', '0', '139', 'ES', 'A', '0.00', '99.99', '74800', 'N', 'S', null, 'Antígeno Australiano.........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'HBsAg', null, null, null, '1', '10', '2007-02-22 08:18:39', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('727', '0', '139', 'ES', 'A', '0.00', '99.99', '74900', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-07 13:34:34', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('728', '0', '140', 'ES', 'A', '0.00', '99.99', '75000', 'C', 'S', '', 'I.F.A. Para Herpes tipo I', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('729', '0', '140', 'ES', 'A', '0.00', '99.99', '75100', 'C', 'S', '', 'TÃƒÂ­tulo 1', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('730', '0', '140', 'ES', 'A', '0.00', '99.99', '75200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('731', '0', '141', 'ES', 'A', '0.00', '99.99', '75300', 'C', 'S', '', 'I.F.A. para Herpes Tipo II', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('732', '0', '141', 'ES', 'A', '0.00', '99.99', '75400', 'C', 'S', '', 'TÃƒÂ­tulo 1', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('733', '0', '141', 'ES', 'A', '0.00', '99.99', '75500', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('734', '0', '142', 'ES', 'A', '0.00', '99.99', '75700', 'N', 'S', null, 'Resultado....................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 08:05:45', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('735', '0', '142', 'ES', 'A', '0.00', '99.99', '75800', 'N', 'S', null, 'Título.......................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 08:06:03', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('736', '0', '142', 'ES', 'A', '0.00', '99.99', '75900', 'N', 'S', null, 'Patron.......................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 08:08:50', 'E', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('737', '0', '142', 'ES', 'A', '0.00', '99.99', '76000', 'N', 'S', null, 'Tejido Utilizado.............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 08:09:12', 'E', '$D', '0', null, 'R');
INSERT INTO `defaults` VALUES ('738', '0', '143', 'ES', 'A', '0.00', '99.99', '76000', 'N', 'S', null, 'Anti-DNA.....................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 08:10:52', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('739', '0', '143', 'ES', 'A', '0.00', '99.99', '76100', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 06:16:36', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('740', '0', '144', 'ES', 'A', '0.00', '99.99', '76200', 'N', 'S', null, 'Anti-Tiroglobulina...........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 08:11:37', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('741', '0', '144', 'ES', 'A', '0.00', '99.99', '76300', 'O', 'S', null, 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 08:32:48', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('742', '0', '145', 'ES', 'A', '0.00', '99.99', '76400', 'N', 'S', null, 'Anti-Microsomales............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 08:54:10', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('743', '0', '145', 'ES', 'A', '0.00', '99.99', '76500', 'O', 'S', null, 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 08:33:34', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('744', '0', '146', 'ES', 'A', '0.00', '99.99', '76600', 'N', 'S', null, 'Anti-Mitocondriales..........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 08:54:41', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('745', '0', '146', 'ES', 'A', '0.00', '99.99', '76700', 'N', 'S', null, 'Título.......................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 08:54:58', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('746', '0', '147', 'ES', 'A', '0.00', '99.99', '76800', 'N', 'S', null, 'Ac.Vanil Mandélico  :', null, 'mg/24hs        ', '( 1.8 -10.0 )', '1.8', '10', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('747', '0', '147', 'ES', 'A', '0.00', '99.99', '76900', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('748', '0', '147', 'ES', 'A', '0.00', '99.99', '77000', 'C', 'S', null, 'Volumen.............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1630', '0', '031', 'ES', 'A', '0.00', '99.99', '1500', 'F', 'S', null, 'VCM..........................:', 'B*10/C', 'fl', '( 80.0-100.0)', '80', '100', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 18:25:06', 'M', '$CAL1', '0', '$B*10/$C', 'R');
INSERT INTO `defaults` VALUES ('1629', '0', '031', 'ES', 'A', '0.21', '99.99', '1400', 'F', 'S', null, 'HCM..........................:', 'A*10/C', 'pg', '( 28.0-34.0 )', '28', '34', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 18:24:30', 'M', '$CAL1', '0', '$A*10/$C', 'R');
INSERT INTO `defaults` VALUES ('1628', '0', '031', 'ES', 'A', '0.00', '99.99', '1300', 'F', 'S', null, 'CHCM.........................:', 'A*100/B', '%', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 18:23:37', 'M', '$CAL1', '0', '$A*100/$B', 'R');
INSERT INTO `defaults` VALUES ('1627', '0', '031', 'ES', 'M', '15.00', '99.99', '1200', 'N', 'S', null, 'Eritrocitos..................:', null, 'millones/mm³', '( 4.5 - 6.5 )', '4.5', '6.5', '6.5', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 12:29:06', 'E', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1626', '0', '031', 'ES', 'F', '15.00', '99.99', '1100', 'N', 'S', null, 'Eritrocitos..................:', null, 'millones/mm³', '( 4.0 - 5.3 )', '4', '5.3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 12:28:45', 'E', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1624', '0', '031', 'ES', 'A', '0.16', '9.99', '900', 'N', 'S', null, 'Eritrocitos..................:', null, 'millones/mm³', '( 3.7 - 4.4 )', '3.7', '4.4', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 12:30:02', 'E', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1625', '0', '031', 'ES', 'A', '10.00', '14.99', '1000', 'N', 'S', null, 'Eritrocitos..................:', null, 'millones/mm³', '( 3.7-4.5 )', '3.7', '4.5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 16:32:01', 'E', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1623', '0', '031', 'ES', 'M', '15.00', '99.99', '800', 'N', 'S', '', 'Hematocrito..................:', null, '%', '( 42.0-54.0 )', '42', '54', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 16:02:06', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1622', '0', '031', 'ES', 'F', '15.00', '99.99', '700', 'N', 'S', '', 'Hematocrito..................:', null, '%', '( 38.0-47.0 )', '38', '47', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 15:59:25', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1621', '0', '031', 'ES', 'A', '0.16', '14.99', '600', 'N', 'S', null, 'Hematocrito..................:', null, '%', '( 34.0-39.0 )', '34', '39', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 16:30:54', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1620', '0', '031', 'ES', 'M', '15.00', '99.99', '500', 'N', 'S', null, 'hemoglobina..................:', null, 'mg/dl', '( 14.3-17.0 )', '14.3', '17', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 15:56:03', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1571', '0', '206', 'ES', 'A', '0.00', '99.99', '1000', 'F', 'S', null, 'Albumina/Globulinas..........:', null, null, '( 1.2 - 2.2 )', '1.2', '2.2', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 07:54:43', 'E', null, '0', '$B/($C+$D+$E+$F)', 'R');
INSERT INTO `defaults` VALUES ('1570', '0', '206', 'ES', 'A', '0.00', '99.99', '900', 'N', 'S', null, 'Gama Globulinas..............:', null, 'g/dl', '( 0.6 - 1.5 )', '0.6', '1.5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 07:41:55', 'E', '$F', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1569', '0', '206', 'ES', 'A', '0.00', '99.99', '800', 'N', 'S', null, 'Beta Globulinas..............:', null, 'g/dl', '( 0.5 - 1.2 )', '0.5', '1.2', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 07:42:15', 'E', '$E', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1561', '0', '205', 'ES', 'A', '0.00', '99.99', '600', 'N', 'S', null, 'Hemoglobina C................:', '0.0', '%', '( Ausente   )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 09:31:09', 'M', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1560', '0', '205', 'ES', 'A', '0.00', '99.99', '500', 'N', 'S', null, 'Hemoglobina S................:', '0.0', '%', '( Ausente   )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 09:30:48', 'M', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1559', '0', '205', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'Hemoglobina F................:', '0.0', '%', '( Ausente   )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 09:30:35', 'M', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1558', '0', '205', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Hemoglobina A2...............:', null, '%', '( 1.5 - 4.0 )', '1.5', '4', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 09:30:19', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1542', '0', '229', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Toxoplasmosis (IgM)..........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 10:16:51', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1541', '0', '228', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Toxoplasmosis (IgG)..........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TXP', null, null, null, '1', '10', '2007-02-22 07:52:08', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1540', '0', '250', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'PERFIL PROSTATICO', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 18:46:12', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1539', '0', '148', 'ES', 'A', '12.00', '13.00', '2000', 'N', 'S', '', 'Inmunoglobulina M............:', null, 'mg/dl', '( 70 -  150 )', '70', '150', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 14:01:56', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1538', '0', '148', 'ES', 'A', '7.00', '11.00', '1900', 'N', 'S', '', 'Inmunoglobulina M............:', null, 'mg/dl', '( 60 -  175 )', '60', '175', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:58:42', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1537', '0', '148', 'ES', 'A', '3.00', '6.00', '1800', 'N', 'S', '', 'Inmunoglobulina M............:', null, 'mg/dl', '( 40 - 210 )', '40', '210', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:56:51', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1536', '0', '148', 'ES', 'A', '7.00', '24.00', '1700', 'N', 'S', '', 'Inmunoglobulina M............:', null, 'mg/dl', '( 36 -  160 )', '36', '160', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:55:10', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1535', '0', '148', 'ES', 'A', '0.00', '0.60', '1600', 'N', 'S', '', 'Inmunoglobulina M............:', null, 'mg/dl', '( 12 -  120 )', '12', '120', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:52:46', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1534', '0', '148', 'ES', 'F', '0.00', '99.99', '1500', 'N', 'S', '', 'Inmunoglobulina M............:', null, 'mg/dl', '( 60 -  370 )', '60', '370', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:49:19', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1533', '0', '148', 'ES', 'M', '0.00', '99.99', '1400', 'N', 'S', '', 'Inmunoglobulina M............:', null, 'mg/dl', '( 50 -  320 )', '50', '320', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:45:46', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1532', '0', '148', 'ES', 'A', '12.00', '13.00', '1300', 'N', 'S', '', 'Inmunoglobulina A............:', null, 'mg/dl', '( 108 - 325 )', '108', '325', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:42:56', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1531', '0', '148', 'ES', 'A', '7.00', '11.00', '1200', 'N', 'S', '', 'Inmunoglobulina A', null, 'mg/dl', '( 65 -  260 )', '65', '260', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:40:59', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1530', '0', '148', 'ES', 'A', '3.00', '6.00', '1100', 'N', 'S', '', 'Inmunoglobulina A', null, 'mg/dl', '( 45 -  220 )', '45', '220', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:39:18', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1529', '0', '148', 'ES', 'A', '0.70', '2.00', '1000', 'N', 'S', '', 'Inmunoglobulina A............:', null, 'mg/dl', '( 36 -  165 )', '36', '65', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:37:29', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1528', '0', '148', 'ES', 'A', '0.00', '0.60', '900', 'N', 'S', '', 'Inmunogobulina A.............:', null, 'mg/dl', '( 6.0 -96.0 )', '6', '96', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:34:31', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1527', '0', '148', 'ES', 'A', '0.00', '99.99', '800', 'N', 'S', '', 'Inmunoglobulina A............:', null, 'mg/dl', '( 90 -  450 )', '90', '450', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:30:59', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1526', '0', '148', 'ES', 'A', '12.00', '13.00', '700', 'N', 'S', '', 'Inmunoglobulina G............:', null, 'mg/dl', '( 770- 1510 )', '770', '1510', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:27:55', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1525', '0', '148', 'ES', 'A', '7.00', '11.00', '600', 'N', 'S', null, 'Inmunoglobulina G', null, 'mg/dl', '( 570-1410 )', '570', '1410', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 14:05:34', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1524', '0', '148', 'ES', 'A', '3.00', '6.00', '500', 'N', 'S', null, 'Inmunoglobulina G............:', null, 'mg/dl', '( 500- 1440 )', '500', '1440', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 14:05:06', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1523', '0', '148', 'ES', 'A', '0.70', '2.00', '400', 'N', 'S', null, 'Inmunoglobulina G............:', null, 'mg/dl', '( 350- 1180 )', '350', '1180', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 14:04:38', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1522', '0', '148', 'ES', 'A', '0.00', '0.60', '300', 'N', 'S', null, 'Inmunoglobulina G............:', null, 'mg/dl', '( 190 - 860 )', '190', '860', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 14:04:09', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1520', '0', '148', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Inmunoglobulina G ...........:', null, 'mg/dl', '( 80 - 1800 )', '80', '1800', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 14:02:33', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1521', '0', '148', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'INMUNOGLOBULINAS', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 13:14:24', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('795', '0', '149', 'ES', 'A', '0.00', '99.99', '81700', 'C', 'S', '', 'Investigacion por Citomegalovi', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('796', '0', '149', 'ES', 'A', '0.00', '99.99', '81800', 'C', 'S', '', 'Titulo', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('797', '0', '149', 'ES', 'A', '0.00', '99.99', '81900', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('798', '0', '150', 'ES', 'A', '0.00', '99.99', '82000', 'C', 'S', '', 'Inmunofluorescencia por B.K', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('799', '0', '151', 'ES', 'A', '13.00', '99.00', '82100', 'N', 'S', null, 'T.S.H........................:', null, 'mUI/L          ', '(0.40 - 4.00)', '0.4', '4', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TSH', null, null, null, '1', '10', '2007-02-22 08:42:08', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('800', '0', '151', 'ES', 'A', '1.00', '1.99', '82200', 'N', 'S', null, 'T.S.H........................:', null, 'mUI/L          ', '( 0.40 - 8.6 )', '0.4', '8.6', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TSH', null, null, null, '1', '10', '2007-02-22 08:42:26', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('801', '0', '151', 'ES', 'A', '3.00', '3.99', '82300', 'N', 'S', null, 'T.S.H........................:', null, 'mUI/L          ', '( 0.33 - 6.7 )', '0.33', '6.7', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TSH', null, null, null, '1', '10', '2007-02-22 08:42:49', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('802', '0', '151', 'ES', 'A', '4.00', '4.99', '82400', 'N', 'S', null, 'T.S.H........................:', null, 'mUI/L          ', '( 0.33 - 6.3 )', '0.33', '6.3', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TSH', null, null, null, '1', '10', '2007-02-22 08:43:10', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('803', '0', '151', 'ES', 'A', '5.00', '5.99', '82500', 'N', 'S', null, 'T.S.H.......................:', null, 'mUI/L          ', '( 0.34 - 6.1 )', '0.34', '6.1', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TSH', null, null, null, '1', '10', '2007-02-22 08:43:28', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('804', '0', '151', 'ES', 'A', '6.00', '6.99', '82600', 'N', 'S', null, 'T.S.H........................:', null, 'mUI/L          ', '( 0.34 - 6.0 )', '0.34', '6', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TSH', null, null, null, '1', '10', '2007-02-22 08:43:46', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('805', '0', '151', 'ES', 'A', '7.00', '7.99', '82700', 'N', 'S', null, 'T.S.H........................:', null, 'mUI/L          ', '( 0.35 - 5.8 )', '0.35', '5.8', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TSH', null, null, null, '1', '10', '2007-02-22 08:44:03', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('806', '0', '151', 'ES', 'A', '8.00', '8.99', '82800', 'N', 'S', null, 'T.S.H........................:', null, 'mUI/L          ', '( 0.35 - 5.7 )', '0.35', '5.7', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TSH', null, null, null, '1', '10', '2007-02-22 08:44:26', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('807', '0', '151', 'ES', 'A', '9.00', '9.99', '82900', 'N', 'S', null, 'T.S.H........................:', null, 'mUI/L          ', '( 0.35 - 5.6 )', '0.35', '5.6', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TSH', null, null, null, '1', '10', '2007-02-22 08:45:41', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('808', '0', '151', 'ES', 'A', '10.00', '10.99', '83000', 'N', 'S', null, 'T.S.H........................:', null, 'mUI/L          ', '( 0.36 - 5.5 )', '0.36', '5.5', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TSH', null, null, null, '1', '10', '2007-02-22 08:45:57', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('809', '0', '151', 'ES', 'A', '11.00', '11.99', '83100', 'N', 'S', null, 'T.S.H........................:', null, 'mUI/L          ', '( 0.36 - 5.5 )', '0.36', '5.5', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TSH', null, null, null, '1', '10', '2007-02-22 08:44:45', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('810', '0', '151', 'ES', 'A', '0.00', '99.99', '83200', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 13:57:51', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1475', '0', '038', 'ES', 'A', '0.00', '99.99', '300', 'T', 'S', '', 'HIERRO SERICO TOTAL', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-08 16:39:39', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('812', '0', '152', 'ES', 'A', '0.00', '99.99', '83400', 'N', 'S', null, 'T4 Libre.....................:', null, 'ng/dl          ', '( 0.77 - 2.17 ) ', '0.77', '2.17', '-99999.99', '99999.99', '-99999.99', '99999.99', 'FT4', null, null, null, '1', '10', '2007-02-22 08:16:56', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('814', '0', '153', 'ES', 'A', '0.00', '99.99', '83600', 'N', 'S', '', 'E.T.R.', '', 'ug/dl          ', '( 5.0 - 12.0 )', '5', '12', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('815', '0', '153', 'ES', 'A', '0.00', '99.99', '83700', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('816', '0', '154', 'ES', 'A', '0.00', '99.99', '83800', 'N', 'S', null, 'Rubeola (IgG)................:', null, '               ', '(Menor de 1:5)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 08:57:11', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('817', '0', '154', 'ES', 'A', '0.00', '99.99', '83900', 'N', 'S', null, 'Título.......................:', null, '               ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 08:57:36', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1476', '0', '118', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', '', 'Sensibilidad: 25 mU/ml', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 07:01:02', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1513', '0', '155', 'ES', 'A', '0.00', '99.99', '700', 'O', 'S', null, 'Procedencia del Agua:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 11:18:05', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('821', '0', '155', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Recuento de Coliformes Totales', null, 'UFC/100 ml', '( 0 - 10 )', '-99999.99', '10', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 08:33:17', 'E', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('822', '0', '155', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'Recuento de Coliformes Fecales', null, 'UFC/100 ml', '( 0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 08:33:36', 'E', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('824', '0', '155', 'ES', 'A', '0.00', '99.99', '800', 'O', 'S', null, 'OBSERVACIONES', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 11:02:16', 'E', '$E', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1642', '0', '031', 'ES', 'A', '4.00', '9.99', '2600', 'N', 'S', '', 'Neutrófilos..................:', null, '%', '( 35.0-65.0 )', '35', '65', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:06:37', 'E', '$J', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1641', '0', '031', 'ES', 'A', '0.00', '0.08', '2500', 'N', 'S', null, 'Neutrófilos..................:', null, '%', '(17.0 - 37.0 )', '17', '37', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:07:28', 'E', '$J', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1640', '0', '031', 'ES', 'A', '0.11', '99.99', '2400', 'N', 'S', '', 'En Banda.....................:', '0.0', '%', '( 0.0 - 3.0 )', '-99999.99', '3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 08:01:35', 'M', '$I', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1638', '0', '031', 'ES', 'A', '0.00', '99.99', '2200', 'N', 'S', '', 'Metamielocitos...............:', '0.0', '%', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 07:47:47', 'M', '$H', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1637', '0', '031', 'ES', 'A', '0.00', '99.99', '2100', 'N', 'S', null, 'Mielocitos...................:', '0.0', '%', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 07:49:23', 'M', '$G', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1636', '0', '031', 'ES', 'A', '0.00', '99.99', '2000', 'N', 'S', null, 'Promielocitos................:', ' 0.0 ', '%', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 07:11:27', 'M', '$S', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1634', '0', '031', 'ES', 'A', '10.00', '99.99', '1800', 'N', 'S', null, 'Leucocitos...................:', null, 'mm³', '( 5000-10000)', '5000', '10000', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 16:06:34', 'E', '$D', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1635', '0', '031', 'ES', 'A', '0.00', '99.99', '1900', 'N', 'S', null, 'Mieloblastos.................:', '0.0', '%', '( 0.0 - 0.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 07:11:07', 'M', '$R', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1506', '0', '161', 'ES', 'A', '0.00', '99.99', null, 'C', 'S', '', null, null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 11:42:42', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1514', '0', '155', 'ES', 'A', '0.00', '99.99', '500', 'O', 'S', '', 'Declorante:Na2S2O2/Normas AWWA', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 08:31:19', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1504', '0', '160', 'ES', 'A', '0.00', '99.99', '500', 'T', 'S', null, 'POTASIO EN ORINA/24 Hrs', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 11:59:27', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1477', '0', '156', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Complemento C3...............:', null, 'mg/dl', '(90.0- 180.0)', '90', '180', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 07:43:19', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1505', '0', '161', 'ES', 'A', '0.00', '99.99', '88800', 'T', 'S', '', 'SODIO EN ORINA/24 HRS', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 11:42:20', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1503', '0', '018', 'ES', 'A', '0.00', '99.99', '400', 'F', 'S', null, 'Fosfaturia /24 Hrs...........:', null, 'g/24 Hrs.', '( 0.4 - 1.3 )', '0.4', '1.3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 08:25:23', 'E', null, '0', '$A*$B/1000', 'R');
INSERT INTO `defaults` VALUES ('1501', '0', '022', 'ES', 'A', '0.00', '99.99', '500', 'N', 'S', '', 'Volumen de orina en ml/min.:  ', null, 'ml/min', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 07:13:35', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1498', '0', '350', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', '', 'MUESTRA', 'SUERO', null, 'ORINA', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, '1', '1', '10', '2007-02-10 10:48:29', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1499', '0', '350', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', '', 'Glucosa Ayunas...............:', null, 'mg/dl', '( 70 -  100 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 10:51:41', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1484', '0', '165', 'ES', 'A', '15.00', '17.00', '700', 'N', 'S', null, 'Hormona de Crecimiento.......:', null, 'ng/ml', '(0.08 - 12.2)', '0.08', '12.2', '-99999.99', '99999.99', '-99999.99', '99999.99', 'GH', null, null, null, '1', '10', '2007-02-22 08:01:21', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1483', '0', '165', 'ES', 'A', '11.00', '14.00', '600', 'N', 'S', null, 'Hormona de Crecimiento.......:', null, 'ng/ml', '(0.08 - 17.8)', '0.08', '17.8', '-99999.99', '99999.99', '-99999.99', '99999.99', 'GH', null, null, null, '1', '10', '2007-02-22 08:01:06', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1482', '0', '165', 'ES', 'A', '7.00', '10.00', '500', 'N', 'S', null, 'Hormona de Crecimiento.......:', null, 'ng/ml', '( 0.08- 5.4 )', '0.08', '5.4', '-99999.99', '99999.99', '-99999.99', '99999.99', 'GH', null, null, null, '1', '10', '2007-02-22 08:00:47', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1481', '0', '165', 'ES', 'A', '1.00', '6.00', '400', 'N', 'S', null, 'Hormona de Crecimiento.......:', null, 'ng/ml', '( 0.09 - 3.5)', '0.09', '3.5', '-99999.99', '99999.99', '-99999.99', '99999.99', 'GH', null, null, null, '1', '10', '2007-02-22 08:00:23', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1480', '0', '165', 'ES', 'A', '0.10', '0.99', '300', 'N', 'S', null, 'Hormona de Crecimiento.......:', null, 'ng/ml', '(0.69 - 27.0)', '0.69', '27', '-99999.99', '99999.99', '-99999.99', '99999.99', 'GH', null, null, null, '1', '10', '2007-02-22 07:59:56', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1479', '0', '165', 'ES', 'M', '18.00', '99.99', '200', 'N', 'S', null, 'Hormona de Crecimiento.......:', null, 'ng/ml', '( 0.0 - 1.0 )', '-99999.99', '1', '-99999.99', '99999.99', '-99999.99', '99999.99', 'GH', null, null, null, '1', '10', '2007-02-22 07:59:17', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1478', '0', '157', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Complemento C4...............:', null, 'mg/dl', '(20.0 - 50.0)', '20', '50', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 11:57:58', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('857', '0', '158', 'ES', 'A', '0.00', '99.99', '87900', 'N', 'S', null, 'CH-50...............:', null, '     ', '( 20 - 45 )', '20', '45', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('858', '0', '158', 'ES', 'A', '0.00', '99.99', '88000', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('859', '0', '159', 'ES', 'A', '0.00', '99.99', '88100', 'C', 'S', '', 'pH', '', '', '( 7.35 - 7.45 )', '7.35', '7.45', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('860', '0', '159', 'ES', 'A', '0.00', '99.99', '88200', 'N', 'S', '', 'pO2', '', 'mmHg           ', '( 80 - 100 )', '80', '100', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('861', '0', '159', 'ES', 'A', '0.00', '99.99', '88300', 'N', 'S', '', 'pCO2', '', 'mmHg           ', '( 35 - 45 )', '35', '45', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('862', '0', '159', 'ES', 'A', '0.00', '99.99', '88400', 'N', 'S', '', 'HCO3', '', 'mEq/L          ', '( 22 - 26 )', '22', '26', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '1', null, 'R');
INSERT INTO `defaults` VALUES ('863', '0', '159', 'ES', 'A', '0.00', '99.99', '88500', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$E', '0', null, 'L');
INSERT INTO `defaults` VALUES ('864', '0', '160', 'ES', 'A', '0.00', '99.99', '88600', 'N', 'S', null, 'Potasio......................:', null, 'mmol/L    ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 07:55:33', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('865', '0', '160', 'ES', 'A', '0.00', '99.99', '88700', 'N', 'S', null, 'Volumen......................:', null, 'L/24 Hrs       ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 12:00:00', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('866', '0', '160', 'ES', 'A', '0.00', '99.99', '88800', 'F', 'S', null, 'Potasio en orina/24 Hrs......:', null, 'mmol/ 24 Hrs  ', '( 25 - 125 )', '25', '125', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 12:00:30', 'E', '$CAL52', '0', '$A*$B', 'R');
INSERT INTO `defaults` VALUES ('867', '0', '161', 'ES', 'A', '0.00', '99.99', '88900', 'N', 'S', null, 'Sodio........................:', null, 'mmol/L        ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 11:37:14', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('868', '0', '161', 'ES', 'A', '0.00', '99.99', '89000', 'N', 'S', null, 'Volumen......................:', null, 'L/24h         ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 11:21:35', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('869', '0', '161', 'ES', 'A', '0.00', '99.99', '89100', 'F', 'S', null, 'Sodio en Orina/24 Hrs', null, 'mmol/24h       ', '( 40 - 220 ) ', '40', '220', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 11:39:35', 'E', '$CAL54', '0', '$A*$B', 'R');
INSERT INTO `defaults` VALUES ('870', '0', '162', 'ES', 'A', '0.00', '99.99', '89200', 'N', 'S', null, 'Fibrinogeno..................:', null, 'mg/dl          ', '(150.0-375.0)', '150', '375', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 12:35:26', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('871', '0', '162', 'ES', 'A', '0.00', '99.99', '89300', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 06:39:14', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('872', '0', '163', 'ES', 'A', '0.00', '99.99', '89400', 'C', 'S', '', 'Color', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('873', '0', '163', 'ES', 'A', '0.00', '99.99', '89500', 'C', 'S', '', 'Viscosidad', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('874', '0', '163', 'ES', 'A', '0.00', '99.99', '89600', 'N', 'S', '', 'Espermatozoides', '', 'campo          ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('875', '0', '163', 'ES', 'A', '0.00', '99.99', '89700', 'N', 'S', '', 'Motilidad', '', '%              ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '1', null, 'R');
INSERT INTO `defaults` VALUES ('876', '0', '163', 'ES', 'A', '0.00', '99.99', '89800', 'N', 'S', '', 'Leucocitos', '', 'campo          ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$E', '1', null, 'R');
INSERT INTO `defaults` VALUES ('877', '0', '163', 'ES', 'A', '0.00', '99.99', '89900', 'N', 'S', '', 'Eritrocitos', '', 'campo          ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('878', '0', '163', 'ES', 'A', '0.00', '99.99', '90000', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$G', '0', null, 'L');
INSERT INTO `defaults` VALUES ('879', '0', '164', 'ES', 'A', '0.00', '99.00', '90100', 'N', 'S', null, 'Colinesterasa................:', null, 'U/L            ', '(3200 - 9000)', '3200', '9000', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CHE', null, null, null, '1', '10', '2007-02-17 08:32:10', 'E', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('881', '0', '165', 'ES', 'F', '18.00', '999.99', '100', 'N', 'S', null, 'Hormona de Crecimiento.......:', null, 'ng/ml         ', '( 0.0 -10.0 )', '0', '10', '-99999.99', '99999.99', '-99999.99', '99999.99', 'GH', null, null, null, '1', '10', '2007-02-22 07:59:40', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('884', '0', '166', 'ES', 'A', '10.00', '99.99', '100', 'N', 'S', null, 'IgE..........................:', null, 'UI/ml', '( ND  -  87 )', '-99999.99', '87', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TIE', null, null, null, '1', '10', '2007-02-22 16:55:25', 'E', '$NO D', '0', null, 'R');
INSERT INTO `defaults` VALUES ('885', '0', '166', 'ES', 'A', '0.00', '0.11', '200', 'N', 'S', null, 'IgE..........................:', null, 'UI/ml', '( ND  -  29 )', '0', '29', '0', '0', '0', '0', 'TIE', null, null, null, '1', '10', '2007-02-22 16:56:12', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('886', '0', '167', 'ES', 'A', '0.00', '99.99', '90800', 'N', 'S', '', 'Xilosa en sangre', '', 'mg/dl          ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('887', '0', '167', 'ES', 'A', '0.00', '99.99', '90900', 'N', 'S', '', 'Xilosa en Orina', '', 'mg/dl          ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('888', '0', '167', 'ES', 'A', '0.00', '99.99', '91000', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('889', '0', '168', 'ES', 'A', '0.00', '99.99', '91100', 'C', 'S', '', 'Melanina en Orina (cual.)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('890', '0', '168', 'ES', 'A', '0.00', '99.99', '91200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('891', '0', '169', 'ES', 'A', '0.00', '99.99', '91300', 'C', 'S', '', 'Aspecto', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('892', '0', '169', 'ES', 'A', '0.00', '99.99', '91400', 'C', 'S', '', 'Coagulo', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('893', '0', '169', 'ES', 'A', '0.00', '99.99', '91500', 'N', 'S', '', 'Leucocitos', '', '/mm3           ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('894', '0', '169', 'ES', 'A', '0.00', '99.99', '91600', 'N', 'S', '', 'Polimorfonucleares', '', '%              ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '1', null, 'R');
INSERT INTO `defaults` VALUES ('895', '0', '169', 'ES', 'A', '0.00', '99.99', '91700', 'N', 'S', '', 'Mononucleares', '', '%              ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$E', '1', null, 'R');
INSERT INTO `defaults` VALUES ('896', '0', '169', 'ES', 'A', '0.00', '99.99', '91800', 'N', 'S', '', 'Eosinofilos', '', '%              ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('897', '0', '169', 'ES', 'A', '0.00', '99.99', '91900', 'C', 'S', '', 'Eritrocitos', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$G', '0', null, 'L');
INSERT INTO `defaults` VALUES ('898', '0', '169', 'ES', 'A', '0.00', '99.99', '92000', 'N', 'S', '', 'Glucosa', '', 'mg/dl          ', '( 50 - 80 )', '50', '80', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$H', '1', null, 'R');
INSERT INTO `defaults` VALUES ('899', '0', '169', 'ES', 'A', '0.00', '99.99', '92100', 'N', 'S', '', 'Proteinas', '', 'mg/dl          ', '( 15 - 45 )', '15', '45', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$I', '1', null, 'R');
INSERT INTO `defaults` VALUES ('900', '0', '169', 'ES', 'A', '0.00', '99.99', '92200', 'C', 'S', '', 'Globulinas', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$J', '0', null, 'L');
INSERT INTO `defaults` VALUES ('901', '0', '169', 'ES', 'A', '0.00', '99.99', '92300', 'N', 'S', '', 'D.H.L.', '', 'UI/L           ', '( 6 - 16 )', '6', '16', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$K', '1', null, 'R');
INSERT INTO `defaults` VALUES ('902', '0', '169', 'ES', 'A', '0.00', '99.99', '92400', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$L', '0', null, 'L');
INSERT INTO `defaults` VALUES ('903', '0', '170', 'ES', 'A', '0.00', '99.99', '92500', 'N', 'S', null, 'Lipasa.......................:', null, 'U/L            ', '(0.0 - 190.0)', '-99999.99', '190', '-99999.99', '99999.99', '-99999.99', '99999.99', 'LIPA', null, null, null, '1', '10', '2007-02-17 08:54:22', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('904', '0', '171', 'ES', 'A', '0.00', '99.99', '92600', 'N', 'S', null, 'Glucosa 2Hrs post Dex........:', null, 'mg/dl          ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 08:52:26', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('905', '0', '171', 'ES', 'A', '0.00', '99.99', '92700', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 08:52:46', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('906', '0', '172', 'ES', 'A', '0.00', '99.99', '92800', 'C', 'S', '', 'Hidroxiprolinuria (semicuant)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('907', '0', '172', 'ES', 'A', '0.00', '99.99', '92900', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('908', '0', '173', 'ES', 'A', '0.00', '99.99', '93000', 'C', 'S', '', 'Aglutinacion Espermatica', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('909', '0', '173', 'ES', 'A', '0.00', '99.99', '93100', 'C', 'S', '', 'TÃƒÂ­tulo 1', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('910', '0', '173', 'ES', 'A', '0.00', '99.99', '93200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('911', '0', '174', 'ES', 'A', '0.00', '99.99', '93300', 'N', 'S', null, 'Anti-Rotavirus...............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 09:03:19', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('913', '0', '174', 'ES', 'A', '0.00', '99.99', '93500', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 08:55:35', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('914', '0', '175', 'ES', 'A', '0.00', '99.99', '93600', 'N', 'S', '', 'Creatina', '', 'mg/dl          ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('915', '0', '175', 'ES', 'A', '0.00', '99.99', '93700', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('916', '0', '176', 'ES', 'A', '0.00', '99.99', '93800', 'C', 'S', '', 'Proteinuria de Bence-Jones', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('917', '0', '176', 'ES', 'A', '0.00', '99.99', '93900', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('918', '0', '177', 'ES', 'A', '0.00', '99.99', '94000', 'C', 'S', '', 'HBsAg (Antigeno Australia)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('919', '0', '177', 'ES', 'A', '0.00', '99.99', '94100', 'C', 'S', '', 'HBeAg', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('920', '0', '177', 'ES', 'A', '0.00', '99.99', '94200', 'C', 'S', '', 'Anti-HBc', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('921', '0', '177', 'ES', 'A', '0.00', '99.99', '94300', 'C', 'S', '', 'Anti-HBe', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('922', '0', '177', 'ES', 'A', '0.00', '99.99', '94400', 'C', 'S', '', 'Anti-HBs', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$E', '0', null, 'L');
INSERT INTO `defaults` VALUES ('923', '0', '177', 'ES', 'A', '0.00', '99.99', '94500', 'C', 'S', '', 'Anti HAV IgM', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '0', null, 'L');
INSERT INTO `defaults` VALUES ('924', '0', '177', 'ES', 'A', '0.00', '99.99', '94600', 'C', 'S', '', 'Anti HAV Total', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$G', '0', null, 'L');
INSERT INTO `defaults` VALUES ('925', '0', '177', 'ES', 'A', '0.00', '99.99', '94700', 'C', 'S', '', 'Hepatitis tipo No A no B', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$H', '0', null, 'L');
INSERT INTO `defaults` VALUES ('926', '0', '177', 'ES', 'A', '0.00', '99.99', '94800', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$I', '0', null, 'L');
INSERT INTO `defaults` VALUES ('927', '0', '178', 'ES', 'A', '0.00', '99.99', '94900', 'C', 'S', '', 'Anti HBsAg (Hepatitis B)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('928', '0', '178', 'ES', 'A', '0.00', '99.99', '95000', 'C', 'S', '', 'Anti HAV (Hepatitis A)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('929', '0', '178', 'ES', 'A', '0.00', '99.99', '95100', 'C', 'S', '', 'Hepatitis No A No B', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('930', '0', '178', 'ES', 'A', '0.00', '99.99', '95200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('931', '0', '179', 'ES', 'A', '0.00', '99.99', '95300', 'N', 'S', null, 'Mioglobulina.................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'MYOG', null, null, null, '1', '10', '2007-02-22 10:48:08', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('932', '0', '179', 'ES', 'A', '0.00', '99.99', '95400', 'C', 'S', null, 'Título 1............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('933', '0', '179', 'ES', 'A', '0.00', '99.99', '95500', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('934', '0', '180', 'ES', 'A', '0.00', '99.99', '95600', 'N', 'S', '', 'T.S.H. basal', '', 'mUI/ml         ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('935', '0', '180', 'ES', 'A', '0.00', '99.99', '95700', 'C', 'S', '', 'T.S.H. 30 minutos', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('936', '0', '180', 'ES', 'A', '0.00', '99.99', '95800', 'N', 'S', '', 'T.S.H. 60 minutos', '', 'mUI/ml         ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('937', '0', '180', 'ES', 'A', '0.00', '99.99', '95900', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('938', '0', '181', 'ES', 'A', '0.00', '99.99', '96000', 'N', 'S', '', 'Cortisol Basal', '', 'ÃƒÂ¦g/dl       ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('939', '0', '181', 'ES', 'A', '0.00', '99.99', '96100', 'C', 'S', '', 'Hora de Muestreo', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('940', '0', '181', 'ES', 'A', '0.00', '99.99', '96200', 'N', 'S', '', 'Cortisol Post-Supresion', '', 'ÃƒÂ¦g/dl       ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('941', '0', '181', 'ES', 'A', '0.00', '99.99', '96300', 'C', 'S', '', 'Hora de Muestreo', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('942', '0', '181', 'ES', 'A', '0.00', '99.99', '96400', 'N', 'S', '', 'Cortisol Post-Supresion', '', 'ÃƒÂ¦g/dl       ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$E', '1', null, 'R');
INSERT INTO `defaults` VALUES ('943', '0', '181', 'ES', 'A', '0.00', '99.99', '96500', 'C', 'S', '', 'Hora de Muestreo', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '0', null, 'L');
INSERT INTO `defaults` VALUES ('944', '0', '181', 'ES', 'A', '0.00', '99.99', '96600', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$G', '0', null, 'L');
INSERT INTO `defaults` VALUES ('945', '0', '182', 'ES', 'A', '0.00', '99.99', '96700', 'C', 'S', '', 'Porfirinas en Orina', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('946', '0', '182', 'ES', 'A', '0.00', '99.99', '96800', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('947', '0', '183', 'ES', 'A', '0.00', '99.99', '96900', 'C', 'S', '', 'Cultivo por Amebas', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('948', '0', '183', 'ES', 'A', '0.00', '99.99', '97000', 'C', 'S', '', 'Organismos Aislados', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('949', '0', '184', 'ES', 'A', '0.00', '99.99', '97100', 'N', 'S', null, 'Carotenos(Suero)....:', null, '      ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('950', '0', '184', 'ES', 'A', '0.00', '99.99', '97200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('951', '0', '185', 'ES', 'A', '0.00', '99.99', '97300', 'N', 'S', null, 'Litio........................:', null, 'mmol/L         ', '( 0.6 - 1.2 )', '0.6', '1.2', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Li', null, null, null, '1', '10', '2007-02-17 08:53:57', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('953', '0', '186', 'ES', 'A', '0.00', '99.99', '97500', 'N', 'S', null, 'Anti-HIV (1+2)...............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 09:03:52', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('954', '0', '186', 'ES', 'A', '0.00', '99.99', '97600', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1457', '0', '287', 'ES', 'M', '0.00', '99.99', '1600', 'N', 'S', null, 'Dioxipiridinolina-Pyrilink-D.:', null, 'nMDpD/mMCrt', '(Menos de 5.4)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 08:35:47', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1456', '0', '287', 'ES', 'F', '0.00', '99.99', '1500', 'N', 'S', null, 'Dioxipiridinolina-pyrilink-D.:', null, 'nMDpD/mMCrt', '(Menos de 7.4)', '-99999.99', '7.4', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 08:36:13', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1455', '0', '287', 'ES', 'A', '0.00', '99.99', '1400', 'N', 'S', null, 'Fosf.acida Tartrato Resistente', null, 'U/L', '( 0.0 -   10 )', '-99999.99', '10', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 08:36:39', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1429', '0', '195', 'ES', 'F', '60.00', '80.00', '500', 'N', 'S', null, 'Testosterona Libre...........:', null, 'pg/ml', '( ND - 1.55 )', '0', '1.55', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 09:43:45', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1494', '0', '350', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'CURVA TOLERANCIA A GLUCOSA 3HS', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 10:03:27', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1491', '0', '350', 'ES', 'A', '0.00', '99.99', '600', 'N', 'S', null, 'Glucosa 60min................:', null, 'mg/dl', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 10:43:29', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1428', '0', '187', 'ES', 'A', '0.00', '99.99', '600', 'C', 'S', null, 'Glucosuria 4Hrs.....:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 12:23:02', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1427', '0', '187', 'ES', 'A', '0.00', '99.99', '500', 'C', 'S', null, 'Glucosuria 3Hrs.....:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 12:15:22', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1426', '0', '187', 'ES', 'A', '0.00', '99.99', '400', 'C', 'S', null, 'Glucosuria 2Hrs.....:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 12:15:44', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1425', '0', '187', 'ES', 'A', '0.00', '99.99', '300', 'C', 'S', null, 'glucosuria 1Hra.....:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 12:16:04', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1424', '0', '187', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', null, 'Glucosuria 30 min...:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 12:16:16', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('968', '0', '188', 'ES', 'F', '0.00', '99.99', '99000', 'N', 'S', '', 'Cobre', '', 'ÃƒÂ¦g/dl       ', '( 85 - 155 )', '85', '155', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('969', '0', '188', 'ES', 'M', '0.00', '99.99', '99100', 'N', 'S', '', 'Cobre', '', 'ÃƒÂ¦g/dl       ', '( 70 - 140 )', '70', '140', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('970', '0', '188', 'ES', 'A', '0.00', '99.99', '99200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('971', '0', '189', 'ES', 'A', '0.00', '99.99', '99300', 'N', 'S', null, 'Ceruloplasmina', null, 'U/L            ', '( 55 - 150 )', '55', '150', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('972', '0', '189', 'ES', 'A', '0.00', '99.99', '99400', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('973', '0', '190', 'ES', 'A', '0.00', '99.99', '99500', 'N', 'S', null, 'Plomo en Sangre..............:', null, 'ug/dl          ', '(0.0 -  10.0)', '-99999.99', '10', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 12:39:58', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('975', '0', '191', 'ES', 'A', '0.00', '99.99', '99700', 'N', 'S', '', 'Apolipoproteina A-I', '', 'mg/dl          ', '( 96 - 176 )', '96', '176', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('976', '0', '191', 'ES', 'A', '0.00', '99.99', '99800', 'N', 'S', '', 'Apolipoproteina A-II', '', 'mg/dl          ', '( 160 - 330 )', '160', '330', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('977', '0', '191', 'ES', 'A', '0.00', '99.99', '99900', 'N', 'S', '', 'Apolipoproteina B', '', 'mg/dl          ', '( 45 - 160 )', '45', '160', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('978', '0', '191', 'ES', 'A', '0.00', '99.99', '100000', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1671', '0', '287', 'ES', 'A', '0.00', '99.99', '900', 'N', 'S', '', 'Paratohormona(PTH)...........:', null, 'pg/ml', '( 10.0-69.0 )', '10', '69', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 13:07:40', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1512', '0', '155', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'ESTUDIO BACTERIOLOGICO DE AGUA', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 08:24:42', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1486', '0', '192', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Cortisol-PM..................:', null, 'ug/dl', '(Después de 5:00PM: 2.5-12.5)', '2.5', '12.5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 13:47:16', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('982', '0', '193', 'ES', 'A', '0.00', '99.99', '100400', 'N', 'S', null, 'Serotonina(5-HIA)...:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('983', '0', '193', 'ES', 'A', '0.00', '99.99', '100500', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('984', '0', '194', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Cortisol-AM..................:', null, 'ug/dl       ', '(Antes 10:00 AM:   5.0-25.0 )', '5', '25', '-99999.99', '99999.99', '-99999.99', '99999.99', 'COR', null, null, null, '1', '10', '2007-02-17 09:11:38', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('986', '0', '195', 'ES', 'F', '20.00', '39.00', '100', 'N', 'S', null, 'Testosterona libre...........:', null, 'pg/ml          ', '( ND - 2.57 )', '0', '2.57', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 09:41:45', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('987', '0', '195', 'ES', 'M', '20.00', '39.00', '200', 'N', 'S', null, 'Testosterona libre...........:', null, 'pg/ml          ', '( 8.8-  27 )', '8.8', '27', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 09:42:00', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('988', '0', '195', 'ES', 'F', '40.00', '59.00', '300', 'N', 'S', null, 'Testosterona Libre...........:', null, 'pg/ml', '( ND - 2.03 )', '0', '2.03', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 09:43:16', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1430', '0', '195', 'ES', 'M', '60.00', '80.00', '600', 'N', 'S', null, 'Testosterona Libre...........:', null, 'pg/ml', '( 5.6 -  19.0 )', '5.6', '19', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 09:44:21', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('990', '0', '195', 'ES', 'M', '40.00', '59.00', '400', 'N', 'S', null, 'Testosterona libre...........:', null, 'pg/ml', '( 7.2 -  23 )', '7.2', '23', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 09:43:30', 'E', '$NO DE', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1614', '0', '028', 'ES', 'M', '0.00', '99.99', '2500', 'T', 'S', '', 'Tinción', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 12:32:48', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1489', '0', '350', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'Glucosa  30min...............:', null, 'ng/ml', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 10:45:45', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1432', '0', '196', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', '', 'Volumen.............:', null, 'ml/24hrs', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1431', '0', '196', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', '17-OH Corticosteroides', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('997', '0', '197', 'ES', 'A', '0.00', '99.99', '101900', 'N', 'S', '', 'F.S.H. basal', '', 'mUI/ml         ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('998', '0', '197', 'ES', 'A', '0.00', '99.99', '102000', 'N', 'S', '', 'F.S.H. 30 minutos', '', 'mUI/ml         ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('999', '0', '197', 'ES', 'A', '0.00', '99.99', '102100', 'N', 'S', '', 'F.S.H. 60 minutos', '', 'mUI/ml         ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1000', '0', '197', 'ES', 'A', '0.00', '99.99', '102200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1001', '0', '198', 'ES', 'A', '0.00', '99.99', '102300', 'N', 'S', '', 'L.H. Basal', '', 'mUI/ml         ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1002', '0', '198', 'ES', 'A', '0.00', '99.99', '102400', 'N', 'S', '', 'L.H. 30 minutos', '', 'mUI/ml         ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1003', '0', '198', 'ES', 'A', '0.00', '99.99', '102500', 'C', 'S', '', 'L.H. 60 minutos', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1004', '0', '198', 'ES', 'A', '0.00', '99.99', '102600', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1005', '0', '199', 'ES', 'A', '0.00', '99.99', '102700', 'C', 'S', '', 'Investigacion por Drepanocitos', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1006', '0', '199', 'ES', 'A', '0.00', '99.99', '102800', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1007', '0', '200', 'ES', 'A', '0.00', '99.99', '102900', 'N', 'S', null, 'Aldolasa............:', null, 'U/L            ', '( 5.0 - 7.6 )', '0.5', '7.6', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1008', '0', '200', 'ES', 'A', '0.00', '99.99', '103000', 'O', 'S', '', 'OBSERVACIONES', '', 'ÃƒÂ¦g/ml       ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1009', '0', '201', 'ES', 'A', '0.00', '99.99', '103100', 'C', 'S', '', 'Herpes Tipo I (HSV-I)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1010', '0', '201', 'ES', 'A', '0.00', '99.99', '103200', 'C', 'S', '', 'Herpes Tipo II (HSV-II)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1011', '0', '201', 'ES', 'A', '0.00', '99.99', '103300', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1568', '0', '206', 'ES', 'A', '0.00', '99.99', '700', 'N', 'S', null, 'Alfa-2-Globulinas............:', null, 'g/dl', '( 0.6 - 1.0 )', '0.6', '1', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 07:42:32', 'E', '$D', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1567', '0', '206', 'ES', 'A', '0.00', '99.99', '600', 'N', 'S', null, 'Alfa-1-Globulinas............:', null, 'g/dl', '( 0.1 - 0.4 )', '0.1', '0.4', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 07:43:23', 'E', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1566', '0', '206', 'ES', 'A', '0.00', '99.99', '500', 'T', 'S', null, 'Globulinas:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 07:43:46', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1565', '0', '206', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Albumina.....................:', null, 'g/dl', '( 3.7 - 5.0 )', '3.7', '5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 07:25:05', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1564', '0', '206', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Proteìna Total...............:', null, 'g/dl', '( 5.7 - 8.2 )', '5.7', '8.2', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 07:24:41', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1563', '0', '206', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', '', 'ELECTROFORESIS DE PROTEINAS', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 07:00:00', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1562', '0', '205', 'ES', 'A', '0.00', '99.99', '700', 'N', 'S', null, 'Patron electroforético Sugiere', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 06:52:07', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1020', '0', '203', 'ES', 'A', '0.00', '99.99', '104200', 'N', 'S', null, 'Mercurio(sangre)....:', null, '      ', '( Menos de 100 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1021', '0', '203', 'ES', 'A', '0.00', '99.99', '104300', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1550', '0', '204', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Vitamina B12.................:', null, 'pg/ml', '( 239 - 931 )', '239', '931', '-99999.99', '99999.99', '-99999.99', '99999.99', 'B12', null, null, null, '1', '10', '2007-02-22 09:55:31', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1495', '0', '350', 'ES', 'A', '0.00', '99.99', '500', 'N', 'S', null, 'GLUCOSA 120 min..............:', null, 'mg/dl', 'Glucosuria:', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 10:44:20', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1617', '0', '031', 'ES', 'A', '0.17', '9.99', '200', 'N', 'S', null, 'Hemoglobina..................:', null, 'g/ml', '( 10.0-12.6 )', '10', '12.6', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-21 16:29:41', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1551', '0', '207', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Acido Fólico.................:', null, 'ng/ml', '( 3.0 -17.0 )\r\n', '3', '17', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Fol', null, null, null, '1', '10', '2007-02-22 10:47:40', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1030', '0', '208', 'ES', 'A', '0.00', '99.99', '105200', 'N', 'S', null, 'G6PD', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1031', '0', '208', 'ES', 'A', '0.00', '99.99', '105300', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1032', '0', '209', 'ES', 'A', '0.00', '99.99', '105400', 'N', 'S', '', 'Nitrogeno Ureico', '', 'mg/dl          ', '( 12.0 - 20.0 )', '12', '20', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1033', '0', '209', 'ES', 'A', '0.00', '99.99', '105500', 'N', 'S', '', 'Volumen', '', 'ml/24horas     ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1034', '0', '209', 'ES', 'A', '0.00', '99.99', '105600', 'N', 'S', '', 'Nitrogeno Ureico en Orina 24 h', '', 'g/24           ', '( 20 - 35 )', '20', '35', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL61', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1035', '0', '210', 'ES', 'A', '0.00', '99.99', '105700', 'C', 'S', '', 'I.F. para Entamoeba histolytic', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1036', '0', '210', 'ES', 'A', '0.00', '99.99', '105800', 'C', 'S', '', 'TÃ­tulo 1', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1037', '0', '210', 'ES', 'A', '0.00', '99.99', '105900', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1038', '0', '211', 'ES', 'A', '0.00', '99.99', '106000', 'C', 'S', '', 'Cetonemia', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1039', '0', '211', 'ES', 'A', '0.00', '99.99', '106100', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1040', '0', '212', 'ES', 'A', '0.00', '99.99', '106300', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 10:35:00', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1041', '0', '212', 'ES', 'A', '0.00', '99.99', '106200', 'N', 'S', null, 'VLDL-Colesterol (calc)', null, 'mg/dl          ', '(15.0 - 55.0)', '15', '55', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 12:38:29', '', '$CAL62', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1042', '0', '213', 'ES', 'A', '0.00', '99.99', '106400', 'N', 'S', null, 'PTH-Intacta(Paratohormona)....', null, 'pg/ml          ', '(10.0 - 69.0)', '10', '69', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 10:41:20', '', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1044', '0', '214', 'ES', 'A', '0.00', '99.99', '106600', 'C', 'S', '', 'Resultado', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1045', '0', '214', 'ES', 'A', '0.00', '99.99', '106700', 'C', 'S', '', 'TÃ­tulo 1', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1046', '0', '214', 'ES', 'A', '0.00', '99.99', '106800', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1047', '0', '215', 'ES', 'A', '0.00', '99.99', '106900', 'C', 'S', '', '30 minutos b', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$5', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1048', '0', '215', 'ES', 'A', '0.00', '99.99', '107000', 'C', 'S', '', '60 minutos c', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$5', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1049', '0', '215', 'ES', 'A', '0.00', '99.99', '107100', 'C', 'S', '', '120 minutosd', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$5', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1050', '0', '215', 'ES', 'A', '0.00', '99.99', '107200', 'C', 'S', '', 'Basala', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$5', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1051', '0', '215', 'ES', 'A', '0.00', '99.99', '107300', 'C', 'S', '', 'Dosis de Insulina utilizada', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$I', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1052', '0', '215', 'ES', 'A', '0.00', '99.99', '107400', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$J', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1053', '0', '215', 'ES', 'A', '0.00', '99.99', '107500', '', 'S', '', 'GLICEMIA MG/DL HGH N', '', '', '', '0', '0', '0', '0', '0', '0', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1054', '0', '216', 'ES', 'A', '0.00', '99.99', '107600', 'N', 'S', '', 'Colesterol Esterificado', '', '%              ', '( 65 - 75 )', '65', '75', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1055', '0', '216', 'ES', 'A', '0.00', '99.99', '107700', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1056', '0', '217', 'ES', 'A', '0.00', '99.99', '107800', 'N', 'S', null, 'Alfa-1-Antitripsina :', null, 'mg/dl          ', '( 200 - 400 )', '200', '400', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1057', '0', '217', 'ES', 'A', '0.00', '99.99', '107900', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1058', '0', '218', 'ES', 'A', '0.00', '99.99', '108000', 'C', 'S', '', 'Color', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1059', '0', '218', 'ES', 'A', '0.00', '99.99', '108100', 'C', 'S', '', 'Aspecto', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1060', '0', '218', 'ES', 'A', '0.00', '99.99', '108200', 'C', 'S', '', 'Viscosidad', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1061', '0', '218', 'ES', 'A', '0.00', '99.99', '108300', 'C', 'S', '', 'Coagulo de Mucina', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1062', '0', '218', 'ES', 'A', '0.00', '99.99', '108400', 'N', 'S', '', 'Recuento de Eritrocitos', '', '/mm            ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$E', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1063', '0', '218', 'ES', 'A', '0.00', '99.99', '108500', 'N', 'S', '', 'Recuento de leucocitos', '', '/mm            ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$F', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1064', '0', '218', 'ES', 'A', '0.00', '99.99', '108600', 'N', 'S', '', 'Eosinofilos', '', '%              ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$G', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1065', '0', '218', 'ES', 'A', '0.00', '99.99', '108700', 'N', 'S', '', 'Neutrofilos', '', '%              ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$H', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1066', '0', '218', 'ES', 'A', '0.00', '99.99', '108800', 'N', 'S', '', 'Mononucleares', '', '%              ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$I', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1067', '0', '218', 'ES', 'A', '0.00', '99.99', '108900', 'N', 'S', '', 'Glucosa', '', 'mg/dl          ', '( 60 - 110 )', '60', '110', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$J', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1068', '0', '218', 'ES', 'A', '0.00', '99.99', '109000', 'N', 'S', '', 'Proteinas', '', 'g/dl           ', '( 1.0 - 3.0 )', '1', '3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$K', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1069', '0', '218', 'ES', 'A', '0.00', '99.99', '109100', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$L', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1070', '0', '219', 'ES', 'A', '0.00', '99.99', '109200', 'N', 'S', '', 'Prueba de Turbidez del Timol', '', 'U.             ', '( 0 - 6 )', '-99999.99', '6', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1071', '0', '220', 'ES', 'A', '0.00', '99.99', '109300', 'N', 'S', '', 'Ojo Derecho', '', 'ÃƒÂ¦g/ml       ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1072', '0', '220', 'ES', 'A', '0.00', '99.99', '109400', 'C', 'S', '', 'Ojo Izquierdo', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1073', '0', '220', 'ES', 'A', '0.00', '99.99', '109500', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1074', '0', '221', 'ES', 'A', '0.00', '99.99', '109600', 'N', 'S', '', 'Catecolaminas', '', 'ÃƒÂ¦g/dl       ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1075', '0', '221', 'ES', 'A', '0.00', '99.99', '109700', 'N', 'S', '', 'Volumen', '', 'ml/24          ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1076', '0', '221', 'ES', 'A', '0.00', '99.99', '109800', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1077', '0', '221', 'ES', 'A', '0.00', '99.99', '109900', 'N', 'S', '', 'Resultado', '', 'ÃƒÂ¦g/24       ', '( Hasta 100 )', '-99999.99', '100', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$CAL64', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1078', '0', '222', 'ES', 'A', '0.00', '99.99', '110000', 'C', 'S', '', '35b', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$4', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1079', '0', '222', 'ES', 'A', '0.00', '99.99', '110100', 'C', 'S', '', 'Esporotricina', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1080', '0', '222', 'ES', 'A', '0.00', '99.99', '110200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1081', '0', '223', 'ES', 'A', '0.00', '99.99', '110300', 'C', 'S', '', '35b', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$4', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1082', '0', '223', 'ES', 'A', '0.00', '99.99', '110400', 'C', 'S', '', 'Toxoplasmina', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1083', '0', '223', 'ES', 'A', '0.00', '99.99', '110500', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1084', '0', '224', 'ES', 'A', '0.00', '99.99', '110600', 'C', 'S', '', '35b', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$4', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1085', '0', '224', 'ES', 'A', '0.00', '99.99', '110700', 'C', 'S', '', 'Leishmanina', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1086', '0', '224', 'ES', 'A', '0.00', '99.99', '110800', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1087', '0', '225', 'ES', 'A', '0.00', '99.99', '700', 'F', 'S', null, 'Colesterol/HDL...............:', null, null, '( 3.1      -       4.6  )  ', '3.1', '4.6', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 06:52:23', 'E', '$CAL67', '0', '$A/$C', 'R');
INSERT INTO `defaults` VALUES ('1454', '0', '287', 'ES', 'A', '0.00', '99.99', '1300', 'N', 'S', null, 'Relación Ca/Creatinina.......:', null, null, '( Hasta   0.2)', '-99999.99', '0.2', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 08:37:10', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1434', '0', '225', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'PERFIL DE LIPIDO', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1433', '0', '225', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Colesterol...................:', null, 'mg/dl', '( Deseable: menos de 200)\r\n( Promedio:   200 - 239 )\r\n( Alto Riesgo:Más de 240)', '-99999.99', '200', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 06:30:40', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1091', '0', '225', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Trigliceridos................:', null, 'mg/dl          ', '( Hasta.............150 )', '-99999.99', '150', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 06:31:41', 'E', '$B', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1092', '0', '225', 'ES', 'A', '0.00', '99.00', '400', 'N', 'S', null, 'HDL-Colesterol...............:', null, 'mg/dl          ', '( Mayor de.......... 50 )', '50', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 06:52:55', 'E', '$C', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1094', '0', '225', 'ES', 'A', '0.00', '99.99', '600', 'F', 'S', null, 'VLDL-Colesterol..............:', null, 'mg/dl          ', '( 15.0      -     55.0  )', '15', '55', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 06:35:27', 'E', '$CAL66', '1', '$B/5', 'R');
INSERT INTO `defaults` VALUES ('1436', '0', '232', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', '', 'Lectura.............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1437', '0', '234', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Clamidia(directa)............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 09:05:12', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1438', '0', '236', 'ES', 'A', '0.00', '99.99', null, 'T', 'S', '', 'PAPANICOLAU', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1439', '0', '236', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', null, 'Ver página adjunta..::', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 17:12:03', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1440', '0', '238', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'Filaria.............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 11:41:22', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1441', '0', '244', 'ES', 'F', '50.00', '99.99', '200', 'N', 'S', null, 'Ferritina....................:', null, 'ng/ml', '( 11.1 - 264 )', '11.1', '264', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Ferr', null, null, null, '1', '10', '2007-02-22 08:09:47', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1442', '0', '247', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Título.......................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 07:49:31', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1443', '0', '287', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'BALANCE METABOLICO OSEO', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1444', '0', '287', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Calcio Sèrico................:', null, 'mg/dl', '( 8.4 - 10.2 )', '8.4', '10.2', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1445', '0', '287', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'Fósforo Sérico...............:', null, 'mg/dl', '( 2.5  - 4.5 )', '2.5', '4.5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1446', '0', '287', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'Creatinina Sérica............:', null, 'mg/dl', '( 0.2  - 1.3 )', '0.2', '1.3', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1447', '0', '287', 'ES', 'A', '0.00', '99.99', '500', 'N', 'S', null, 'Calcio Urinario..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1448', '0', '287', 'ES', 'A', '0.00', '99.99', '600', 'N', 'S', null, 'Fósforo Urinario.............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1449', '0', '287', 'ES', 'A', '0.00', '99.99', '700', 'N', 'S', null, 'Creatinina urinaria..........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1450', '0', '287', 'ES', 'A', '0.00', '99.99', '800', 'N', 'S', null, 'Reab.Tubular de Fosfato......:', null, '%', '(Mayor de  85)', '85', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 11:05:08', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1451', '0', '287', 'ES', 'A', '0.00', '99.99', '1000', 'T', 'S', null, 'MARCADORES DE FORMACION', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, null, '1', '10', '2007-02-10 08:39:14', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1452', '0', '287', 'ES', 'A', '0.00', '99.99', '1100', 'N', 'S', null, 'Fosfatasa Alcalina...........:', null, 'U/L', '(38.0 - 126.0)', '38', '126', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 08:38:40', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1453', '0', '287', 'ES', 'A', '0.00', '99.99', '1200', 'T', 'S', null, 'MARCADORES DE RESORCION', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, null, '1', '10', '2007-02-10 08:37:39', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1435', '0', '225', 'ES', 'A', '0.00', '99.99', '500', 'F', 'S', null, 'LDL-Colesterol...............:', null, 'mg/dl', '( Menor de..........100 )', '-99999.99', '100', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 06:53:12', 'E', '$CAL65', '0', '$A -($C+($B/5))', 'R');
INSERT INTO `defaults` VALUES ('1124', '0', '225', 'ES', 'A', '0.00', '99.99', '900', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', '', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1380', '0', '226', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'PSA..........................:', null, 'ng/ml', '( 0.0 - 4.0 )\r\n', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'PSA', null, null, null, '1', '10', '2007-02-22 07:41:51', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1129', '0', '227', 'ES', 'A', '0.00', '99.99', '115200', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 11:01:35', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1130', '0', '227', 'ES', 'A', '0.00', '99.99', '115100', 'N', 'S', null, 'Glucosa 1hr. 50gr...:', null, 'mg/dl', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 11:01:18', '', '$DEXTR', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1132', '0', '228', 'ES', 'A', '0.00', '99.99', '115300', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:............<6.5 )\r\n( Equivoco: ......6.5 - 7.9 )\r\n( Positivo:..............>8 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TXP', null, null, null, '1', '10', '2007-02-22 07:52:42', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1133', '0', '229', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, '               ', '( Negativo:............<0.9 )\r\n( Equivoco:       0.9 - 1.1 )\r\n( Positivo:............>1.1 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 10:16:20', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1135', '0', '230', 'ES', 'A', '0.00', '99.99', '115700', 'C', 'S', '', 'Citomegalovirus (IgG)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1136', '0', '230', 'ES', 'A', '0.00', '99.99', '115800', 'C', 'S', '', '1:', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1137', '0', '230', 'ES', 'A', '0.00', '99.99', '115900', 'C', 'S', '', 'Citomegalovirus (IgM)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1138', '0', '230', 'ES', 'A', '0.00', '99.99', '116000', 'C', 'S', '', '1:', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1139', '0', '231', 'ES', 'A', '0.00', '99.99', '116100', 'C', 'S', '', 'E.B.V. (IgG)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1140', '0', '231', 'ES', 'A', '0.00', '99.99', '116200', 'C', 'S', '', '1:', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1141', '0', '231', 'ES', 'A', '0.00', '99.99', '116300', 'C', 'S', '', 'E.B.V. (IgM)', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1142', '0', '231', 'ES', 'A', '0.00', '99.99', '116400', 'C', 'S', '', '1:', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$D', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1143', '0', '232', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'Cocaina en orina....:', null, null, '( Positiva:......... >300.0 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 11:33:50', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1144', '0', '233', 'ES', 'A', '0.00', '99.99', '116600', 'C', 'S', null, 'Marihuana en orina  :', null, null, '(Menor de 50)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 13:09:53', 'E', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1145', '0', '233', 'ES', 'A', '0.00', '99.99', '116700', 'O', 'S', null, 'Lectura.............:', null, null, null, '0', '0', '0', '0', '0', '0', null, null, null, null, '1', '10', '2007-02-12 13:10:33', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1147', '0', '235', 'ES', 'F', '0.00', '99.99', '100', 'N', 'S', null, 'DHEA(SO4)....................:', null, 'ug/dl          ', '( 35.0-430.0 )', '35', '430', '-99999.99', '99999.99', '-99999.99', '99999.99', 'DHS', null, null, null, '1', '10', '2007-02-22 07:42:21', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1148', '0', '235', 'ES', 'M', '0.00', '99.99', '200', 'N', 'S', null, 'DHEA(SO4)....................:', null, 'ug/dl        ', '( 80.0-560.0 )', '80', '560', '-99999.99', '99999.99', '-99999.99', '99999.99', 'DHS', null, null, null, '1', '10', '2007-02-22 07:42:34', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1507', '0', '250', 'ES', 'M', '0.00', '99.99', '200', 'N', 'S', null, 'PSA Total....................:', null, 'ng/ml', '( 0.00   -   4.0  )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'PSA', null, null, null, '1', '10', '2007-02-22 07:53:35', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1150', '0', '237', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'Cultivo de Thayer martin', null, '       ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, '1', '1', '10', '2007-02-12 17:15:08', 'E', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1151', '0', '237', 'ES', 'A', '0.00', '99.99', '117300', 'O', 'S', null, 'OBSERVACIONES.......:', null, '        ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1152', '0', '238', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', null, 'OBSERVACIONES.......:', null, '        ', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 17:17:07', 'E', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1153', '0', '239', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, '         ', '( Negativo:............<0.9 )\r\n( Equivoco:.......0.9 - 1.1 )\r\n( Positivo:............>1.1 )', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', 'CVG', null, null, null, '1', '10', '2007-02-22 08:02:36', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1515', '0', '155', 'ES', 'A', '0.00', '99.99', '600', 'O', 'S', '', 'Método: Membrana Filtrante', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 08:35:34', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1155', '0', '240', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Citomegalovirus IgM..........:', null, '         ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 09:06:00', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1156', '0', '240', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', null, 'OBSERVACIONES.......:', null, '         ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1157', '0', '241', 'ES', 'A', '0.00', '99.99', '117900', 'C', 'S', '', 'Herpes virus (IgG) Tipo I', '', 'pg/ml          ', '( 0.06 - 2.5 )', '0.06', '2.5', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1158', '0', '241', 'ES', 'A', '0.00', '99.99', '118000', 'O', 'S', '', 'OBSERVACIONES', '', 'pg/ml          ', '( 0.03 - 1.55 )', '0.03', '1.55', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1159', '0', '241', 'ES', 'A', '0.00', '99.99', '118100', 'C', 'S', '', 'Herpes virus (IgG) Tipo II', '', 'U              ', '(0.72 - 1.24)', '0.72', '1.24', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1160', '0', '242', 'ES', 'A', '0.00', '99.99', '118200', 'C', 'S', '', 'Herpes virus (IgM) Tipo I', '', 'u/ml           ', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1161', '0', '242', 'ES', 'A', '0.00', '99.99', '118300', 'O', 'S', '', 'OBSERVACIONES', '', 'u/ml           ', '( 0 - 35 )', '-99999.99', '35', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1162', '0', '242', 'ES', 'A', '0.00', '99.99', '118400', 'C', 'S', '', 'Herpes virus (IgM) Tipo II', '', 'UG/DL          ', '(80 - 560 )', '80', '560', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1163', '0', '243', 'ES', 'A', '0.00', '99.99', '118500', 'N', 'S', null, 'Rubeola (IgM)................:', null, '          ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 09:06:42', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1164', '0', '243', 'ES', 'A', '0.00', '99.99', '118600', 'O', 'S', null, 'OBSERVACIONES.......:', null, '       ', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1165', '0', '244', 'ES', 'F', '0.00', '50.00', '100', 'N', 'S', null, 'Ferritina....................:', null, 'ng/ml', '( 6.24 - 13.7 )', '6.24', '13.7', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Ferr', null, null, null, '1', '10', '2007-02-22 08:09:33', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1166', '0', '244', 'ES', 'M', '0.00', '99.99', '300', 'N', 'S', null, 'Ferritina....................:', null, 'ng/ml', '( 17.9 - 464.0 )', '17.9', '464', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Ferr', null, null, null, '1', '10', '2007-02-22 08:10:04', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1167', '0', '244', 'ES', 'A', '0.00', '99.99', '118900', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 17:28:26', 'E', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1168', '0', '245', 'ES', 'A', '0.00', '99.99', '119000', 'N', 'S', null, 'RPR.................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 11:33:30', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1169', '0', '246', 'ES', 'A', '0.00', '99.99', '119100', 'N', 'S', '', 'T3 Uptake', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '1', null, 'R');
INSERT INTO `defaults` VALUES ('1170', '0', '246', 'ES', 'A', '0.00', '99.99', '119200', 'O', 'S', '', 'OBSERVACIONES', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1171', '0', '247', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Clamidia(Suero)...............', null, null, '( Negativa:...........<1:16 )', '-99999.99', '16', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 07:48:38', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1172', '0', '248', 'ES', 'A', '0.00', '99.99', '119400', 'N', 'S', null, 'Transferrina.................:', null, 'mg/dl', '( 250 - 450 )', '250', '450', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 17:32:57', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1173', '0', '249', 'ES', 'A', '0.00', '99.99', '119500', 'N', 'S', null, 'Alcohol(Sangre)..............:', null, 'mg/dl', '( Negativo:.............<10 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ALC', null, null, null, '1', '10', '2007-02-17 08:23:09', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1174', '0', '249', 'ES', 'A', '0.00', '99.99', '119600', 'N', 'S', null, 'Lectura......................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ALC', null, null, null, '1', '10', '2007-02-17 08:23:22', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1175', '0', '250', 'ES', 'M', '0.00', '99.99', '300', 'N', 'S', null, 'P.S.A. Libre.................:', null, 'ng/ml', '( 0.05  -   0.25  )', '0.05', '0.25', '-99999.99', '99999.99', '-99999.99', '99999.99', 'fPS', null, null, null, '1', '10', '2007-02-22 07:54:02', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1176', '0', '250', 'ES', 'M', '0.00', '99.99', '400', 'F', 'S', null, 'Relación Libre/Total.........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 18:44:10', 'E', null, '0', '$B/$A', 'R');
INSERT INTO `defaults` VALUES ('1177', '0', '250', 'ES', 'M', '0.00', '99.99', '500', 'F', 'S', null, '% PSA Libre .................:', null, '%', '( Deseable:  >20% )\r\n( Alto Riesgo:0-10)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 18:51:57', 'E', null, '0', '($B/$A)*100', 'R');
INSERT INTO `defaults` VALUES ('1179', '0', '251', 'ES', 'A', '0.00', '99.99', '120100', 'N', 'S', null, 'Nicotina-Cotinina(Suero).....:', null, null, '( Menor de25)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'NM', null, null, null, '1', '10', '2007-02-22 07:41:08', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1181', '0', '251', 'ES', 'A', '0.00', '99.00', '120300', 'N', 'S', null, 'Lectura......................:', null, 'ng/ml', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'NM', null, null, null, '1', '10', '2007-02-22 07:41:22', 'E', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1182', '0', '252', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:............<0.9 )\r\n( Equivoco:.......0.9 - 1.1 )\r\n( Positivo:............>1.1 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'HPG', null, null, null, '1', '10', '2007-02-22 07:58:17', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1519', '0', '239', 'ES', 'A', '0.00', '99.99', null, 'N', 'S', null, 'Citomegalovirus(IgG).........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CVG', null, null, null, '1', '10', '2007-02-22 08:02:16', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1518', '0', '253', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, 'ng/ml', null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 12:28:48', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1517', '0', '253', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Nicotina-Cotinina(Orina).....:', null, null, '(Menor de500)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 12:28:16', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1190', '0', '254', 'ES', 'A', '0.00', '99.99', '121200', 'N', 'S', null, 'CA-125.......................:', null, 'U/ml', '( 0.0 - 35.0 )', '-99999.99', '35', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CA125', null, null, null, '1', '10', '2007-02-22 08:06:00', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1191', '0', '255', 'ES', 'A', '0.00', '99.99', '121300', 'N', 'S', null, 'Dengue(IgG)..................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 09:12:41', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1192', '0', '255', 'ES', 'A', '0.00', '99.99', '121500', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 12:40:11', 'E', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1193', '0', '255', 'ES', 'A', '0.00', '99.99', '121400', 'N', 'S', null, 'Dengue(IgM)..................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 09:13:04', 'E', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1194', '0', '256', 'ES', 'A', '0.00', '99.99', '121600', 'N', 'S', null, 'B.T.A........................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 09:13:32', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1195', '0', '256', 'ES', 'A', '0.00', '99.99', '121700', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 12:41:58', 'E', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1553', '0', '262', 'ES', 'A', '0.00', '99.99', '122900', 'T', 'S', '', 'TIEMPO DE PROTROMBINA/INR', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 12:47:58', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1552', '0', '257', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'PSA Libre....................:', null, 'ng/ml', '( 0.05-0.25 )', '0.05', '0.25', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 12:03:21', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1199', '0', '258', 'ES', 'A', '0.00', '99.99', '122100', 'C', 'S', '', 'E.B.V. (VCA) IgG', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1200', '0', '258', 'ES', 'A', '0.00', '99.99', '122200', 'O', 'S', null, 'OBSERVACIONES', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', null, '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1201', '0', '258', 'ES', 'A', '0.00', '99.99', '122300', 'C', 'S', '', 'E.B.V. (VCA) IgM', '', '', '', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '0', '0', '0', '1', '10', '2007-02-04 20:26:37', '', '$C', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1202', '0', '259', 'ES', 'A', '0.00', '99.99', '122400', 'N', 'S', null, 'HAV-IgG(Hepatitis A).........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 09:13:58', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1203', '0', '259', 'ES', 'A', '0.00', '99.99', '122500', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1204', '0', '260', 'ES', 'A', '0.00', '99.99', '122600', 'N', 'S', null, 'HAV-IgM(Hepatitis A).........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 09:14:25', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1205', '0', '260', 'ES', 'A', '0.00', '99.99', '122700', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 12:44:09', 'E', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1206', '0', '261', 'ES', 'A', '0.00', '99.99', '122800', 'N', 'S', null, 'HCV (Hepatitis C)............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 09:14:55', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1207', '0', '261', 'ES', 'A', '0.00', '99.99', '122900', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 12:45:00', 'E', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1208', '0', '262', 'ES', 'A', '0.00', '99.99', '123000', 'N', 'S', null, 'Paciente.....................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 12:42:38', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1209', '0', '262', 'ES', 'A', '0.00', '99.99', '123100', 'N', 'S', null, 'Control Normal...............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 12:43:11', 'E', '$B', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1210', '0', '262', 'ES', 'A', '0.00', '99.99', '123200', 'N', 'S', null, 'INR..........................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 12:42:15', 'E', '$C', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1211', '0', '262', 'ES', 'A', '0.00', '99.99', '123300', 'N', 'S', null, 'ISI..........................:', '1.2', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 12:41:41', 'M', '$D', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1212', '0', '263', 'ES', 'A', '0.00', '99.99', '123400', 'C', 'S', null, 'Micoplasma..........:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$A', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1213', '0', '263', 'ES', 'A', '0.00', '99.99', '123500', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', '', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1214', '0', '264', 'ES', 'A', '0.00', '99.99', '123600', 'N', 'S', null, 'ACTH.........................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 12:47:27', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1215', '0', '264', 'ES', 'A', '0.00', '99.99', '123700', 'O', 'S', null, 'OBSERVACIONES.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 12:46:05', 'E', '$B', '0', null, 'L');
INSERT INTO `defaults` VALUES ('1216', '0', '265', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Homocisteina.................:', null, 'umol/L', '( 5.0 - 15.0)', '5', '15', '-99999.99', '99999.99', '-99999.99', '99999.99', 'HCY', null, null, null, '1', '10', '2007-02-22 07:56:07', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1218', '0', '266', 'ES', 'A', '0.00', '99.99', '124000', 'N', 'S', null, 'CPK-MB.......................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CKMB', null, null, null, '1', '10', '2007-02-17 08:34:13', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1302', '0', '277', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'CA-15.3......................:', null, 'IU/ml', '( 0.0 - 31.3 )', '0', '31.3', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CA153', null, null, null, '1', '10', '2007-02-22 08:06:52', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1223', '0', '274', 'ES', 'M', '0.00', '99.99', '100', 'N', 'S', null, 'Androstenediona..............:', null, 'ng/ml', '( 0.6 -  3.1 )', '0.6', '3.1', '-99999.99', '99999.99', '-99999.99', '99999.99', 'AND', null, null, null, '1', '10', '2007-02-07 11:16:54', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1224', '0', '274', 'ES', 'F', '0.00', '99.99', '200', 'N', 'S', null, 'Androstenediona..............:', null, 'ng/ml', '( 0.3 -  3.3 )', '0.3', '3.3', '-99999.99', '99999.99', '-99999.99', '99999.99', 'AND', null, null, null, '1', '10', '2007-02-07 11:17:04', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1225', '0', '275', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Anti-TPO.....................:', null, 'IU/ml', '( 0.0 - 35.0 )', '0', '35', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ATA', null, null, null, '1', '10', '2007-02-05 09:29:00', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1226', '0', '282', 'ES', 'M', '0.00', '99.99', '100', 'N', 'S', null, 'SHBG.........................:', null, 'nmol/L', '( 13 -  71 )', '13', '71', '-99999.99', '99999.99', '-99999.99', '99999.99', 'SBG', null, null, null, '1', '10', '2007-02-09 11:41:37', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1227', '0', '282', 'ES', 'F', '0.00', '99.99', '200', 'N', 'S', null, 'SHBG.........................:', null, 'mmol/L', '(  18 -  114 )', '18', '114', '-99999.99', '99999.99', '-99999.99', '99999.99', 'SBG', null, null, null, '1', '10', '2007-02-09 11:50:29', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1228', '0', '283', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'T-3  Libre...................:', null, 'pg/ml', '( 1.8 -  4.2 )', '1.8', '4.2', '-99999.99', '99999.99', '-99999.99', '99999.99', 'FT3', null, null, null, '1', '10', '2007-02-09 11:42:18', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1230', '0', '285', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Albúmina.....................:', null, 'g/dl', '( 3.5 - 5.0 )', '3.5', '5', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ALB', null, null, null, '1', '10', '2007-02-05 11:01:43', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1231', '0', '286', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Amilasa pancreática..........:', null, 'U/I', '( 0.0 - 53.0 )', '0', '53', '-99999.99', '99999.99', '-99999.99', '99999.99', 'P-AM', null, null, null, '1', '10', '2007-02-05 11:02:27', 'N', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1406', '0', '288', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Radicales Libres.............:', null, 'U/CARR', 'Stress Oxidativo:\r\n( Normal:.........250 - 300 )\r\n( Borde:..........301 - 320 )\r\n( Bajo:...........321 - 340 )\r\n( Medio:..........341 - 400 )\r\n( Alto:...........401 - 500 )\r\n( Muy Alto:............>500 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 11:07:36', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1301', '0', '276', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'CA-19.9......................:', null, 'UI/ml', '( 0.0 - 37.0 )', '0', '37', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CA199', null, null, null, '1', '10', '2007-02-22 08:07:21', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1393', '0', '267', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'PCR-Alta Sensibilidad........:', null, 'mg/L', '(Normal Cardíaco:  1.0 - 3.0)\r\n(Elevado Cardiaco: 3.0 -10.0)\r\n(Inf.no Cardiovascular:>10.0)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CRP', null, null, null, '1', '10', '2007-02-22 07:45:19', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1240', '0', '300', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', null, 'Prueba Cruzada......:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-07 10:16:33', 'E', null, '1', null, 'L');
INSERT INTO `defaults` VALUES ('1241', '0', '301', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'MHATP........................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:15:03', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1242', '0', '302', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Clostridium Difficile........:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:15:53', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1243', '0', '303', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:............<0.209 )\r\n( Equivoco:.....0.209 - 0.254 ) \r\n( Positivo:............>0.254 )', '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:02:49', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1244', '0', '310', 'ES', 'A', '0.00', '99.99', '100', 'N', null, null, 'Uricosuria al Azar...........:', null, 'mg/dl', null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'URIC', null, null, null, '1', '10', '2007-02-07 10:25:02', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1245', '0', '311', 'ES', 'A', '0.00', '99.99', null, 'N', 'S', null, 'Anfetaminas..................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'ANFE', null, null, null, '1', '10', '2007-02-22 14:29:36', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1246', '0', '312', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Calciuria al Azar............:', null, 'mg/dl', null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CA', null, null, null, '1', '10', '2007-02-07 10:26:05', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1247', '0', '313', 'ES', 'A', '0.00', '99.99', null, 'N', 'S', null, 'Creatinuria al Azar..........:', null, 'mg/dl', null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'CREA', null, null, null, '1', '10', '2007-02-07 10:26:36', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1248', '0', '314', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Fosfaturia al Azar...........:', null, 'mg/dl', null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'PHOS', null, null, null, '1', '10', '2007-02-07 10:27:07', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1249', '0', '318', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Proteinuria al Azar..........:', null, 'mg%', null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'PROT', null, null, null, '1', '10', '2007-02-07 10:29:01', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1250', '0', '319', 'ES', 'A', '0.00', '99.99', null, 'N', 'S', null, 'Sodio en orina al Azar.......:', null, 'mmol/L', '( 30 -  900 )', '30', '900', '-99999.99', '99999.99', '-99999.99', '99999.99', 'NA', null, null, null, '1', '10', '2007-02-12 13:46:49', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1251', '0', '320', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Microalbuminuria.............:', null, 'mg/g', '(0-30)', '0', '30', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-07 10:30:03', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1252', '0', '323', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:........ ....<0.9  )\r\n( Equivoco:...... ..0.9 - 1.1 )\r\n( Positivo:..............>1.1 )', '0', '0.89', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:09:15', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1678', '0', '031', 'ES', 'A', '0.00', '99.99', '1600', 'O', 'S', null, null, null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 16:31:59', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1632', '0', '031', 'ES', 'A', '0.21', '9.99', '1700', 'N', 'S', '', 'Leucocitos...................:', null, 'mm³', '( 5000-14000)', '5000', '14000', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 07:20:52', 'E', '$D', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1255', '0', '324', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:..............<0.9 )\r\n( Equivoco:........0.9 -  1.1 )\r\n( Positivo:..............>1.1 )', '0', '0.89', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:10:23', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1516', '0', '245', 'ES', 'A', '0.00', '99.99', '119100', 'N', 'S', null, 'Título..............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 11:33:49', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1258', '0', '325', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:..............<0.9 )\r\n( Equivoco:.........0.9 - 1.1 )\r\n( Positivo:..............>1.1 )', '0', '0.89', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:11:16', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1511', '0', '252', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'H. Pylori(IgG)...............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'HPG', null, null, null, '1', '10', '2007-02-22 07:58:03', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1261', '0', '326', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:..............<0.9 )\r\n( Equivoco:..........0.9 -1.1 )\r\n( Positivo:..............>1.1 )', '0', '0.89', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:12:12', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1509', '0', '400', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', '', 'Lectura.............:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 06:39:54', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1264', '0', '327', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:..............<0.9 )\r\n( Equivoco:.........0.9 - 1.1 )\r\n( Positivo:..............>1.1 )', '0', '0.89', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:13:07', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1267', '0', '328', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:..............<0.9 )\r\n( Equivoco:.........0.9 - 1.1 )\r\n( Positivo:..............>1.1 )', '0', '0.89', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:14:10', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1508', '0', '400', 'ES', 'A', '0.00', '99.99', '100', 'C', 'S', '', 'Antígeno por Giardia:', null, null, '(mmmmmmmmmmmm)\r\n(mmmmmmmmmmmm)\r\n(mmmmmmmmmmmm)', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 06:38:36', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1270', '0', '315', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Opio.........................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:31:10', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1271', '0', '316', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Morfina......................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:31:44', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1272', '0', '317', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'PCP..........................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:32:14', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1273', '0', '321', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Nitrógeno Ureico/Orina 24Hrs.:', null, ' g/24 Hrs', '12-20', '12', '20', '-99999.99', '99999.99', '-99999.99', '99999.99', 'BUN', null, null, null, '1', '10', '2007-02-12 14:54:17', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1274', '0', '321', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Volumen......................:', null, 'ml/24 Hrs', null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 14:54:42', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1275', '0', '289', 'ES', 'A', '0.00', '99.99', '100', 'N', null, null, 'Troponina I..................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'Topi', null, null, null, '1', '10', '2007-02-22 08:41:33', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1386', '0', '270', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:............<0.9 )\r\n( Equivoco:.........0.9-1.1 )\r\n( Positivo:............>1.1 )                         ', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:18:35', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1408', '0', '271', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:............<0.9 )\r\n( Equivoco:.........0.9-1.1 )\r\n( Positivo:............>1.1 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:19:37', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1409', '0', '272', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:............<0.9 )\r\n( Equivoco:.........0.9-1.1 )\r\n( Positivo:............>1.1 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:21:44', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1410', '0', '273', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:............<0.9 )\r\n( Equivoco:.........0.9-1.1 )\r\n( Positivo:............>1.1 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:23:39', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1289', '0', '279', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Ecstasy......................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 13:48:42', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1412', '0', '292', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, 'MPL', '( Negativo:..............<5 )\r\n( Positivo Bajo:.......5-20 )\r\n( Positivo Moderado:..20-80 )\r\n( Positivo Alto:........>80 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:27:02', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1303', '0', '278', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'DOBLE MARCADOR', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1304', '0', '284', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'TRIPLE MARCADOR', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, '1', null, null, '1', '10', '2007-02-14 12:58:08', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1305', '0', '281', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Indice Androgénico...........:', null, null, '( 0.7 -  1.0 )', '0.7', '1', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 11:41:06', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1306', '0', '293', 'ES', 'A', '0.00', '99.99', null, 'N', 'S', null, 'Crioglobulinas...............:', null, null, 'PRECIPITADO EN_____HRS.', '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:04:34', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1307', '0', '295', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'HBc-Ab(Anti-Core)............:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'aHBc', null, null, null, '1', '10', '2007-02-22 08:04:47', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1308', '0', '296', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'HBeAb........................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:05:52', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1309', '0', '297', 'ES', 'A', '0.00', '99.99', null, 'N', 'S', null, 'HBeAg........................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:06:25', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1310', '0', '298', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'HBsAb........................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', 'aHBs', null, null, null, '1', '10', '2007-02-22 08:05:30', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1311', '0', '304', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', null, 'Helicobacter Pylori(Heces)...:', null, null, '( Negativo:............<0.150 )\r\n( Equivoco:.....0.150 - 0.250 )\r\n( Positivo:............>0.250 )', '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 13:55:49', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1314', '0', '294', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:............<0.8 )\r\n( Equivoco:.......0.8 - 1.2 )\r\n( Positivo:............>1.2 )', '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:29:54', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1317', '0', '308', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:............. <0.9 )\r\n( Equivoco:.........0.9 - 1.1 )\r\n( Positivo:..............>1.1 )', '0', null, '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:03:59', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1320', '0', '309', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, null, '( Negativo:..............<0.9 )\r\n( Equivoco:.........0.9 - 1.1 )\r\n( Positivo:..............>1.1 )', '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:08:08', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1397', '0', '278', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', null, 'Observación.........:', 'Ver Página Adjunto', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1398', '0', '284', 'ES', 'A', '0.00', '99.99', '200', 'O', 'S', null, 'Observación.........:', 'Ver página Adjunto', null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1595', '0', '324', 'ES', 'A', '0.00', '99.99', '100', 'N', 'S', '', 'Herpes I IgM.................:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 14:10:43', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1329', '0', '299', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'PERFIL DE HEPATITIS B', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-04 20:26:37', 'E', null, '0', null, null);
INSERT INTO `defaults` VALUES ('1330', '0', '299', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'HBeAg........................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:07:22', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1331', '0', '299', 'ES', 'A', '0.00', '99.99', '300', 'N', 'S', null, 'HBeAb........................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:07:45', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1332', '0', '299', 'ES', 'A', '0.00', '99.99', '400', 'N', 'S', null, 'HBsAg........................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:08:10', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1333', '0', '299', 'ES', 'A', '0.00', '99.99', '500', 'N', 'S', null, 'HBsAb........................:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:08:29', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1334', '0', '299', 'ES', 'A', '0.00', '99.99', '600', 'N', 'S', null, 'HBcAb-Anti Core..............:', null, null, null, '0', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-22 14:08:48', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1338', '0', '280', 'ES', 'A', '8.00', '8.00', '100', 'N', 'S', null, 'IGF-1(Somatomidina-C)........:', null, 'ng/mL', '(  64 - 345 )', '64', '345', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 08:50:06', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1339', '0', '280', 'ES', 'A', '9.00', '9.00', '200', 'N', 'S', null, 'IGF-1 (Somatomidica-C).......:', null, 'ng/mL', '(  74 - 388 )', '74', '388', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 08:50:20', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1340', '0', '280', 'ES', 'A', '10.00', '10.00', '300', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '(  88 - 452 )', '88', '452', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 08:50:51', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1341', '0', '280', 'ES', 'A', '11.00', '11.00', '400', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 111 - 551 )', '111', '551', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 08:51:15', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1342', '0', '280', 'ES', 'A', '12.00', '12.00', '500', 'N', 'S', null, 'IGF-1  (Somatomidina-c)......:', null, 'ng/mL', '( 143 - 693 )', '143', '693', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:49:48', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1343', '0', '280', 'ES', 'A', '13.00', '13.00', '600', 'N', 'S', null, 'IGF-1 (Somatomidina-c).......:', null, 'ng/mL', '( 183 - 850 )', '183', '850', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 08:51:37', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1344', '0', '280', 'ES', 'A', '14.00', '14.00', '700', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 220 - 972 )', '220', '972', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:50:15', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1345', '0', '280', 'ES', 'A', '15.00', '15.00', '800', 'N', 'S', null, 'IGF-1  (Somatomidina-C)......:', null, 'ng/mL', '( 237 - 996 )', '237', '996', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:50:48', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1346', '0', '280', 'ES', 'A', '16.00', '16.00', '900', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 226 - 903 )', '226', '903', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 08:51:56', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1347', '0', '280', 'ES', 'A', '17.00', '17.00', '1000', 'N', 'S', null, 'IGF-1  ( Somatomidina-C).....:', null, 'ng/mL', '( 193 - 731 )', '193', '731', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:52:07', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1348', '0', '280', 'ES', 'A', '31.00', '35.00', '1100', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 115 - 307 )', '115', '307', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 08:52:39', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1349', '0', '280', 'ES', 'A', '36.00', '40.00', '1200', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 109 - 284 )', '109', '284', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 08:52:17', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1350', '0', '280', 'ES', 'A', '41.00', '45.00', '1300', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/nL', '( 101 - 267  )', '101', '267', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:52:39', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1351', '0', '280', 'ES', 'A', '46.00', '50.00', '1400', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '(   94 - 252 )', '94', '252', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:53:10', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1352', '0', '280', 'ES', 'A', '51.00', '55.00', '1500', 'N', 'S', null, 'IGF-1  (Somatomidina-C)......:', null, 'ng/mL', '( 87 - 238 )', '87', '238', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:53:47', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1353', '0', '280', 'ES', 'A', '56.00', '60.00', '1600', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '(  81 - 225 )', '81', '225', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:54:16', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1354', '0', '280', 'ES', 'A', '61.00', '65.00', '1700', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 75 - 212 )', '75', '212', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:55:02', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1355', '0', '280', 'ES', 'A', '66.00', '70.00', '1800', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 69 - 200 )', '69', '200', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:55:31', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1356', '0', '280', 'ES', 'A', '71.00', '75.00', '1900', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 64 - 188 )', '64', '188', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:56:09', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1357', '0', '280', 'ES', 'A', '76.00', '80.00', '2000', 'N', 'S', null, 'IGF-1  (Somatomidina-C)......:', null, 'ng/mL', '( 59 - 177 )', '59', '177', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:56:39', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1365', '0', '306', 'ES', 'A', '20.00', '59.00', '100', 'N', 'S', null, '17 OH Progesterona...........:', null, 'ng/ml', '(0.60 - 3.42 )', '0.6', '3.42', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-13 08:17:42', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1359', '0', '280', 'ES', 'A', '81.00', '85.00', '2100', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '(  55 - 166 )', '55', '166', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:57:24', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1360', '0', '280', 'ES', 'A', '21.00', '25.00', '2200', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 116 - 358 )', '116', '358', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:57:37', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1361', '0', '280', 'ES', 'A', '26.00', '30.00', '2300', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 117 - 329 )', '117', '329', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:57:51', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1362', '0', '280', 'ES', 'A', '18.00', '18.00', '2400', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 163 - 584 )', '163', '584', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:58:15', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1363', '0', '280', 'ES', 'A', '19.00', '19.00', '2500', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 141 - 483 )', '141', '483', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:58:49', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1364', '0', '280', 'ES', 'A', '20.00', '20.00', '2600', 'N', 'S', null, 'IGF-1 (Somatomidina-C).......:', null, 'ng/mL', '( 127 - 242 )', '127', '242', '-99999.99', '99999.99', '-99999.99', '99999.99', 'IG1', null, null, null, '1', '10', '2007-02-22 13:58:29', 'E', null, '1', null, 'R');
INSERT INTO `defaults` VALUES ('1411', '0', '291', 'ES', 'A', '0.00', '99.99', '200', 'N', 'S', null, 'Lectura......................:', null, 'MPL', '( Negativo:..............<5 )\r\n( Positivo Bajo:.......5-20 )\r\n( Positivo Moderado:..20-80 )\r\n( Positivo Alto:........>80 )', '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-14 11:25:48', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1421', '0', '166', 'ES', 'A', '1.00', '1.99', '300', 'N', 'S', null, 'IgE..........................:', null, 'UI/ml', '( ND  -  49 )', '-99999.99', '49', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TIE', null, null, null, '1', '10', '2007-02-22 16:56:57', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1422', '0', '166', 'ES', 'A', '2.00', '2.99', '400', 'N', 'S', null, 'IgE..........................:', null, 'UI/ml', '( ND  -  45 )', '-99999.99', '45', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TIE', null, null, null, '1', '10', '2007-02-22 16:57:43', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1423', '0', '166', 'ES', 'A', '3.00', '9.99', '500', 'N', 'S', null, 'IgE..........................:', null, 'UI/ml', '( ND  -  52 )', '-99999.99', '52', '-99999.99', '99999.99', '-99999.99', '99999.99', 'TIE', null, null, null, '1', '10', '2007-02-22 16:58:14', 'E', null, '0', null, 'R');
INSERT INTO `defaults` VALUES ('1458', '0', '287', 'ES', 'A', '0.00', '99.99', '1700', 'O', 'S', null, 'PACIENTE DE REMODELAMIENTO:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-10 08:35:20', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1485', '0', '187', 'ES', 'A', '0.00', '99.99', '100', 'T', 'S', null, 'GLUCOSURIA FRACCIONADA', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-09 12:22:07', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1460', '0', '032', 'ES', 'A', '0.00', '0.20', '900', 'N', 'S', null, 'Hematocrito..................:', null, '%', '( Cordón:  43 - 53 )\r\n', '43', '53', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 08:52:04', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1461', '0', '032', 'ES', 'A', '0.00', '0.20', '1000', 'S', 'S', null, 'Hematocrito..................:', null, '%', '( Venosa: 51 - 63 )', '51', '63', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 08:53:58', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1462', '0', '032', 'ES', 'A', '0.00', '0.20', '1100', 'S', 'S', null, 'Hematocrito..................:', null, '%', '( 59 - 72 )', '59', '72', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 08:54:45', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1463', '0', '032', 'ES', 'A', '0.21', '14.99', '1200', 'N', 'S', null, 'Hematocrito..................:', null, '%', '( 34.0 - 37.0 )', '34', '37', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 09:24:18', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1465', '0', '032', 'ES', 'M', '15.00', '99.99', '1400', 'N', 'S', null, 'Hematocrito..................:', null, '%', '( 42.0 - 54.0 )', '42', '54', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 09:25:28', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1466', '0', '032', 'ES', 'F', '15.00', '99.99', '1300', 'N', 'S', null, 'Hematocrito..................:', null, '%', '( 38.0 - 47.0 )', '38', '47', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-05 09:24:56', 'E', '$A', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1500', '0', '015', 'ES', 'A', '0.00', '99.99', '400', 'F', 'S', null, 'Creatinuria /24 Hrs..........:', null, 'g/24 Hrs', '( 0.8 - 2.8 )', '0.8', '2.8', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-12 08:46:29', 'E', null, '0', '$A*$B*0.01', 'R');
INSERT INTO `defaults` VALUES ('1572', '0', '054', 'ES', 'A', '0.00', '99.99', '900', 'O', 'S', '', 'Observación.......:', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-15 10:11:41', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1575', '0', '055', 'ES', 'A', '0.00', '99.99', '200', 'C', 'S', null, 'Post Ingesta de 75 g/dextrosa', null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-16 13:41:22', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1667', '0', '030', 'ES', 'A', '0.00', '99.99', '1500', 'O', 'S', null, null, null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 16:21:40', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1672', '0', '287', 'ES', 'A', '0.00', '99.99', null, 'C', 'S', '', null, null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-23 13:07:58', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1673', '0', '030', 'ES', 'A', '0.00', '99.99', '5300', 'O', 'S', null, null, null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 16:26:53', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1674', '0', '031', 'ES', 'A', '0.00', '0.20', '1600', 'N', 'S', null, 'Leucocitos', null, 'mm³', '(10000-12000)', '10000', '12000', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 16:05:47', 'E', '$D', '0', null, 'R');
INSERT INTO `defaults` VALUES ('1681', '0', '031', 'ES', 'A', '0.00', '99.99', '4500', 'O', 'S', '', null, null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 16:58:16', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1679', '0', '031', 'ES', 'A', '0.00', '99.99', '3600', 'C', 'S', '', null, null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 16:54:05', 'E', null, '0', null, 'L');
INSERT INTO `defaults` VALUES ('1680', '0', '031', 'ES', 'A', '0.00', '99.99', '4400', 'O', 'S', '', null, null, null, null, '-99999.99', '99999.99', '-99999.99', '99999.99', '-99999.99', '99999.99', null, null, null, null, '1', '10', '2007-02-24 16:57:04', 'E', null, '0', null, 'L');
INSERT INTO `departamentos` VALUES ('1', 'Sin departamento');
INSERT INTO `departamentos` VALUES ('2', 'INMUNOSEROLOGIA');
INSERT INTO `departamentos` VALUES ('3', 'QUIMICA GENERAL');
INSERT INTO `departamentos` VALUES ('4', 'QUIMICA ESPECIALIZADA');
INSERT INTO `departamentos` VALUES ('5', 'HEMATOLOGIA');
INSERT INTO `departamentos` VALUES ('6', 'BACTERIOLOGIA');
INSERT INTO `departamentos` VALUES ('7', 'URINALISIS');
INSERT INTO `departamentos` VALUES ('8', 'PARASITOLOGIA');
INSERT INTO `departamentos` VALUES ('9', 'HEMATOLOGIA ESPECIALIZADA');
INSERT INTO `departamentos` VALUES ('10', 'TOXICOLOGIA');
INSERT INTO `direxame` VALUES ('001', 'Heces General', '4.00', '1', '8');
INSERT INTO `direxame` VALUES ('002', 'Frotis de Heces', '5.00', '1', '8');
INSERT INTO `direxame` VALUES ('004', 'Grasas en Heces', '3.00', '1', '8');
INSERT INTO `direxame` VALUES ('005', 'Azúcares Reductores', '5.00', '1', '8');
INSERT INTO `direxame` VALUES ('006', 'Ph en Heces', '3.00', '1', '8');
INSERT INTO `direxame` VALUES ('007', 'Sangre oculta en Heces', '2.50', '1', '8');
INSERT INTO `direxame` VALUES ('008', 'Orina General', '4.00', '1', '7');
INSERT INTO `direxame` VALUES ('014', 'HCG- Cualitativa (orina)', '6.00', '1', '4');
INSERT INTO `direxame` VALUES ('015', 'Creatinuria de 24 Hrs.', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('016', 'Uricosuria de 24 Hrs', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('017', 'Calciuria de 24 Hrs', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('018', 'Fosfaturia de 24 Hrs.', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('019', 'Proteinuria de 24 Hrs.', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('020', 'Amilasuria de 2 Hrs.', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('294', 'Helicobacter Pylori - IgA', '35.00', '1', '2');
INSERT INTO `direxame` VALUES ('022', 'Depuración de Creatinina', '15.00', '1', '3');
INSERT INTO `direxame` VALUES ('502', 'GENERALI PS4 (COOP. MEDICOS)', '48.00', null, null);
INSERT INTO `direxame` VALUES ('024', 'Bilis en Orina', '3.00', '1', '7');
INSERT INTO `direxame` VALUES ('025', 'Cetonas en Orina', '3.00', '1', '7');
INSERT INTO `direxame` VALUES ('253', 'Nicotina-Cotinina(orina)', '15.00', '1', '4');
INSERT INTO `direxame` VALUES ('028', 'Espermograma', '15.00', '1', '2');
INSERT INTO `direxame` VALUES ('029', 'Análisis de Cálculo', '105.00', '1', '4');
INSERT INTO `direxame` VALUES ('030', 'Hemograma', '6.00', '1', '5');
INSERT INTO `direxame` VALUES ('032', 'Hemoglobina y Hematocrito', '3.00', '1', '5');
INSERT INTO `direxame` VALUES ('036', 'Plaquetas', '4.00', '1', '5');
INSERT INTO `direxame` VALUES ('038', 'Hierro Sérico Total', '15.00', '1', '3');
INSERT INTO `direxame` VALUES ('039', 'V.E.S.', '4.00', '1', '5');
INSERT INTO `direxame` VALUES ('040', 'Células L.E.', '12.50', '1', '2');
INSERT INTO `direxame` VALUES ('041', 'Tiempo de Coagulación', '5.00', '1', '9');
INSERT INTO `direxame` VALUES ('042', 'Tiempo de Sangrado', '5.00', '1', '9');
INSERT INTO `direxame` VALUES ('043', 'Tiempo de Protrombina', '10.00', '1', '9');
INSERT INTO `direxame` VALUES ('044', 'Tiempo de Tromboplastina Par.', '10.00', '1', '9');
INSERT INTO `direxame` VALUES ('045', 'Frotis por Eosinófilo(moco N)', '5.00', '1', '5');
INSERT INTO `direxame` VALUES ('046', 'Placa por Malaria', '5.00', '1', '5');
INSERT INTO `direxame` VALUES ('047', 'Grupo y  Rh', '3.00', '1', '2');
INSERT INTO `direxame` VALUES ('048', 'Coombs Directo', '10.00', '1', '2');
INSERT INTO `direxame` VALUES ('049', 'Coombs Indirecto', '10.00', '1', '2');
INSERT INTO `direxame` VALUES ('051', 'Crioaglutininas', '15.00', '1', '2');
INSERT INTO `direxame` VALUES ('052', 'Glucosa', '6.00', '1', '3');
INSERT INTO `direxame` VALUES ('053', 'Curva Tolerancia a Glucosa 2Hr', '28.00', '1', '3');
INSERT INTO `direxame` VALUES ('054', 'Curva Tolerancia a Glucosa 3Hr', '34.00', '1', '3');
INSERT INTO `direxame` VALUES ('055', 'Curva Tolerancia a Glucosa 5Hr', '46.00', '1', '3');
INSERT INTO `direxame` VALUES ('056', 'Glucosa 2Hr Post Pandrial', '6.00', '1', '3');
INSERT INTO `direxame` VALUES ('057', 'A1C(Hgb. Glicosilada)', '20.00', '1', '3');
INSERT INTO `direxame` VALUES ('058', 'Colesterol Total', '6.00', '1', '3');
INSERT INTO `direxame` VALUES ('059', 'HDL-Colesterol', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('060', 'LDL-Colesterol', '0.00', '1', '3');
INSERT INTO `direxame` VALUES ('061', 'Triglicéridos', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('548', 'Atlantic Pacific Security', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('065', 'Creatinina', '6.00', '1', '3');
INSERT INTO `direxame` VALUES ('066', 'Acido Urico', '6.00', '1', '3');
INSERT INTO `direxame` VALUES ('067', 'Proteínas Totales y Rel. A/G', '12.50', '1', '3');
INSERT INTO `direxame` VALUES ('069', 'Sodio', '7.00', '1', '3');
INSERT INTO `direxame` VALUES ('070', 'Potasio', '7.00', '1', '3');
INSERT INTO `direxame` VALUES ('071', 'Cloruro', '7.00', '1', '3');
INSERT INTO `direxame` VALUES ('074', 'Fósforo', '7.00', '1', '3');
INSERT INTO `direxame` VALUES ('072', 'CO2', '7.00', '1', '3');
INSERT INTO `direxame` VALUES ('076', 'Bilirrubinas Total y Directa', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('078', 'SGOT/AST', '7.50', '1', '3');
INSERT INTO `direxame` VALUES ('079', 'SGPT/ALT', '7.50', '1', '3');
INSERT INTO `direxame` VALUES ('080', 'Gama Glutamil Transferasa', '8.00', '1', '3');
INSERT INTO `direxame` VALUES ('081', 'Fosfatasa Alcalina', '7.50', '1', '3');
INSERT INTO `direxame` VALUES ('083', 'Antígeno Carcino Embriónico', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('084', 'Alfa-Fetoproteína', '35.00', '1', '4');
INSERT INTO `direxame` VALUES ('085', 'Amilasa', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('086', 'D.H.L.', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('087', 'Creatina Fosfokinasa(CPK)', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('293', 'Crioglobulinas', '20.00', '1', '2');
INSERT INTO `direxame` VALUES ('090', 'Fosfatasa Acida', '7.50', '1', '3');
INSERT INTO `direxame` VALUES ('091', 'Fracción Prostática', '13.50', '1', '3');
INSERT INTO `direxame` VALUES ('092', 'Fenitoína', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('094', 'Fenobarbital', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('095', 'Carbamazepina', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('096', 'Acido Valproico', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('292', 'Anti-Cardiolipina IgM', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('098', 'Teofilina', '35.00', '1', '4');
INSERT INTO `direxame` VALUES ('291', 'Anti-Cardiolipina IgG', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('100', 'Digoxina', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('571', 'Iberia', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('689', 'COPA Grupo C (Hombre)', '33.00', 'M', null);
INSERT INTO `direxame` VALUES ('106', 'T-3', '12.50', '1', '4');
INSERT INTO `direxame` VALUES ('107', 'T-4', '12.50', '1', '4');
INSERT INTO `direxame` VALUES ('108', 'Prolactina', '15.00', '1', '4');
INSERT INTO `direxame` VALUES ('109', 'F.S.H.', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('110', 'L.H.', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('111', 'Progesterona', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('112', 'Testosterona', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('692', 'COPA EM ( Dr Paredes)', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('114', 'Insulina Ayunas', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('289', 'Troponina I', '30.00', '1', '3');
INSERT INTO `direxame` VALUES ('118', 'HCG Cualitativa (suero)', '10.00', '1', '4');
INSERT INTO `direxame` VALUES ('119', 'Frotis por Gram', '5.00', '1', '6');
INSERT INTO `direxame` VALUES ('120', 'Cultivo', '12.50', '1', '6');
INSERT INTO `direxame` VALUES ('121', 'Sensibilidad a  Antibioticos', '0.00', '1', '6');
INSERT INTO `direxame` VALUES ('122', 'Urocultivo', '12.50', '1', '6');
INSERT INTO `direxame` VALUES ('123', 'Coprocultivo', '15.00', '1', '6');
INSERT INTO `direxame` VALUES ('124', 'Cultivo por BAR', '25.00', '1', '6');
INSERT INTO `direxame` VALUES ('125', 'Cultivo por Hongos', '25.00', '1', '6');
INSERT INTO `direxame` VALUES ('126', 'Hemocultivo', '15.00', '1', '6');
INSERT INTO `direxame` VALUES ('127', 'V.D.R.L.', '5.00', '1', '2');
INSERT INTO `direxame` VALUES ('128', 'Antígenos Febriles', '15.00', '1', '2');
INSERT INTO `direxame` VALUES ('129', 'Factor Rehumatoideo', '10.00', '1', '2');
INSERT INTO `direxame` VALUES ('130', 'Proteína C Reactiva', '10.00', '1', '2');
INSERT INTO `direxame` VALUES ('131', 'A.S.T.O.', '10.00', '1', '2');
INSERT INTO `direxame` VALUES ('132', 'Mono-Test', '8.00', '1', '2');
INSERT INTO `direxame` VALUES ('073', 'Calcio', '7.00', '1', '3');
INSERT INTO `direxame` VALUES ('136', 'F.T.A./A.B.S.', '25.00', '1', '2');
INSERT INTO `direxame` VALUES ('139', 'HBsAg (Antígeno Australiano)', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('142', 'Anticuerpos Antinucleares(ANA)', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('143', 'Anti-DNA', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('144', 'Anti-Tiroglobulina', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('145', 'Anticuerpos Microsomales', '35.00', '1', '2');
INSERT INTO `direxame` VALUES ('146', 'Anticuerpos Mitocondriales', '25.00', '1', '2');
INSERT INTO `direxame` VALUES ('147', 'Acido Vanil Mandélico(AVM)', null, '1', '3');
INSERT INTO `direxame` VALUES ('148', 'Inmunoglobulinas(G-A-M)', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('528', 'CB Richard Ellis (Mujer)', '34.00', 'M', null);
INSERT INTO `direxame` VALUES ('632', 'Capital  PSA', '20.00', 'M', null);
INSERT INTO `direxame` VALUES ('151', 'T.S.H.', '15.00', '1', '4');
INSERT INTO `direxame` VALUES ('152', 'T-4 Libre', '15.00', '1', '4');
INSERT INTO `direxame` VALUES ('154', 'Rubeola (IgG)', '20.00', '1', '2');
INSERT INTO `direxame` VALUES ('155', 'Estudio Bacteriológico de Agua', '30.00', '1', '6');
INSERT INTO `direxame` VALUES ('156', 'Complemento C3', '10.00', '1', '2');
INSERT INTO `direxame` VALUES ('157', 'Complemento C4', '10.00', '1', '2');
INSERT INTO `direxame` VALUES ('158', 'CH-50', '35.00', '1', '4');
INSERT INTO `direxame` VALUES ('288', 'Radicales Libres', '50.00', '1', '3');
INSERT INTO `direxame` VALUES ('160', 'Potasio en Orina(24 Hrs.)', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('161', 'Sodio en orina(24 Hrs)', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('162', 'Fibrinógeno', '20.00', '1', '5');
INSERT INTO `direxame` VALUES ('287', 'BMO', '110.00', '1', '3');
INSERT INTO `direxame` VALUES ('164', 'Colinesterasa', '15.00', '1', '3');
INSERT INTO `direxame` VALUES ('165', 'Hormona de Crecimiento', '35.00', '1', '4');
INSERT INTO `direxame` VALUES ('166', 'Inmunoglobulina E (IgE)', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('286', 'Amilasa Pancreática', '15.00', '1', '3');
INSERT INTO `direxame` VALUES ('285', 'Albúmina', '6.00', '1', '3');
INSERT INTO `direxame` VALUES ('170', 'Lipasa', '25.00', '1', '3');
INSERT INTO `direxame` VALUES ('171', 'Glucosa 2Hrs post Dextrosa', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('174', ' Rotavirus', '15.00', '1', '2');
INSERT INTO `direxame` VALUES ('284', 'Triple Marcador', '80.00', '1', '4');
INSERT INTO `direxame` VALUES ('283', 'T-3 Libre', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('282', 'SHBG ', '65.00', '1', '4');
INSERT INTO `direxame` VALUES ('179', 'Mioglobulina', '0.00', '1', '4');
INSERT INTO `direxame` VALUES ('281', 'Indice Androgénico Libre', '0.00', '1', '4');
INSERT INTO `direxame` VALUES ('280', 'IGF-1  (Somatomidina-C)', '90.00', '1', '4');
INSERT INTO `direxame` VALUES ('184', 'Carotenos', '0.00', '1', '4');
INSERT INTO `direxame` VALUES ('185', 'Litio', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('186', 'Anti-HIV (1+2)', '15.00', '1', '2');
INSERT INTO `direxame` VALUES ('187', 'Glucosuria Fraccionada', '9.00', '1', '3');
INSERT INTO `direxame` VALUES ('279', 'Ecstasy', '20.00', '1', '10');
INSERT INTO `direxame` VALUES ('189', 'Ceruloplasmina', null, '1', '4');
INSERT INTO `direxame` VALUES ('190', 'Plomo en Sangre', '65.00', '1', '10');
INSERT INTO `direxame` VALUES ('276', 'CA-19.9', '40.00', '1', '4');
INSERT INTO `direxame` VALUES ('275', 'Anti-TPO', '35.00', '1', '4');
INSERT INTO `direxame` VALUES ('193', 'Serotoninas(5-HIA)', null, '1', '4');
INSERT INTO `direxame` VALUES ('194', 'Cortisol-AM', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('195', 'Testosterona Libre', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('196', '17-Hidroxicorticosteroides', '35.00', '1', '4');
INSERT INTO `direxame` VALUES ('274', 'Androstenediona', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('273', 'Influenza B-IgM', '20.00', '1', '2');
INSERT INTO `direxame` VALUES ('272', 'Influenza B-IgG', '20.00', '1', '2');
INSERT INTO `direxame` VALUES ('200', 'Aldolasa', '25.00', '1', '3');
INSERT INTO `direxame` VALUES ('203', 'Mercurio en Sangre', '0.00', '1', '10');
INSERT INTO `direxame` VALUES ('271', 'Influenza A-IgM', '20.00', '1', '2');
INSERT INTO `direxame` VALUES ('270', 'Influenza  A-IgG', '20.00', '1', '2');
INSERT INTO `direxame` VALUES ('208', 'Glucosa 6-P Deshidrogenasa', '30.00', '1', '3');
INSERT INTO `direxame` VALUES ('687', 'COPA Grupo A', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('212', 'VLDL-Colesterol(Calculado)', '28.00', '1', '3');
INSERT INTO `direxame` VALUES ('213', 'PTH-Intacta (Paratohormona)', '35.00', '1', '4');
INSERT INTO `direxame` VALUES ('075', 'Magnesio', '7.00', '1', '3');
INSERT INTO `direxame` VALUES ('217', 'Alfa-1-Antitripsina', '0.00', '1', '4');
INSERT INTO `direxame` VALUES ('694', 'PACT-Grupo \"F\" (Dopping)', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('225', 'Perfil de Lípidos', '28.00', '1', '3');
INSERT INTO `direxame` VALUES ('226', 'Antígeno Prostático Específico', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('227', 'Glucosa 1H. Post 50gr Dex.', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('228', 'Toxoplasmosis (IgG)', '15.00', '1', '2');
INSERT INTO `direxame` VALUES ('229', 'Toxoplasmosis (IgM)', '25.00', '1', '2');
INSERT INTO `direxame` VALUES ('232', 'Cocaína en Orina', '10.00', '1', '10');
INSERT INTO `direxame` VALUES ('233', 'Marihuana en Orina', '10.00', '1', '10');
INSERT INTO `direxame` VALUES ('234', 'Clamidia Toma Directa', '25.00', '1', '2');
INSERT INTO `direxame` VALUES ('235', 'DHEA(SO4)', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('236', 'Papanicolau', '12.00', '1', '1');
INSERT INTO `direxame` VALUES ('237', 'Cultivo de Thayer Martin', '8.00', '1', '6');
INSERT INTO `direxame` VALUES ('238', 'Filarias', '2.00', '1', null);
INSERT INTO `direxame` VALUES ('239', 'Citomegalovirus (IgG)', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('240', 'Citomegalovirus (IgM)', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('243', 'Rubeola (IgM)', '25.00', '1', '2');
INSERT INTO `direxame` VALUES ('244', 'Ferritina', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('245', 'RPR', '5.00', '1', '2');
INSERT INTO `direxame` VALUES ('247', 'Clamidia en Suero', '20.00', '1', '2');
INSERT INTO `direxame` VALUES ('248', 'Transferrina', '0.00', '1', '3');
INSERT INTO `direxame` VALUES ('249', 'Alcoholemia', '20.00', '1', '3');
INSERT INTO `direxame` VALUES ('250', 'Perfil Prostático', '50.00', '1', '4');
INSERT INTO `direxame` VALUES ('251', 'Nicotina-Cotinina(Suero)', '15.00', '1', '4');
INSERT INTO `direxame` VALUES ('252', 'Helicobacter Pylori (IgG)', '25.00', '1', '2');
INSERT INTO `direxame` VALUES ('254', 'CA-125', '40.00', '1', '4');
INSERT INTO `direxame` VALUES ('255', 'Dengue (IgG e IgM)', '25.00', '1', '2');
INSERT INTO `direxame` VALUES ('256', 'BTA (Antígeno Tumor Vejiga)', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('259', 'HAV-IgG (Hepatitis A)', '40.00', '1', '2');
INSERT INTO `direxame` VALUES ('260', 'HAV-IgM (Hepatitis A)', '40.00', '1', '2');
INSERT INTO `direxame` VALUES ('261', 'HCV (Hepatitis C)', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('262', 'Tiempo de Protombina / INR', '17.50', '1', '9');
INSERT INTO `direxame` VALUES ('263', 'Cultivo por Micoplasma', '30.00', '1', '6');
INSERT INTO `direxame` VALUES ('264', 'ACTH', '35.00', '1', '4');
INSERT INTO `direxame` VALUES ('265', 'Homocisteína', '60.00', '1', '4');
INSERT INTO `direxame` VALUES ('266', 'CPK-MB', '25.00', '1', '3');
INSERT INTO `direxame` VALUES ('267', 'PCR-Alta Sensibilidad', '45.00', '1', '4');
INSERT INTO `direxame` VALUES ('278', 'Doble Marcador', '50.00', '1', '4');
INSERT INTO `direxame` VALUES ('277', 'CA - 15.3', '45.00', '1', '4');
INSERT INTO `direxame` VALUES ('500', 'Generali PS2 (Vida Ind.)', '30.00', 'M', null);
INSERT INTO `direxame` VALUES ('690', 'COPA Grupo D (Mujer)', '18.00', 'M', null);
INSERT INTO `direxame` VALUES ('691', 'COPA Grupo D (Hombre)', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('693', 'PACT-Grupo \"D\" (Mujer)', '18.00', 'M', null);
INSERT INTO `direxame` VALUES ('509', 'Assa UL', '2.38', 'M', null);
INSERT INTO `direxame` VALUES ('510', 'Assa Lab B', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('511', 'Assa Lab A', '69.05', 'M', null);
INSERT INTO `direxame` VALUES ('512', 'Generali PS1 (Vida Ind.)', '75.00', 'M', null);
INSERT INTO `direxame` VALUES ('513', 'Generali UL', '3.00', 'M', null);
INSERT INTO `direxame` VALUES ('514', 'Generali HIV', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('515', 'Generali Nicotina', '9.00', 'M', null);
INSERT INTO `direxame` VALUES ('518', 'Centro de Agencias (Hombre)', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('519', 'Centro de Agencias (Mujer)', '8.00', 'M', null);
INSERT INTO `direxame` VALUES ('661', 'Dr. Paz (Anti-Aging Mujer)', '428.00', 'M', null);
INSERT INTO `direxame` VALUES ('521', 'F. Icaza (Hombre)', '24.00', 'M', null);
INSERT INTO `direxame` VALUES ('522', 'F. Icaza (Mujer)', '29.00', 'M', null);
INSERT INTO `direxame` VALUES ('523', 'Atlantic Pacific', '11.00', 'M', null);
INSERT INTO `direxame` VALUES ('524', 'Cruz Verde (Truly Nolen)', '11.50', 'M', null);
INSERT INTO `direxame` VALUES ('525', 'Metrobank (Hombre)', '30.50', 'M', null);
INSERT INTO `direxame` VALUES ('526', 'Metrobank (Mujer)', '35.50', 'M', null);
INSERT INTO `direxame` VALUES ('567', 'Global Bank (Dopping)', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('535', 'Hotel Sheraton (Mujer)', '30.00', 'M', null);
INSERT INTO `direxame` VALUES ('534', 'Hotel Sheraton (Hombre)', '22.00', 'M', null);
INSERT INTO `direxame` VALUES ('591', 'Mundial Nicotina', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('568', 'Global Bank (Ortho)', '8.00', 'M', null);
INSERT INTO `direxame` VALUES ('544', 'Dr. Pereira (Hombre)', '33.00', 'M', null);
INSERT INTO `direxame` VALUES ('545', 'Dr. Pereira (Mujer)', '39.00', 'M', null);
INSERT INTO `direxame` VALUES ('547', 'Mediequipo', '8.00', 'M', null);
INSERT INTO `direxame` VALUES ('550', 'Bac / Credomatic (Mujer)', '32.00', 'M', null);
INSERT INTO `direxame` VALUES ('551', 'Bac / Credomatic (Hombre)', '24.00', 'M', null);
INSERT INTO `direxame` VALUES ('553', 'Panasonic PSA', '18.75', 'M', null);
INSERT INTO `direxame` VALUES ('557', 'Panasonic (Japoneses)', '80.00', 'M', null);
INSERT INTO `direxame` VALUES ('624', 'IS UL ', '2.50', 'M', null);
INSERT INTO `direxame` VALUES ('666', 'Alico Perfil Completo', '82.00', 'M', null);
INSERT INTO `direxame` VALUES ('564', 'Global Bank  (A) (Hombre)', '53.00', 'M', null);
INSERT INTO `direxame` VALUES ('565', 'Global Bank (B) (Mujer)', '63.00', 'M', null);
INSERT INTO `direxame` VALUES ('566', 'Global Bank (C) (Hombre PSA)', '73.00', 'M', null);
INSERT INTO `direxame` VALUES ('569', 'Pamar (Mujer)', '32.00', 'M', null);
INSERT INTO `direxame` VALUES ('570', 'Pamar (Hombre)', '24.00', 'M', null);
INSERT INTO `direxame` VALUES ('506', 'Assa Nicotina', '9.00', 'M', null);
INSERT INTO `direxame` VALUES ('507', 'Generali PS4 (Coop.Médicos)', '48.00', 'M', null);
INSERT INTO `direxame` VALUES ('577', 'Generali (Hombre)', '28.00', 'M', null);
INSERT INTO `direxame` VALUES ('578', 'Generali (Mujer)', '36.00', 'M', null);
INSERT INTO `direxame` VALUES ('579', 'Mossak & Fonseca (Mujer)', '54.00', 'M', null);
INSERT INTO `direxame` VALUES ('580', 'Mossak & Fonseca (Hombre)', '46.00', 'M', null);
INSERT INTO `direxame` VALUES ('581', 'Procesa  (Hombre)', '22.00', 'M', null);
INSERT INTO `direxame` VALUES ('582', 'Procesa (Mujer)', '30.00', 'M', null);
INSERT INTO `direxame` VALUES ('583', 'Procesa (Sorpresivo)', '26.00', 'M', null);
INSERT INTO `direxame` VALUES ('586', 'Alta Cordillera (Hombre)', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('587', 'Alta Cordillera  (Mujer)', '17.00', 'M', null);
INSERT INTO `direxame` VALUES ('588', 'Mundial UL', '2.50', 'M', null);
INSERT INTO `direxame` VALUES ('589', 'Mundial HIV', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('590', 'Mundial PL', '57.50', 'M', null);
INSERT INTO `direxame` VALUES ('592', 'Mundial PSA (45 años)', '0.00', 'M', null);
INSERT INTO `direxame` VALUES ('629', 'IS Perfil Sanguíneo/PSA', '90.00', 'M', null);
INSERT INTO `direxame` VALUES ('627', 'IS Prueba B (HIV)', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('628', 'IS Perfil Sanguíneo', '78.00', 'M', null);
INSERT INTO `direxame` VALUES ('599', 'Telered (Hombre)', '14.00', 'M', null);
INSERT INTO `direxame` VALUES ('600', 'Telered (Mujer)', '22.00', 'M', null);
INSERT INTO `direxame` VALUES ('505', 'Assa PSA', '20.00', 'M', null);
INSERT INTO `direxame` VALUES ('602', 'Avianca', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('609', 'Hotel Ejecutivo (Ejecutivos)', '42.00', 'M', null);
INSERT INTO `direxame` VALUES ('610', 'Hotel Ejecutivo  (Mujer)', '49.00', 'M', null);
INSERT INTO `direxame` VALUES ('611', 'Hotel Ejecutivo (Hombre)', '43.00', 'M', null);
INSERT INTO `direxame` VALUES ('614', 'Profuturo (Mujer)', '37.00', 'M', null);
INSERT INTO `direxame` VALUES ('615', 'Profuturo (Hombre)', '29.00', 'M', null);
INSERT INTO `direxame` VALUES ('630', 'Capital (Vida Ind.)', '73.50', 'M', null);
INSERT INTO `direxame` VALUES ('631', 'Capital UL', '2.40', 'M', null);
INSERT INTO `direxame` VALUES ('618', 'Pamar Barcos (Dopping)', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('619', 'Pamar Barcos (Dopping/Alcohol)', '24.50', 'M', null);
INSERT INTO `direxame` VALUES ('620', 'Pamar Barcos (alcohol)', '12.50', 'M', null);
INSERT INTO `direxame` VALUES ('621', 'McDonald (Mujer )', '36.00', 'M', null);
INSERT INTO `direxame` VALUES ('622', 'McDonald (Hombre)', '29.00', 'M', null);
INSERT INTO `direxame` VALUES ('623', 'IS PSA', '15.00', 'M', null);
INSERT INTO `direxame` VALUES ('625', 'IS  (Mujer)', '30.00', 'M', null);
INSERT INTO `direxame` VALUES ('626', 'IS (Hombre)', '22.00', 'M', null);
INSERT INTO `direxame` VALUES ('035', 'Reticulocitos', '3.00', '1', '5');
INSERT INTO `direxame` VALUES ('635', 'Hielo Fiesta', '11.00', 'M', null);
INSERT INTO `direxame` VALUES ('637', 'Caja de Ahorros (Hombre)', '18.00', 'M', null);
INSERT INTO `direxame` VALUES ('639', 'Caja de Ahorros (Mujer)', '23.00', 'M', null);
INSERT INTO `direxame` VALUES ('640', 'Boyd Steamchip (Hombre)', '20.00', 'M', null);
INSERT INTO `direxame` VALUES ('641', 'Boyd Steamship (Mujer)', '27.00', 'M', null);
INSERT INTO `direxame` VALUES ('665', 'Cia. Nestlé', '21.00', 'M', null);
INSERT INTO `direxame` VALUES ('645', 'Xerox (Hombre)', '11.00', 'M', null);
INSERT INTO `direxame` VALUES ('646', 'Xerox (Mujer)', '18.00', 'M', null);
INSERT INTO `direxame` VALUES ('664', 'Seaboard (Hombre)', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('601', 'UPS', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('649', 'Ekono', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('650', 'Elmec', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('667', 'Alico Pefil III', '31.00', 'M', null);
INSERT INTO `direxame` VALUES ('648', 'Esco (Mujer)', '8.00', 'M', null);
INSERT INTO `direxame` VALUES ('654', 'Airbox Express Aerocasillas', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('655', 'Ambito 2000 (Komex)', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('563', 'Ancón (Hombre)', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('562', 'Ancón (Mujer)', '8.00', 'M', null);
INSERT INTO `direxame` VALUES ('647', 'Esco (Hombre)', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('659', 'IO Perfil Sanguíneo', '54.60', 'M', null);
INSERT INTO `direxame` VALUES ('660', 'IO Perfil Sanguíneo/PSA', '69.60', 'M', null);
INSERT INTO `direxame` VALUES ('662', 'Dr. Paz (Anti-Aging Hombre)', '464.00', 'M', null);
INSERT INTO `direxame` VALUES ('663', 'Seaboard (Mujer)', '6.00', 'M', null);
INSERT INTO `direxame` VALUES ('670', 'Alico Tol.Glucosa 2hpp.', '8.00', 'M', null);
INSERT INTO `direxame` VALUES ('686', 'IS (Extranjeros más de 46 años', '70.85', 'M', null);
INSERT INTO `direxame` VALUES ('685', 'IS (Pños más de 46 años)', '57.85', 'M', null);
INSERT INTO `direxame` VALUES ('684', 'IS (Extranjeros 18 a 45 años)', '61.10', 'M', null);
INSERT INTO `direxame` VALUES ('669', 'Alico Orina Especial', '31.00', 'M', null);
INSERT INTO `direxame` VALUES ('683', 'IS (Pños 40 a 45 años)', '48.10', 'M', null);
INSERT INTO `direxame` VALUES ('633', 'Capital  HIV', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('634', 'Capital Nicotina', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('501', 'Generali PS3 (Coop. Médicos)', '37.00', 'M', null);
INSERT INTO `direxame` VALUES ('329', 'Micoplasma Toma Directa', '30.00', '1', '6');
INSERT INTO `direxame` VALUES ('682', 'Fasa (Mujer)', '16.00', 'M', null);
INSERT INTO `direxame` VALUES ('681', 'Fasa (Hombre)', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('680', 'Bonlac (Mujer)', '8.00', 'M', null);
INSERT INTO `direxame` VALUES ('679', 'Bonlac (Hombre)', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('678', 'COACECSS (Mujer)', '22.50', 'M', null);
INSERT INTO `direxame` VALUES ('677', 'COACECSS (Hombre)', '15.00', 'M', null);
INSERT INTO `direxame` VALUES ('676', 'TNT (Dopping)', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('675', 'TNT (Colinesterasa)', '12.50', 'M', null);
INSERT INTO `direxame` VALUES ('517', 'Generali HbeAg', '0.00', 'M', null);
INSERT INTO `direxame` VALUES ('668', 'Alico BHC', '5.60', 'M', null);
INSERT INTO `direxame` VALUES ('516', 'Generali PSA (50 años)', '15.00', 'M', null);
INSERT INTO `direxame` VALUES ('613', 'Seguridad Técnica (Dopping)', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('658', 'IO Nicotina', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('657', 'IO HIV', '12.00', 'M', null);
INSERT INTO `direxame` VALUES ('656', 'IO UL', '2.40', 'M', null);
INSERT INTO `direxame` VALUES ('205', 'Electroforesis de Hemoglobina', '15.00', '1', '9');
INSERT INTO `direxame` VALUES ('257', 'PSA Libre', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('673', 'Alico Elec.de Hemoglobina', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('672', 'Alico UL', '3.00', 'M', null);
INSERT INTO `direxame` VALUES ('671', 'Alico Otros', '28.00', 'M', null);
INSERT INTO `direxame` VALUES ('116', 'HCG-Cuantitativa', '30.00', '1', '4');
INSERT INTO `direxame` VALUES ('063', 'Nitrógeno de Urea', '6.00', '1', '3');
INSERT INTO `direxame` VALUES ('105', 'Estradiol', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('688', 'COPA Grupo B (Mujer)', '39.00', 'M', null);
INSERT INTO `direxame` VALUES ('350', 'Glucosa', '5.00', null, '3');
INSERT INTO `direxame` VALUES ('206', 'Electroforesis de proteínas', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('204', 'Vitamina B12', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('207', 'Acido Fólico', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('192', 'Cortisol- PM', '20.00', '1', '4');
INSERT INTO `direxame` VALUES ('031', 'Hemograma Completo', '10.00', '1', '5');
INSERT INTO `direxame` VALUES ('295', 'Anti-Core (HBcAb)', '35.00', '1', '2');
INSERT INTO `direxame` VALUES ('296', 'HBeAb', '35.00', '1', '2');
INSERT INTO `direxame` VALUES ('297', 'HBeAg', '35.00', '1', '2');
INSERT INTO `direxame` VALUES ('298', 'HBsAb', '35.00', '1', '2');
INSERT INTO `direxame` VALUES ('299', 'Perfil de Hepatitis  B', '160.00', '1', '2');
INSERT INTO `direxame` VALUES ('300', 'Prueba Cruzada', '12.50', '1', '9');
INSERT INTO `direxame` VALUES ('301', 'MHATP', '25.00', '1', '2');
INSERT INTO `direxame` VALUES ('302', 'Clostridium Difficile Toxina A', '35.00', '1', '8');
INSERT INTO `direxame` VALUES ('303', 'Antígeno por Giardia', '38.00', '1', '2');
INSERT INTO `direxame` VALUES ('304', 'Helicobacter Pylori en Heces', '30.00', '1', '8');
INSERT INTO `direxame` VALUES ('306', '17OH Progesterona', '35.00', '1', '4');
INSERT INTO `direxame` VALUES ('527', 'CB Richard Ellis (Hombre)', '26.00', 'M', null);
INSERT INTO `direxame` VALUES ('308', 'Micoplasma IgG', '35.00', '1', '2');
INSERT INTO `direxame` VALUES ('309', 'MIcoplasma IgM', '35.00', '1', '2');
INSERT INTO `direxame` VALUES ('310', 'Acido Urico en Orina al Azar', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('311', 'Anfetaminas', '20.00', '1', '10');
INSERT INTO `direxame` VALUES ('312', 'Calcio en Orina al Azar', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('313', 'Creatinina en Orina al Azar', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('314', 'Fósforo en Orina al Azar', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('315', 'Opio', '20.00', '1', '10');
INSERT INTO `direxame` VALUES ('316', 'Morfina', '20.00', '1', '10');
INSERT INTO `direxame` VALUES ('317', 'PCP', '20.00', '1', '10');
INSERT INTO `direxame` VALUES ('318', 'Proteinuria al Azar', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('319', 'Sodio en Orina al Azar', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('320', 'Microalbuminuria', '25.00', '1', '4');
INSERT INTO `direxame` VALUES ('321', 'Nitrógeno Ureico (Orina 24hr)', '10.00', '1', '3');
INSERT INTO `direxame` VALUES ('612', 'Droguería Arrocha', '10.00', 'M', null);
INSERT INTO `direxame` VALUES ('323', 'Herpes I  IgG', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('324', 'Herpes I IgM', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('325', 'Herpes  II  IgG', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('326', 'Herpes II  IgM', '30.00', '1', '2');
INSERT INTO `direxame` VALUES ('327', 'EBV -VCA(IgM)', '20.00', '1', '2');
INSERT INTO `direxame` VALUES ('328', 'EBV -VCA( IgG)', '20.00', '1', '2');
INSERT INTO `doctores` VALUES ('0', null, 'NO SE HA ASIGNADO', ' ', ' ', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, '    NO SE HA ASIGNADO', null, null);
INSERT INTO `idiomas` VALUES ('ES', 'ESPAÑOL');
INSERT INTO `idiomas` VALUES ('IN', 'INGLES');
INSERT INTO `metaexas` VALUES ('282', '500', '057', '18.2');
INSERT INTO `metaexas` VALUES ('283', '500', '081', '3');
INSERT INTO `metaexas` VALUES ('284', '500', '076', '4');
INSERT INTO `metaexas` VALUES ('6', '299', '295', '35');
INSERT INTO `metaexas` VALUES ('7', '299', '296', '35');
INSERT INTO `metaexas` VALUES ('11', '299', '298', '35');
INSERT INTO `metaexas` VALUES ('10', '299', '297', '35');
INSERT INTO `metaexas` VALUES ('12', '299', '139', '20');
INSERT INTO `metaexas` VALUES ('310', '590', '031', '2.35');
INSERT INTO `metaexas` VALUES ('173', '590', '008', '0.95');
INSERT INTO `metaexas` VALUES ('15', '523', '232', '5.5');
INSERT INTO `metaexas` VALUES ('16', '523', '234', '5.5');
INSERT INTO `metaexas` VALUES ('17', '654', '232', '5');
INSERT INTO `metaexas` VALUES ('18', '654', '234', '5');
INSERT INTO `metaexas` VALUES ('19', '602', '232', '5');
INSERT INTO `metaexas` VALUES ('20', '602', '234', '5');
INSERT INTO `metaexas` VALUES ('21', '551', '186', '12');
INSERT INTO `metaexas` VALUES ('22', '551', '232', '6');
INSERT INTO `metaexas` VALUES ('23', '551', '234', '6');
INSERT INTO `metaexas` VALUES ('24', '550', '186', '12');
INSERT INTO `metaexas` VALUES ('25', '550', '232', '6');
INSERT INTO `metaexas` VALUES ('26', '550', '234', '6');
INSERT INTO `metaexas` VALUES ('27', '550', '118', '8');
INSERT INTO `metaexas` VALUES ('28', '525', '186', '12');
INSERT INTO `metaexas` VALUES ('29', '525', '127', '3.5');
INSERT INTO `metaexas` VALUES ('306', '525', '031', '7');
INSERT INTO `metaexas` VALUES ('31', '525', '008', '2');
INSERT INTO `metaexas` VALUES ('32', '525', '232', '6');
INSERT INTO `metaexas` VALUES ('33', '526', '186', '12');
INSERT INTO `metaexas` VALUES ('34', '526', '127', '3.5');
INSERT INTO `metaexas` VALUES ('307', '526', '031', '7');
INSERT INTO `metaexas` VALUES ('36', '526', '008', '2');
INSERT INTO `metaexas` VALUES ('37', '526', '232', '6');
INSERT INTO `metaexas` VALUES ('38', '526', '118', '5');
INSERT INTO `metaexas` VALUES ('39', '640', '186', '8');
INSERT INTO `metaexas` VALUES ('40', '640', '047', '2');
INSERT INTO `metaexas` VALUES ('41', '640', '232', '5');
INSERT INTO `metaexas` VALUES ('42', '640', '234', '5');
INSERT INTO `metaexas` VALUES ('43', '641', '186', '8');
INSERT INTO `metaexas` VALUES ('44', '641', '047', '2');
INSERT INTO `metaexas` VALUES ('45', '641', '234', '5');
INSERT INTO `metaexas` VALUES ('46', '641', '232', '5');
INSERT INTO `metaexas` VALUES ('47', '641', '118', '7');
INSERT INTO `metaexas` VALUES ('48', '586', '232', '5');
INSERT INTO `metaexas` VALUES ('49', '586', '234', '5');
INSERT INTO `metaexas` VALUES ('50', '587', '232', '5');
INSERT INTO `metaexas` VALUES ('51', '587', '234', '5');
INSERT INTO `metaexas` VALUES ('52', '587', '118', '7');
INSERT INTO `metaexas` VALUES ('53', '637', '031', '3');
INSERT INTO `metaexas` VALUES ('54', '637', '127', '2');
INSERT INTO `metaexas` VALUES ('55', '637', '047', '2');
INSERT INTO `metaexas` VALUES ('56', '637', '008', '1');
INSERT INTO `metaexas` VALUES ('57', '637', '232', '5');
INSERT INTO `metaexas` VALUES ('58', '637', '234', '5');
INSERT INTO `metaexas` VALUES ('59', '639', '031', '3');
INSERT INTO `metaexas` VALUES ('60', '639', '127', '2');
INSERT INTO `metaexas` VALUES ('61', '639', '047', '2');
INSERT INTO `metaexas` VALUES ('62', '639', '008', '1');
INSERT INTO `metaexas` VALUES ('63', '639', '232', '5');
INSERT INTO `metaexas` VALUES ('64', '639', '234', '5');
INSERT INTO `metaexas` VALUES ('65', '639', '118', '5');
INSERT INTO `metaexas` VALUES ('66', '518', '232', '6');
INSERT INTO `metaexas` VALUES ('67', '518', '234', '6');
INSERT INTO `metaexas` VALUES ('68', '544', '008', '2');
INSERT INTO `metaexas` VALUES ('69', '544', '127', '3');
INSERT INTO `metaexas` VALUES ('70', '544', '186', '12');
INSERT INTO `metaexas` VALUES ('71', '544', '232', '8');
INSERT INTO `metaexas` VALUES ('72', '544', '234', '8');
INSERT INTO `metaexas` VALUES ('73', '545', '008', '2');
INSERT INTO `metaexas` VALUES ('74', '545', '118', '6');
INSERT INTO `metaexas` VALUES ('75', '545', '127', '3');
INSERT INTO `metaexas` VALUES ('76', '545', '186', '12');
INSERT INTO `metaexas` VALUES ('77', '545', '232', '8');
INSERT INTO `metaexas` VALUES ('78', '545', '234', '8');
INSERT INTO `metaexas` VALUES ('79', '521', '186', '12');
INSERT INTO `metaexas` VALUES ('80', '521', '232', '6');
INSERT INTO `metaexas` VALUES ('81', '521', '234', '6');
INSERT INTO `metaexas` VALUES ('82', '524', '164', '11.5');
INSERT INTO `metaexas` VALUES ('83', '520', '118', '8');
INSERT INTO `metaexas` VALUES ('84', '520', '186', '10');
INSERT INTO `metaexas` VALUES ('85', '520', '232', '6');
INSERT INTO `metaexas` VALUES ('86', '520', '234', '6');
INSERT INTO `metaexas` VALUES ('87', '534', '186', '10');
INSERT INTO `metaexas` VALUES ('88', '534', '232', '6');
INSERT INTO `metaexas` VALUES ('89', '534', '234', '6');
INSERT INTO `metaexas` VALUES ('90', '635', '232', '5.5');
INSERT INTO `metaexas` VALUES ('91', '635', '234', '5.5');
INSERT INTO `metaexas` VALUES ('92', '625', '186', '10');
INSERT INTO `metaexas` VALUES ('93', '625', '118', '8');
INSERT INTO `metaexas` VALUES ('94', '625', '232', '6');
INSERT INTO `metaexas` VALUES ('95', '625', '234', '6');
INSERT INTO `metaexas` VALUES ('96', '626', '186', '10');
INSERT INTO `metaexas` VALUES ('97', '626', '232', '6');
INSERT INTO `metaexas` VALUES ('98', '626', '234', '6');
INSERT INTO `metaexas` VALUES ('99', '619', '249', '12.5');
INSERT INTO `metaexas` VALUES ('100', '619', '232', '6');
INSERT INTO `metaexas` VALUES ('101', '619', '234', '6');
INSERT INTO `metaexas` VALUES ('384', '662', '112', '16');
INSERT INTO `metaexas` VALUES ('385', '662', '282', '52');
INSERT INTO `metaexas` VALUES ('104', '663', '118', '6');
INSERT INTO `metaexas` VALUES ('105', '547', '118', '8');
INSERT INTO `metaexas` VALUES ('313', '621', '031', '9');
INSERT INTO `metaexas` VALUES ('107', '621', '118', '9');
INSERT INTO `metaexas` VALUES ('108', '621', '232', '9');
INSERT INTO `metaexas` VALUES ('109', '621', '234', '9');
INSERT INTO `metaexas` VALUES ('314', '622', '031', '9');
INSERT INTO `metaexas` VALUES ('111', '622', '232', '10');
INSERT INTO `metaexas` VALUES ('112', '622', '234', '10');
INSERT INTO `metaexas` VALUES ('113', '645', '232', '5.5');
INSERT INTO `metaexas` VALUES ('114', '645', '234', '5.5');
INSERT INTO `metaexas` VALUES ('115', '646', '118', '7');
INSERT INTO `metaexas` VALUES ('116', '646', '232', '5.5');
INSERT INTO `metaexas` VALUES ('117', '646', '234', '5.5');
INSERT INTO `metaexas` VALUES ('118', '615', '047', '3');
INSERT INTO `metaexas` VALUES ('119', '615', '186', '10');
INSERT INTO `metaexas` VALUES ('120', '615', '232', '8');
INSERT INTO `metaexas` VALUES ('121', '615', '234', '8');
INSERT INTO `metaexas` VALUES ('122', '614', '047', '3');
INSERT INTO `metaexas` VALUES ('123', '614', '186', '10');
INSERT INTO `metaexas` VALUES ('124', '614', '232', '8');
INSERT INTO `metaexas` VALUES ('125', '614', '234', '8');
INSERT INTO `metaexas` VALUES ('126', '614', '118', '8');
INSERT INTO `metaexas` VALUES ('127', '588', '008', '2.5');
INSERT INTO `metaexas` VALUES ('128', '589', '186', '10');
INSERT INTO `metaexas` VALUES ('349', '592', '226', '0');
INSERT INTO `metaexas` VALUES ('130', '594', '008', '2.5');
INSERT INTO `metaexas` VALUES ('131', '623', '226', '15');
INSERT INTO `metaexas` VALUES ('132', '620', '249', '12.5');
INSERT INTO `metaexas` VALUES ('133', '655', '232', '6');
INSERT INTO `metaexas` VALUES ('134', '655', '234', '6');
INSERT INTO `metaexas` VALUES ('135', '583', '232', '5');
INSERT INTO `metaexas` VALUES ('136', '583', '234', '5');
INSERT INTO `metaexas` VALUES ('137', '599', '232', '7');
INSERT INTO `metaexas` VALUES ('138', '599', '234', '7');
INSERT INTO `metaexas` VALUES ('139', '600', '232', '7');
INSERT INTO `metaexas` VALUES ('140', '600', '234', '7');
INSERT INTO `metaexas` VALUES ('141', '600', '118', '8');
INSERT INTO `metaexas` VALUES ('142', '580', '008', '2');
INSERT INTO `metaexas` VALUES ('309', '580', '031', '7.5');
INSERT INTO `metaexas` VALUES ('144', '580', '080', '6');
INSERT INTO `metaexas` VALUES ('145', '580', '127', '3.75');
INSERT INTO `metaexas` VALUES ('146', '580', '186', '11.75');
INSERT INTO `metaexas` VALUES ('147', '580', '232', '7.5');
INSERT INTO `metaexas` VALUES ('148', '580', '234', '7.5');
INSERT INTO `metaexas` VALUES ('149', '579', '008', '2');
INSERT INTO `metaexas` VALUES ('308', '579', '031', '7.5');
INSERT INTO `metaexas` VALUES ('151', '579', '080', '6');
INSERT INTO `metaexas` VALUES ('152', '579', '127', '3.75');
INSERT INTO `metaexas` VALUES ('153', '579', '186', '11.75');
INSERT INTO `metaexas` VALUES ('154', '579', '232', '7.5');
INSERT INTO `metaexas` VALUES ('155', '579', '234', '7.5');
INSERT INTO `metaexas` VALUES ('156', '579', '118', '8');
INSERT INTO `metaexas` VALUES ('305', '511', '031', '7');
INSERT INTO `metaexas` VALUES ('158', '511', '039', '2.8');
INSERT INTO `metaexas` VALUES ('159', '511', '052', '4.2');
INSERT INTO `metaexas` VALUES ('160', '511', '225', '23.55');
INSERT INTO `metaexas` VALUES ('161', '511', '065', '4.2');
INSERT INTO `metaexas` VALUES ('162', '511', '079', '5.25');
INSERT INTO `metaexas` VALUES ('163', '511', '078', '5.25');
INSERT INTO `metaexas` VALUES ('164', '511', '080', '5.6');
INSERT INTO `metaexas` VALUES ('165', '511', '066', '4.2');
INSERT INTO `metaexas` VALUES ('166', '511', '076', '7');
INSERT INTO `metaexas` VALUES ('167', '510', '186', '10');
INSERT INTO `metaexas` VALUES ('168', '506', '251', '9');
INSERT INTO `metaexas` VALUES ('169', '509', '008', '2.38');
INSERT INTO `metaexas` VALUES ('170', '505', '226', '20');
INSERT INTO `metaexas` VALUES ('171', '504', '251', '10');
INSERT INTO `metaexas` VALUES ('522', '507', '031', '6.2');
INSERT INTO `metaexas` VALUES ('175', '590', '039', '0.95');
INSERT INTO `metaexas` VALUES ('176', '590', '052', '1.41');
INSERT INTO `metaexas` VALUES ('177', '590', '065', '1.41');
INSERT INTO `metaexas` VALUES ('178', '590', '066', '1.41');
INSERT INTO `metaexas` VALUES ('179', '590', '076', '2.35');
INSERT INTO `metaexas` VALUES ('180', '590', '078', '1.76');
INSERT INTO `metaexas` VALUES ('181', '590', '079', '1.76');
INSERT INTO `metaexas` VALUES ('182', '590', '080', '1.88');
INSERT INTO `metaexas` VALUES ('183', '590', '081', '1.76');
INSERT INTO `metaexas` VALUES ('184', '590', '083', '5.88');
INSERT INTO `metaexas` VALUES ('185', '590', '084', '8.23');
INSERT INTO `metaexas` VALUES ('186', '590', '087', '2.35');
INSERT INTO `metaexas` VALUES ('187', '590', '186', '3.53');
INSERT INTO `metaexas` VALUES ('188', '590', '225', '6.58');
INSERT INTO `metaexas` VALUES ('189', '590', '232', '2.35');
INSERT INTO `metaexas` VALUES ('190', '590', '234', '2.35');
INSERT INTO `metaexas` VALUES ('191', '590', '251', '3.54');
INSERT INTO `metaexas` VALUES ('192', '590', '311', '4.7');
INSERT INTO `metaexas` VALUES ('351', '528', '186', '10');
INSERT INTO `metaexas` VALUES ('194', '660', '052', '3.52');
INSERT INTO `metaexas` VALUES ('195', '660', '065', '3.52');
INSERT INTO `metaexas` VALUES ('196', '660', '066', '3.52');
INSERT INTO `metaexas` VALUES ('197', '660', '076', '5.87');
INSERT INTO `metaexas` VALUES ('198', '660', '078', '4.4');
INSERT INTO `metaexas` VALUES ('199', '660', '080', '4.4');
INSERT INTO `metaexas` VALUES ('200', '660', '079', '4.7');
INSERT INTO `metaexas` VALUES ('201', '660', '225', '16.45');
INSERT INTO `metaexas` VALUES ('316', '660', '031', '5.87');
INSERT INTO `metaexas` VALUES ('203', '660', '226', '15');
INSERT INTO `metaexas` VALUES ('204', '660', '039', '2.35');
INSERT INTO `metaexas` VALUES ('205', '659', '052', '3.52');
INSERT INTO `metaexas` VALUES ('206', '659', '065', '3.52');
INSERT INTO `metaexas` VALUES ('207', '659', '066', '3.52');
INSERT INTO `metaexas` VALUES ('208', '659', '076', '5.87');
INSERT INTO `metaexas` VALUES ('209', '659', '078', '4.4');
INSERT INTO `metaexas` VALUES ('210', '659', '080', '4.4');
INSERT INTO `metaexas` VALUES ('211', '659', '079', '4.7');
INSERT INTO `metaexas` VALUES ('212', '659', '225', '16.45');
INSERT INTO `metaexas` VALUES ('315', '659', '031', '5.87');
INSERT INTO `metaexas` VALUES ('214', '659', '039', '2.35');
INSERT INTO `metaexas` VALUES ('220', '647', '232', '6');
INSERT INTO `metaexas` VALUES ('219', '648', '118', '8');
INSERT INTO `metaexas` VALUES ('217', '649', '232', '5');
INSERT INTO `metaexas` VALUES ('218', '649', '234', '5');
INSERT INTO `metaexas` VALUES ('221', '647', '234', '6');
INSERT INTO `metaexas` VALUES ('222', '522', '118', '5');
INSERT INTO `metaexas` VALUES ('223', '522', '232', '6');
INSERT INTO `metaexas` VALUES ('224', '522', '234', '6');
INSERT INTO `metaexas` VALUES ('225', '522', '186', '12');
INSERT INTO `metaexas` VALUES ('226', '562', '118', '8');
INSERT INTO `metaexas` VALUES ('227', '563', '232', '6');
INSERT INTO `metaexas` VALUES ('228', '563', '234', '6');
INSERT INTO `metaexas` VALUES ('229', '569', '118', '8');
INSERT INTO `metaexas` VALUES ('230', '569', '127', '3');
INSERT INTO `metaexas` VALUES ('231', '569', '186', '9');
INSERT INTO `metaexas` VALUES ('232', '569', '232', '6');
INSERT INTO `metaexas` VALUES ('233', '569', '234', '6');
INSERT INTO `metaexas` VALUES ('234', '570', '127', '3');
INSERT INTO `metaexas` VALUES ('235', '570', '186', '9');
INSERT INTO `metaexas` VALUES ('236', '570', '232', '6');
INSERT INTO `metaexas` VALUES ('237', '570', '234', '6');
INSERT INTO `metaexas` VALUES ('238', '601', '232', '5');
INSERT INTO `metaexas` VALUES ('239', '601', '234', '5');
INSERT INTO `metaexas` VALUES ('412', '628', '225', '15.4');
INSERT INTO `metaexas` VALUES ('411', '628', '052', '3.3');
INSERT INTO `metaexas` VALUES ('410', '628', '031', '5.5');
INSERT INTO `metaexas` VALUES ('243', '664', '232', '5');
INSERT INTO `metaexas` VALUES ('244', '664', '234', '5');
INSERT INTO `metaexas` VALUES ('245', '581', '232', '5');
INSERT INTO `metaexas` VALUES ('246', '581', '234', '5');
INSERT INTO `metaexas` VALUES ('247', '581', '311', '10');
INSERT INTO `metaexas` VALUES ('248', '581', '127', '2');
INSERT INTO `metaexas` VALUES ('249', '582', '232', '5');
INSERT INTO `metaexas` VALUES ('250', '582', '234', '5');
INSERT INTO `metaexas` VALUES ('251', '582', '311', '10');
INSERT INTO `metaexas` VALUES ('252', '582', '127', '2');
INSERT INTO `metaexas` VALUES ('253', '582', '118', '8');
INSERT INTO `metaexas` VALUES ('254', '571', '232', '5');
INSERT INTO `metaexas` VALUES ('255', '571', '234', '5');
INSERT INTO `metaexas` VALUES ('362', '583', '249', '6');
INSERT INTO `metaexas` VALUES ('361', '583', '311', '10');
INSERT INTO `metaexas` VALUES ('258', '527', '186', '10');
INSERT INTO `metaexas` VALUES ('259', '527', '232', '8');
INSERT INTO `metaexas` VALUES ('260', '527', '234', '8');
INSERT INTO `metaexas` VALUES ('262', '572', '186', '10');
INSERT INTO `metaexas` VALUES ('263', '572', '232', '8');
INSERT INTO `metaexas` VALUES ('264', '572', '234', '8');
INSERT INTO `metaexas` VALUES ('265', '572', '118', '8');
INSERT INTO `metaexas` VALUES ('266', '512', '031', '5.5');
INSERT INTO `metaexas` VALUES ('267', '512', '052', '3.15');
INSERT INTO `metaexas` VALUES ('268', '512', '225', '15.4');
INSERT INTO `metaexas` VALUES ('269', '512', '065', '3.3');
INSERT INTO `metaexas` VALUES ('270', '512', '130', '5');
INSERT INTO `metaexas` VALUES ('271', '512', '078', '4');
INSERT INTO `metaexas` VALUES ('272', '512', '079', '4');
INSERT INTO `metaexas` VALUES ('273', '512', '080', '4.4');
INSERT INTO `metaexas` VALUES ('274', '512', '139', '11');
INSERT INTO `metaexas` VALUES ('281', '512', '261', '19.25');
INSERT INTO `metaexas` VALUES ('276', '513', '008', '3');
INSERT INTO `metaexas` VALUES ('277', '514', '186', '10');
INSERT INTO `metaexas` VALUES ('278', '515', '251', '9');
INSERT INTO `metaexas` VALUES ('279', '516', '226', '15');
INSERT INTO `metaexas` VALUES ('280', '517', '297', '0');
INSERT INTO `metaexas` VALUES ('285', '500', '066', '2.4');
INSERT INTO `metaexas` VALUES ('286', '500', '064', '2.4');
INSERT INTO `metaexas` VALUES ('287', '501', '031', '6.2');
INSERT INTO `metaexas` VALUES ('288', '501', '052', '4');
INSERT INTO `metaexas` VALUES ('289', '501', '225', '17.5');
INSERT INTO `metaexas` VALUES ('290', '501', '186', '9.3');
INSERT INTO `metaexas` VALUES ('291', '502', '031', '6');
INSERT INTO `metaexas` VALUES ('292', '502', '052', '3.6');
INSERT INTO `metaexas` VALUES ('293', '502', '225', '16.8');
INSERT INTO `metaexas` VALUES ('294', '502', '186', '9');
INSERT INTO `metaexas` VALUES ('295', '502', '065', '3.6');
INSERT INTO `metaexas` VALUES ('296', '502', '078', '4.5');
INSERT INTO `metaexas` VALUES ('297', '502', '079', '4.5');
INSERT INTO `metaexas` VALUES ('298', '577', '186', '12');
INSERT INTO `metaexas` VALUES ('299', '577', '232', '8');
INSERT INTO `metaexas` VALUES ('300', '577', '234', '8');
INSERT INTO `metaexas` VALUES ('301', '578', '186', '12');
INSERT INTO `metaexas` VALUES ('302', '578', '232', '8');
INSERT INTO `metaexas` VALUES ('303', '578', '234', '8');
INSERT INTO `metaexas` VALUES ('304', '578', '118', '8');
INSERT INTO `metaexas` VALUES ('311', '618', '232', '6');
INSERT INTO `metaexas` VALUES ('312', '618', '234', '6');
INSERT INTO `metaexas` VALUES ('318', '553', '226', '18.75');
INSERT INTO `metaexas` VALUES ('319', '564', '008', '2.7');
INSERT INTO `metaexas` VALUES ('320', '564', '031', '6.7');
INSERT INTO `metaexas` VALUES ('321', '564', '052', '4');
INSERT INTO `metaexas` VALUES ('322', '564', '063', '4');
INSERT INTO `metaexas` VALUES ('323', '564', '127', '3.35');
INSERT INTO `metaexas` VALUES ('324', '564', '225', '18.85');
INSERT INTO `metaexas` VALUES ('325', '564', '232', '6.7');
INSERT INTO `metaexas` VALUES ('326', '564', '234', '6.7');
INSERT INTO `metaexas` VALUES ('327', '565', '008', '2.7');
INSERT INTO `metaexas` VALUES ('328', '565', '031', '6.7');
INSERT INTO `metaexas` VALUES ('329', '565', '052', '4');
INSERT INTO `metaexas` VALUES ('330', '565', '063', '4');
INSERT INTO `metaexas` VALUES ('331', '565', '127', '3.35');
INSERT INTO `metaexas` VALUES ('332', '565', '225', '18.85');
INSERT INTO `metaexas` VALUES ('333', '565', '118', '10');
INSERT INTO `metaexas` VALUES ('334', '565', '232', '6.7');
INSERT INTO `metaexas` VALUES ('335', '565', '234', '6.7');
INSERT INTO `metaexas` VALUES ('336', '566', '008', '2.7');
INSERT INTO `metaexas` VALUES ('337', '566', '031', '6.7');
INSERT INTO `metaexas` VALUES ('338', '566', '052', '4');
INSERT INTO `metaexas` VALUES ('339', '566', '063', '4');
INSERT INTO `metaexas` VALUES ('340', '566', '127', '3.35');
INSERT INTO `metaexas` VALUES ('341', '566', '225', '18.85');
INSERT INTO `metaexas` VALUES ('342', '566', '232', '6.7');
INSERT INTO `metaexas` VALUES ('343', '566', '234', '6.7');
INSERT INTO `metaexas` VALUES ('344', '566', '226', '20');
INSERT INTO `metaexas` VALUES ('345', '567', '232', '5');
INSERT INTO `metaexas` VALUES ('346', '567', '234', '5');
INSERT INTO `metaexas` VALUES ('347', '568', '118', '8');
INSERT INTO `metaexas` VALUES ('348', '591', '251', '10');
INSERT INTO `metaexas` VALUES ('350', '519', '118', '8');
INSERT INTO `metaexas` VALUES ('352', '528', '232', '8');
INSERT INTO `metaexas` VALUES ('353', '528', '234', '8');
INSERT INTO `metaexas` VALUES ('354', '528', '118', '8');
INSERT INTO `metaexas` VALUES ('355', '624', '008', '2.5');
INSERT INTO `metaexas` VALUES ('356', '627', '186', '10');
INSERT INTO `metaexas` VALUES ('357', '535', '118', '8');
INSERT INTO `metaexas` VALUES ('358', '535', '186', '10');
INSERT INTO `metaexas` VALUES ('359', '535', '232', '6');
INSERT INTO `metaexas` VALUES ('360', '535', '234', '6');
INSERT INTO `metaexas` VALUES ('363', '661', '225', '22.4');
INSERT INTO `metaexas` VALUES ('364', '661', '195', '20');
INSERT INTO `metaexas` VALUES ('365', '661', '194', '16');
INSERT INTO `metaexas` VALUES ('366', '661', '109', '16');
INSERT INTO `metaexas` VALUES ('367', '661', '110', '16');
INSERT INTO `metaexas` VALUES ('368', '661', '105', '16');
INSERT INTO `metaexas` VALUES ('369', '661', '111', '16');
INSERT INTO `metaexas` VALUES ('370', '661', '151', '12');
INSERT INTO `metaexas` VALUES ('371', '661', '283', '20');
INSERT INTO `metaexas` VALUES ('372', '661', '152', '12');
INSERT INTO `metaexas` VALUES ('373', '661', '235', '16');
INSERT INTO `metaexas` VALUES ('374', '661', '280', '72');
INSERT INTO `metaexas` VALUES ('375', '661', '114', '20');
INSERT INTO `metaexas` VALUES ('376', '661', '052', '4.8');
INSERT INTO `metaexas` VALUES ('377', '661', '267', '36');
INSERT INTO `metaexas` VALUES ('378', '661', '265', '48');
INSERT INTO `metaexas` VALUES ('379', '661', '288', '40');
INSERT INTO `metaexas` VALUES ('380', '661', '078', '6');
INSERT INTO `metaexas` VALUES ('381', '661', '079', '6');
INSERT INTO `metaexas` VALUES ('382', '661', '031', '8');
INSERT INTO `metaexas` VALUES ('383', '661', '065', '4.8');
INSERT INTO `metaexas` VALUES ('386', '662', '194', '16');
INSERT INTO `metaexas` VALUES ('387', '662', '105', '16');
INSERT INTO `metaexas` VALUES ('388', '662', '110', '16');
INSERT INTO `metaexas` VALUES ('389', '662', '151', '12');
INSERT INTO `metaexas` VALUES ('390', '662', '283', '20');
INSERT INTO `metaexas` VALUES ('391', '662', '152', '12');
INSERT INTO `metaexas` VALUES ('392', '662', '235', '16');
INSERT INTO `metaexas` VALUES ('393', '662', '280', '72');
INSERT INTO `metaexas` VALUES ('394', '662', '114', '20');
INSERT INTO `metaexas` VALUES ('395', '662', '052', '4.8');
INSERT INTO `metaexas` VALUES ('396', '662', '267', '36');
INSERT INTO `metaexas` VALUES ('397', '662', '265', '48');
INSERT INTO `metaexas` VALUES ('398', '662', '226', '20');
INSERT INTO `metaexas` VALUES ('399', '662', '288', '40');
INSERT INTO `metaexas` VALUES ('400', '662', '225', '22.4');
INSERT INTO `metaexas` VALUES ('401', '662', '978', '6');
INSERT INTO `metaexas` VALUES ('402', '662', '079', '6');
INSERT INTO `metaexas` VALUES ('403', '662', '031', '8');
INSERT INTO `metaexas` VALUES ('404', '662', '065', '4.8');
INSERT INTO `metaexas` VALUES ('405', '665', '031', '5');
INSERT INTO `metaexas` VALUES ('406', '665', '052', '3.5');
INSERT INTO `metaexas` VALUES ('407', '665', '008', '2.5');
INSERT INTO `metaexas` VALUES ('408', '665', '232', '5');
INSERT INTO `metaexas` VALUES ('409', '665', '234', '5');
INSERT INTO `metaexas` VALUES ('413', '628', '065', '3.3');
INSERT INTO `metaexas` VALUES ('414', '628', '066', '3.3');
INSERT INTO `metaexas` VALUES ('415', '628', '069', '3.85');
INSERT INTO `metaexas` VALUES ('416', '628', '070', '3.85');
INSERT INTO `metaexas` VALUES ('417', '628', '076', '5.5');
INSERT INTO `metaexas` VALUES ('418', '628', '078', '4.18');
INSERT INTO `metaexas` VALUES ('419', '628', '079', '4.18');
INSERT INTO `metaexas` VALUES ('420', '628', '080', '4.4');
INSERT INTO `metaexas` VALUES ('421', '628', '081', '4.18');
INSERT INTO `metaexas` VALUES ('422', '628', '085', '5.5');
INSERT INTO `metaexas` VALUES ('423', '628', '186', '8.26');
INSERT INTO `metaexas` VALUES ('424', '628', '063', '3.3');
INSERT INTO `metaexas` VALUES ('425', '629', '031', '5.5');
INSERT INTO `metaexas` VALUES ('426', '629', '052', '3.3');
INSERT INTO `metaexas` VALUES ('427', '629', '225', '15.4');
INSERT INTO `metaexas` VALUES ('428', '629', '065', '3.3');
INSERT INTO `metaexas` VALUES ('429', '629', '066', '3.3');
INSERT INTO `metaexas` VALUES ('430', '629', '069', '3.85');
INSERT INTO `metaexas` VALUES ('431', '629', '070', '3.85');
INSERT INTO `metaexas` VALUES ('432', '629', '076', '5.5');
INSERT INTO `metaexas` VALUES ('433', '629', '078', '4.18');
INSERT INTO `metaexas` VALUES ('434', '629', '079', '4.18');
INSERT INTO `metaexas` VALUES ('435', '629', '080', '4.4');
INSERT INTO `metaexas` VALUES ('436', '629', '081', '4.18');
INSERT INTO `metaexas` VALUES ('437', '629', '085', '5.5');
INSERT INTO `metaexas` VALUES ('438', '629', '186', '8.26');
INSERT INTO `metaexas` VALUES ('439', '629', '063', '3.3');
INSERT INTO `metaexas` VALUES ('440', '629', '226', '12');
INSERT INTO `metaexas` VALUES ('441', '630', '052', '5');
INSERT INTO `metaexas` VALUES ('442', '630', '225', '23.8');
INSERT INTO `metaexas` VALUES ('443', '630', '063', '5');
INSERT INTO `metaexas` VALUES ('444', '630', '065', '5');
INSERT INTO `metaexas` VALUES ('445', '630', '078', '6.35');
INSERT INTO `metaexas` VALUES ('446', '630', '079', '6.35');
INSERT INTO `metaexas` VALUES ('447', '630', '080', '7.65');
INSERT INTO `metaexas` VALUES ('448', '630', '076', '8');
INSERT INTO `metaexas` VALUES ('449', '630', '081', '6.35');
INSERT INTO `metaexas` VALUES ('450', '631', '008', '2.4');
INSERT INTO `metaexas` VALUES ('451', '632', '226', '20');
INSERT INTO `metaexas` VALUES ('452', '633', '186', '12');
INSERT INTO `metaexas` VALUES ('453', '634', '251', '12');
INSERT INTO `metaexas` VALUES ('454', '666', '052', '4.2');
INSERT INTO `metaexas` VALUES ('455', '666', '225', '19.6');
INSERT INTO `metaexas` VALUES ('456', '666', '066', '4.2');
INSERT INTO `metaexas` VALUES ('457', '666', '065', '4.2');
INSERT INTO `metaexas` VALUES ('458', '666', '063', '4.2');
INSERT INTO `metaexas` VALUES ('459', '666', '078', '5.25');
INSERT INTO `metaexas` VALUES ('460', '666', '079', '5.25');
INSERT INTO `metaexas` VALUES ('461', '666', '080', '5.6');
INSERT INTO `metaexas` VALUES ('462', '666', '076', '7');
INSERT INTO `metaexas` VALUES ('463', '666', '067', '9.2');
INSERT INTO `metaexas` VALUES ('464', '666', '186', '10.5');
INSERT INTO `metaexas` VALUES ('465', '666', '008', '2.8');
INSERT INTO `metaexas` VALUES ('466', '667', '080', '5.6');
INSERT INTO `metaexas` VALUES ('467', '667', '057', '14.9');
INSERT INTO `metaexas` VALUES ('468', '667', '186', '10.5');
INSERT INTO `metaexas` VALUES ('469', '668', '031', '5.6');
INSERT INTO `metaexas` VALUES ('470', '669', '008', '3');
INSERT INTO `metaexas` VALUES ('471', '669', '232', '8');
INSERT INTO `metaexas` VALUES ('472', '669', '234', '8');
INSERT INTO `metaexas` VALUES ('473', '669', '251', '12');
INSERT INTO `metaexas` VALUES ('474', '670', '052', '4');
INSERT INTO `metaexas` VALUES ('475', '670', '056', '4');
INSERT INTO `metaexas` VALUES ('476', '671', '080', '6.7');
INSERT INTO `metaexas` VALUES ('477', '671', '076', '8.7');
INSERT INTO `metaexas` VALUES ('478', '671', '078', '6.3');
INSERT INTO `metaexas` VALUES ('479', '671', '079', '6.3');
INSERT INTO `metaexas` VALUES ('480', '672', '008', '3');
INSERT INTO `metaexas` VALUES ('481', '673', '205', '10');
INSERT INTO `metaexas` VALUES ('496', '651', '232', '6');
INSERT INTO `metaexas` VALUES ('497', '651', '234', '6');
INSERT INTO `metaexas` VALUES ('498', '656', '008', '2.4');
INSERT INTO `metaexas` VALUES ('499', '657', '186', '12');
INSERT INTO `metaexas` VALUES ('500', '658', '251', '12');
INSERT INTO `metaexas` VALUES ('501', '612', '232', '5');
INSERT INTO `metaexas` VALUES ('502', '612', '234', '5');
INSERT INTO `metaexas` VALUES ('503', '613', '232', '5');
INSERT INTO `metaexas` VALUES ('504', '613', '234', '5');
INSERT INTO `metaexas` VALUES ('505', '675', '164', '12.5');
INSERT INTO `metaexas` VALUES ('506', '676', '232', '6');
INSERT INTO `metaexas` VALUES ('507', '676', '234', '6');
INSERT INTO `metaexas` VALUES ('508', '677', '232', '7.5');
INSERT INTO `metaexas` VALUES ('509', '677', '234', '7.5');
INSERT INTO `metaexas` VALUES ('510', '678', '232', '7.5');
INSERT INTO `metaexas` VALUES ('511', '678', '234', '7.5');
INSERT INTO `metaexas` VALUES ('512', '678', '118', '7.5');
INSERT INTO `metaexas` VALUES ('513', '679', '232', '6');
INSERT INTO `metaexas` VALUES ('514', '679', '234', '6');
INSERT INTO `metaexas` VALUES ('515', '680', '118', '8');
INSERT INTO `metaexas` VALUES ('516', '681', '232', '5');
INSERT INTO `metaexas` VALUES ('517', '681', '234', '5');
INSERT INTO `metaexas` VALUES ('518', '682', '232', '5');
INSERT INTO `metaexas` VALUES ('519', '682', '234', '5');
INSERT INTO `metaexas` VALUES ('520', '682', '118', '6');
INSERT INTO `metaexas` VALUES ('521', '529', '186', '10');
INSERT INTO `metaexas` VALUES ('523', '507', '052', '4');
INSERT INTO `metaexas` VALUES ('524', '507', '225', '17.5');
INSERT INTO `metaexas` VALUES ('525', '507', '186', '9.3');
INSERT INTO `metaexas` VALUES ('526', '507', '078', '3.65');
INSERT INTO `metaexas` VALUES ('527', '507', '079', '3.65');
INSERT INTO `metaexas` VALUES ('528', '507', '065', '3.7');
INSERT INTO `metaexas` VALUES ('529', '683', '031', '6.5');
INSERT INTO `metaexas` VALUES ('530', '683', '052', '3.9');
INSERT INTO `metaexas` VALUES ('531', '683', '008', '2.6');
INSERT INTO `metaexas` VALUES ('532', '683', '225', '18.2');
INSERT INTO `metaexas` VALUES ('533', '683', '226', '16.9');
INSERT INTO `metaexas` VALUES ('534', '684', '031', '6.5');
INSERT INTO `metaexas` VALUES ('535', '684', '052', '3.9');
INSERT INTO `metaexas` VALUES ('536', '684', '008', '2.6');
INSERT INTO `metaexas` VALUES ('537', '684', '225', '18.2');
INSERT INTO `metaexas` VALUES ('538', '684', '226', '16.9');
INSERT INTO `metaexas` VALUES ('539', '684', '186', '13');
INSERT INTO `metaexas` VALUES ('540', '685', '031', '7.3');
INSERT INTO `metaexas` VALUES ('541', '685', '008', '3.1');
INSERT INTO `metaexas` VALUES ('542', '685', '225', '20.44');
INSERT INTO `metaexas` VALUES ('543', '685', '052', '4.38');
INSERT INTO `metaexas` VALUES ('544', '685', '056', '4.38');
INSERT INTO `metaexas` VALUES ('545', '685', '226', '18.25');
INSERT INTO `metaexas` VALUES ('546', '686', '031', '7.3');
INSERT INTO `metaexas` VALUES ('547', '686', '008', '3.1');
INSERT INTO `metaexas` VALUES ('548', '686', '225', '20.44');
INSERT INTO `metaexas` VALUES ('549', '686', '052', '4.38');
INSERT INTO `metaexas` VALUES ('550', '686', '056', '4.38');
INSERT INTO `metaexas` VALUES ('551', '686', '226', '18.25');
INSERT INTO `metaexas` VALUES ('552', '686', '186', '13');
INSERT INTO `metaexas` VALUES ('553', '548', '232', '5');
INSERT INTO `metaexas` VALUES ('554', '548', '234', '5');
INSERT INTO `metaexas` VALUES ('555', '609', '008', '2.4');
INSERT INTO `metaexas` VALUES ('556', '609', '031', '6');
INSERT INTO `metaexas` VALUES ('557', '609', '052', '3.6');
INSERT INTO `metaexas` VALUES ('558', '609', '066', '3.6');
INSERT INTO `metaexas` VALUES ('559', '609', '078', '4.5');
INSERT INTO `metaexas` VALUES ('560', '609', '079', '4.5');
INSERT INTO `metaexas` VALUES ('561', '609', '225', '17.4');
INSERT INTO `metaexas` VALUES ('562', '687', '232', '5');
INSERT INTO `metaexas` VALUES ('563', '687', '234', '5');
INSERT INTO `metaexas` VALUES ('564', '688', '030', '6');
INSERT INTO `metaexas` VALUES ('565', '688', '047', '1');
INSERT INTO `metaexas` VALUES ('566', '688', '008', '2');
INSERT INTO `metaexas` VALUES ('567', '688', '118', '6');
INSERT INTO `metaexas` VALUES ('568', '688', '232', '6');
INSERT INTO `metaexas` VALUES ('569', '688', '234', '6');
INSERT INTO `metaexas` VALUES ('570', '688', '692', '12');
INSERT INTO `metaexas` VALUES ('571', '689', '030', '6');
INSERT INTO `metaexas` VALUES ('572', '689', '047', '1');
INSERT INTO `metaexas` VALUES ('573', '689', '008', '2');
INSERT INTO `metaexas` VALUES ('574', '689', '232', '6');
INSERT INTO `metaexas` VALUES ('575', '689', '234', '6');
INSERT INTO `metaexas` VALUES ('576', '689', '692', '12');
INSERT INTO `metaexas` VALUES ('577', '690', '118', '6');
INSERT INTO `metaexas` VALUES ('578', '690', '232', '6');
INSERT INTO `metaexas` VALUES ('579', '690', '234', '6');
INSERT INTO `metaexas` VALUES ('580', '691', '047', '2');
INSERT INTO `metaexas` VALUES ('581', '691', '232', '5');
INSERT INTO `metaexas` VALUES ('582', '691', '234', '5');
INSERT INTO `metaexas` VALUES ('583', '651', '249', '12.5');
INSERT INTO `metaexas` VALUES ('584', '693', '232', '5');
INSERT INTO `metaexas` VALUES ('585', '693', '234', '5');
INSERT INTO `metaexas` VALUES ('586', '693', '118', '8');
INSERT INTO `metaexas` VALUES ('587', '694', '232', '5');
INSERT INTO `metaexas` VALUES ('588', '694', '234', '5');
INSERT INTO `metaexas` VALUES ('589', '692', '692', '12');
INSERT INTO `metaexas` VALUES ('590', '650', '232', '5');
INSERT INTO `metaexas` VALUES ('591', '650', '234', '5');
INSERT INTO `saludos` VALUES ('1', 'F', 'SRA');
INSERT INTO `saludos` VALUES ('2', 'F', 'SRTA');
INSERT INTO `saludos` VALUES ('3', 'F', 'NIÑA');
INSERT INTO `saludos` VALUES ('4', 'M', 'SR.');
INSERT INTO `saludos` VALUES ('5', 'M', 'NIÑO');
INSERT INTO `saludos` VALUES ('6', 'M', 'LIC.');
INSERT INTO `saludos` VALUES ('7', 'F', 'DRA.');
INSERT INTO `saludos` VALUES ('8', 'M', 'DR.');
INSERT INTO `sexos` VALUES ('F', 'Femenino');
INSERT INTO `sexos` VALUES ('M', 'Masculino');
INSERT INTO `tipopago` VALUES ('1', 'EFECTIVO');
INSERT INTO `tipopago` VALUES ('2', 'TARJETA');
INSERT INTO `tipopago` VALUES ('3', 'CHEQUE');
INSERT INTO `tiporesultado` VALUES ('T', 'Titulo');
INSERT INTO `tiporesultado` VALUES ('L', 'Leyenda');
INSERT INTO `tiporesultado` VALUES ('C', 'Caracter');
INSERT INTO `tiporesultado` VALUES ('O', 'Observacion');
INSERT INTO `tiporesultado` VALUES ('N', 'Numerico');
INSERT INTO `tiporesultado` VALUES ('F', 'Formula');
INSERT INTO `tiporesultado` VALUES ('S', 'Sigue normal');
INSERT INTO `tiporesultado` VALUES ('P', 'Pasar Pagina');
INSERT INTO `tipotarjeta` VALUES ('1', 'VISA', '2');
INSERT INTO `tipotarjeta` VALUES ('2', 'MC', '2');
INSERT INTO `tipotarjeta` VALUES ('3', 'AMEX', '2');
INSERT INTO `tipotarjeta` VALUES ('4', 'CLAVE', '2');
INSERT INTO `tipotarjeta` VALUES ('5', 'DINERS ', '2');
INSERT INTO `tipotubo` VALUES ('1', 'Sangre Morado', 'Vitros ECi');
INSERT INTO `tipotubo` VALUES ('2', 'Sangre Rojo', 'Manual');
INSERT INTO `tipotubo` VALUES ('3', 'Orina', 'Manual');
INSERT INTO `tubosxexamen` VALUES ('1', '007', '1');
INSERT INTO `tubosxexamen` VALUES ('2', '007', '2');
INSERT INTO `userlevelpermissions` VALUES ('2', 'tubosxexamen', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'tipotubo', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'tipotarjeta', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'tipopago', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'sexos', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'cajahist', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'pagos', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'resultados', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'examenes', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'saludos', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'idiomas', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'departamentos', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'caja', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'cias', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'doctores', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'metaexas', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'defaults', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'direxame', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'citas', '15');
INSERT INTO `userlevelpermissions` VALUES ('2', 'datosexa', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'pacientes', '8');
INSERT INTO `userlevelpermissions` VALUES ('1', 'pacientes', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'datosexa', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'citas', '15');
INSERT INTO `userlevelpermissions` VALUES ('1', 'direxame', '8');
INSERT INTO `userlevelpermissions` VALUES ('1', 'defaults', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'metaexas', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'doctores', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'cias', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'caja', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'departamentos', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'idiomas', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'saludos', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'examenes', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'resultados', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'pagos', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'cajahist', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'sexos', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'tipopago', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'tipotarjeta', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'tipotubo', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'tubosxexamen', '9');
INSERT INTO `userlevelpermissions` VALUES ('1', 'usuarios', '8');
INSERT INTO `userlevelpermissions` VALUES ('1', 'cajaview1', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'cajaview2', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'ciasview', '15');
INSERT INTO `userlevelpermissions` VALUES ('1', 'comparables', '8');
INSERT INTO `userlevelpermissions` VALUES ('1', 'entregamedico', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'estadocuenta', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'examenescia', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'examenesmed', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'ordenes', '13');
INSERT INTO `userlevelpermissions` VALUES ('1', 'ordenesmed', '6');
INSERT INTO `userlevelpermissions` VALUES ('1', 'userlevelpermissions', '-1');
INSERT INTO `userlevelpermissions` VALUES ('1', 'userlevels', '-1');
INSERT INTO `userlevelpermissions` VALUES ('2', 'usuarios', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'cajaview1', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'comparables', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'entregamedico', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'estadocuenta', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'examenescia', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'examenesmed', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'ordenes', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'mensajes', '15');
INSERT INTO `userlevelpermissions` VALUES ('1', 'mensajes', '15');
INSERT INTO `userlevelpermissions` VALUES ('1', 'presupuestos', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'pacientes', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'datosexa', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'citas', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'mensajes', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'presupuestos', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'direxame', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'defaults', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'metaexas', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'doctores', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'cias', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'caja', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'departamentos', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'idiomas', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'saludos', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'examenes', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'resultados', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'pagos', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'cajahist', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'sexos', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'tipopago', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'tipotarjeta', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'tipotubo', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'tubosxexamen', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'usuarios', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'cajaview1', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'comparables', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'entregamedico', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'estadocuenta', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'examenescia', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'examenesmed', '15');
INSERT INTO `userlevelpermissions` VALUES ('3', 'ordenes', '15');
INSERT INTO `userlevelpermissions` VALUES ('4', 'pacientes', '8');
INSERT INTO `userlevelpermissions` VALUES ('4', 'datosexa', '8');
INSERT INTO `userlevelpermissions` VALUES ('4', 'citas', '13');
INSERT INTO `userlevelpermissions` VALUES ('4', 'mensajes', '5');
INSERT INTO `userlevelpermissions` VALUES ('4', 'presupuestos', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'direxame', '13');
INSERT INTO `userlevelpermissions` VALUES ('4', 'defaults', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'metaexas', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'doctores', '8');
INSERT INTO `userlevelpermissions` VALUES ('4', 'cias', '8');
INSERT INTO `userlevelpermissions` VALUES ('4', 'caja', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'departamentos', '8');
INSERT INTO `userlevelpermissions` VALUES ('4', 'idiomas', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'saludos', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'examenes', '8');
INSERT INTO `userlevelpermissions` VALUES ('4', 'resultados', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'pagos', '8');
INSERT INTO `userlevelpermissions` VALUES ('4', 'cajahist', '8');
INSERT INTO `userlevelpermissions` VALUES ('4', 'sexos', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'tipopago', '13');
INSERT INTO `userlevelpermissions` VALUES ('4', 'tipotarjeta', '13');
INSERT INTO `userlevelpermissions` VALUES ('4', 'tipotubo', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'tubosxexamen', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'usuarios', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'cajaview1', '8');
INSERT INTO `userlevelpermissions` VALUES ('4', 'comparables', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'entregamedico', '0');
INSERT INTO `userlevelpermissions` VALUES ('4', 'estadocuenta', '11');
INSERT INTO `userlevelpermissions` VALUES ('4', 'examenescia', '8');
INSERT INTO `userlevelpermissions` VALUES ('4', 'examenesmed', '8');
INSERT INTO `userlevelpermissions` VALUES ('4', 'ordenes', '8');
INSERT INTO `userlevelpermissions` VALUES ('1', 'tiporesultado', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'presupuestos', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'tiporesultado', '0');
INSERT INTO `userlevelpermissions` VALUES ('2', 'cajaview2', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'userdecias', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'ordenescia', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'userdedrs', '0');
INSERT INTO `userlevelpermissions` VALUES ('1', 'presupuestohead', '15');
INSERT INTO `userlevels` VALUES ('-1', 'Administrator');
INSERT INTO `userlevels` VALUES ('0', 'Anonymous');
INSERT INTO `userlevels` VALUES ('1', 'Secretaria');
INSERT INTO `userlevels` VALUES ('2', 'Telefonista');
INSERT INTO `userlevels` VALUES ('3', 'Supervisor');
INSERT INTO `userlevels` VALUES ('4', 'Contabilidad');
INSERT INTO `usuarios` VALUES ('1', 'frosich', 'catala', 'FRANK', 'ROSICH', 'RAMOS', '1', '0');
INSERT INTO `usuarios` VALUES ('2', 'secre', 'secre', 'Secretaria', 'Secretaria', 'Secretaria', '1', '0');
INSERT INTO `usuarios` VALUES ('3', 'rodolfo', 'edrodfer', 'Rodolfo', 'Fernandez', null, '3', '1');
INSERT INTO `usuarios` VALUES ('4', 'edgar', 'edrodfer', 'Edgar', 'Fernandez', null, '3', '1');
INSERT INTO `usuarios` VALUES ('5', 'telefonista', 'telefonista', 'Telefonista', null, null, '2', '0');
INSERT INTO `usuarios` VALUES ('6', 'secre2', 'secre2', 'Secre2', null, null, '1', '0');
INSERT INTO `usuarios` VALUES ('7', 'contabilidad', 'contabilidad', 'Contabilidad', null, null, '4', '0');
INSERT INTO `usuarios` VALUES ('8', 'admin', 'admin', 'Administrador', null, null, '-1', '0');
